var apiEnvironment = "RELEASE";

var apiHost; //API服务器地址
var h5Host = "https://h5.lsmart.wang"; //H5服务器地址
var imgResizeParam = "?x-oss-process=image/resize,m_fill,h_120,w_120";
var uploadHost; //图片上传服务器地址
var logSwitch = true; // 日志开关，true 打印日志，false 不打印
var nowVersion = 160; //当前与服务端定义的版本号

mui.plusReady(function(){
	initHost();
	//监听域名变化
	window.addEventListener("onDomainUrlChanged", function(){
		initHost();
	});
	var opener = plus.webview.currentWebview().opener();
	if(!opener) return;
	//触发扫一扫关闭事件
	mui.fire(opener, "onScanCloseListener", {});
	//添加统计
	statisticEvent("pageLoadTime", {"pageUrl" : location.href.substring(location.href.indexOf("ui/") + 3) + "?from=" + opener.id});
	if(!plus.webview.currentWebview().isCloseOpener || !opener.id) return;
	closeWebview(opener.id);
});

function initHost(){
	if(apiEnvironment != 'RELEASE'){
		var cacheEnv = getCache(USER_SELECT_API_EVN);
		if(cacheEnv){
			apiEnvironment = cacheEnv;
		}
	}
	switch (apiEnvironment){
		case "SELF":
			apiHost = getCache(USER_SELECT_API_URL); // 自定义环境
			break;
		case "DEV":
			apiHost = "https://lifeapp.lsmart.wang"; // 开发环境
			break;
		case "TEST":
			apiHost = "https://lifeapp.lsmart.wang"; //测试环境
			break;
		case "STABLE":
			apiHost = "https://lifeapp.lsmart.wang"; //稳定测试环境
			break;
		case "PRE":
			apiHost = "https://lifeapppre.lsmart.wang"; //预发布环境
			break;
		case "GRAY":
			apiHost = "https://lifeappgray.xiaofubao.com"; //灰度布环境
			h5Host = "https://h5gray.xiaofubao.com";
			break;
		case "RELEASE":
			logSwitch = false; // 日志开关，true 打印日志，false 不打印
		case "PRO":
			apiHost = "https://lifeapp.xiaofubao.com"; //正式环境 https
			h5Host = "https://h5.xiaofubao.com";
			apiHost = getExchangeDomainUrl(apiHost);
			break;
		default:
			break;
	}
	uploadHost = apiHost;
}

/**
 * 接口公共访问方法
 * @param {Object} urlPath 访问路径
 * @param {Object} params 访问参数（json格式）
 * @param {Object} requestCode 访问码，返回处理使用
 * @param {Object} onSuccess 成功回调
 * @param {Object} onErrorBefore 失败回调
 * @param {Object} requestType 请求类型（默认POST，也支持GET）
 * @param {Object} retry 访问失败重新请求次数（默认1次）
 */
var requestCount = {};
var requestParams = {};
function webCall2(urlPath, params, requestCode, onSuccess, onErrorBefore, requestType, retry, reqIntervalTime, extParams, isMustLogin) {
	//防止重复提交，相同请求间隔时间不能小于500毫秒
	if(!reqIntervalTime) reqIntervalTime = 500;
	var nowTime = new Date().getTime();
	
	var params = arguments[1] ? arguments[1] : {};
	if(requestCount[urlPath] && requestParams[urlPath] && requestParams[urlPath] == JSON.stringify(params) && (nowTime - requestCount[urlPath]) < reqIntervalTime) {
		closeWaiting();
		return;
	}
	requestCount[urlPath] = nowTime;
	requestParams[urlPath] = JSON.stringify(params);
	
	var requestCode = arguments[2] ? arguments[2] : 1;
	var onSuccess = arguments[3] ? arguments[3] : function() {};
	var onErrorBefore = arguments[4] ? arguments[4] : onError;
	var requestType = arguments[5] ? arguments[5] : "post";
	var retry = arguments[6] ? arguments[6] : 2;

	params.id = getCache(USER_ID_KEY);
	params.ymId = getCache(USER_ID_KEY);
	params.token = getCache(USER_TOKEN_KEY);
	//判断为必须登录接口，如果用户id或token为空，则直接返回
	if(isMustLogin && (!params.ymId || !params.token)){
		return;
	}
	params.deviceId = getLocalDeviceId();
	//营销接口 加上定位经纬度
	if(urlPath && urlPath.indexOf("/lifeapp/advertising/getAdvertisingMap") == 0){
		var locationObj = getCache(LOCATION_POSITION_KEY);
		if(locationObj && locationObj.coords){
			params.position = locationObj.coords.longitude + "," + locationObj.coords.latitude;
		}
	}
	var testAccount = getCache(USER_TEST_ACCOUNT);
	params.testAccount = testAccount === "0" ? "0" : "1"; //是否测试账号（0是1否）
	params.appVersion = nowVersion;
	params.platform = "LIFE_DELIVERY";
	params.specialLine = null; //专线暂时不用
	//过滤params中为null或undefine的参数
	for(var key in params){
		var value = params[key];
		if(value == null || value == undefined || value === '' || commonTrim(value) === '' || value == 'null' || value == 'undefined'){
			delete params[key];
		}
	}
	
	var _params = params;
	//判断是否验证重复提交
	if(urlPath == '/common/token/get') {
		_params = {
			deviceId: params.deviceId,
			appVersion: params.appVersion,
			platform: "LIFE_DELIVERY"
		};
	}
	//安全验证
	if(urlPath == '/common/security/token') {
		_params = {
			deviceId: params.deviceId,
			appVersion: params.appVersion,
			platform: params.platform,
			sceneCode: params.sceneCode
		};
	}
	var _apiHost = apiHost;
	if(apiEnvironment === 'RELEASE' && urlPath === '/getDomainList'){
		_apiHost = "https://lifeapp.xiaofubao.com";
	}
	//调用网络
	mui.ajax(_apiHost + urlPath, {
		data: _params,
		crossDomain: true,
		dataType: 'json',
		type: requestType,
		timeout: 15000,
		headers: {
			"X-Requested-With": ""
		},
		success: function(data) {
 			 outputLog("网络访问成功, 路径:" + _apiHost + urlPath + ", 参数:" + JSON.stringify(_params) + ", 返回结果: " + JSON.stringify(data));
			if(!data) {
				onErrorBefore(0, "请求失败 , 请重试", requestCode);
			}
			if(data.statusCode == 0) { //访问成功
				if(urlPath == '/common/token/get') { //重复提交token返回
					params.submitToken = data.data;
					webCall2(extParams.urlPath, params, requestCode, onSuccess, onErrorBefore);
				} else if(urlPath == '/common/security/token') {
					//获取本地安全码
					if(plus.os.name == 'iOS'){
						data.data.appSecurityToken = plus.ios.invoke("NativeJsTool", "getAppToken:", data.data.securityToken);
					}else{
						var NativeYischool = plus.android.importClass("com.app.yunma.cpp.NativeYischool");
						data.data.appSecurityToken = NativeYischool.getInstance().getAppToken(data.data.securityToken, plus.android.runtimeMainActivity());
					}
					if(data.data.level !== 0){
						onErrorBefore('code', data.message, requestCode, data);
						return;
					}
					params.securityToken = data.data.securityToken;
					params.appSecurityToken = data.data.appSecurityToken;
					webCall2(extParams.urlPath, params, requestCode, onSuccess, onErrorBefore);
				} else {
					//营销广告统计
					if(urlPath == '/lifeapp/advertising/getAdvertisingMap' && data.data){
						data.data = showBannerDataUpload(data.data);
					}
					onSuccess(data, requestCode);
				}
			} else if(data.statusCode == 205){ //设备更换
				onErrorBefore(data.statusCode, data.message, requestCode, data);
			} else if(data.statusCode == 213){ //未设置密码
				closeWaiting();
				openWindow("settingPwd", location.href.substring(0, location.href.indexOf("/ui/")) + "/ui/setting/setting_pwd.html", false, {}, null, true);
			} else if(data.statusCode == 204) { //登录失效
				if(getCache(IS_SHOW_UNLOGIN_KEY)) return; //如果已经执行过该流程，则直接返回
				closeWaiting();
				setCache(IS_SHOW_UNLOGIN_KEY, "true");
				var nowUrl = location.href;
				var loginUrl = nowUrl.substring(0, nowUrl.indexOf("/ui/")) + "/ui/login/login_by_code.html";
				//跳转到登录页
				openWindow("loginByCode", loginUrl, false, {isLoginOut:2}, null, true);
			} else if(data.statusCode == 300 || data.bizCode == 300) { //系统维护时间或Alert提示
				closeWaiting();
				plus.nativeUI.alert(data.message, function(){
					var nowPageId = plus.webview.currentWebview().id;
					if(nowPageId != "main"){
						mui.back();
					}
				}, "", "确定");
			} else if(data.statusCode == 215) { //版本过低
				closeWaiting();
				confirmDialog(null, "APP版本过低，请下载最新版本", "取消", "立即更新", null, function(){
					plus.runtime.openURL("https://h5.xiaofubao.com/dms");
				});
			} else {
				onErrorBefore(0, data.message, requestCode, data);
			}
		},
		error: function(xhr, type, errorThrown) {
			retry--;
			outputLog("status: " + xhr.status + ", type: " + type + ", 网络访问失败: " + _apiHost + urlPath + ", 参数:" + JSON.stringify(params));
			if(retry > 1 || (type == "abort" && retry > 0)) return webCall2(urlPath, params, requestCode, onSuccess, onErrorBefore, requestType, retry);
			if(plus.networkinfo.getCurrentType() <= 1) {
				onErrorBefore('FAILED_NETWORK', '', requestCode);
			} else if(type == "abort" || type == "timeout" || type == "error" || type == "parsererror") {
				onErrorBefore(0, "服务连接超时，请重试", requestCode);
				//测试连接
				testAllDomainUrl();
			} else if(xhr.response) {
				var response;
				try {
					response = JSON.parse(xhr.response);
				} catch(e) {
					outputLog(e);
				}
				if(response && response.message) {
					onErrorBefore(0, response.message, requestCode);
				} else {
					onErrorBefore('FAILED_NETWORK', '', requestCode);
				}
			} else {
				onErrorBefore('BAND_REQUEST', '请求访问失败，请重试', requestCode);
			}
		}
	});
}

/**
 * 网络访问错误
 * @param {Object} errcode
 */
var onError = function(resultCode, resultMsgDesc, requestCode) {
	switch(resultCode) {
		case 'FAILED_NETWORK':
			toast('网络状态不佳，请查检您的网络');
			break;
		case 'BAND_REQUEST':
			toast('请求访问失败，请重试');
			break;
		case 0:
			toast(resultMsgDesc);
			break;
		default:
			break;
	}
}

/**
 * 打开新页面
 * @param {Object} id 页面标识
 * @param {Object} url 页面路径
 * @param {Object} waiting 是否显示加载框
 * @param {Object} params json参数
 */
var openWindowCount = {};
function openWindow(id, url, waiting, params, aniShow, createNew) {
	//防止重复提交，相同请求间隔时间不能小于1000毫秒
	var nowTime = new Date().getTime();
	if(openWindowCount[id] && (nowTime - openWindowCount[id]) < 1000) {
		return;
	}
	if(params == null) params = {};
	params.loadUrl = url;
	openWindowCount[id] = nowTime;
	mui.openWindow({
		id: id,
		url: url,
		show: {
			aniShow: aniShow || 'slide-in-right'
		},
		waiting: {
			autoShow: waiting
		},
		createNew: createNew,
		extras: params,
		styles: {"contentAdjust":false}
	});
}
/*
* 判断是否以指定字符串结尾
*/
function isEndSpecifiedStr(str, endStr) {
	if(!str || !endStr){
		return true;
	}
	var d = str.length - endStr.length;
	return(d >= 0 && str.lastIndexOf(endStr) == d);
}
/**
 * 关闭界面 当账号被登出时
 * @param {Object}
 */
function closeWebviewWhenLoginOut() {
	//获取所有webView
	var wvs=plus.webview.all();
	for(var i = 0; i < wvs.length; i++) {
		//不关闭start login 两个页面
		if(!wvs[i].getURL() || wvs[i].getURL() == null || isEndSpecifiedStr(wvs[i].getURL(), "start.html") || isEndSpecifiedStr(wvs[i].getURL(), "login_by_code.html") || isEndSpecifiedStr(wvs[i].getURL(), "login.html")) {
			continue;
		}
		wvs[i].hide();
	}
	setTimeout(function(){
		for(var i = 0; i < wvs.length; i++) {
			//不关闭start login 两个页面
			if(!wvs[i].getURL() || wvs[i].getURL() == null || isEndSpecifiedStr(wvs[i].getURL(), "start.html") || isEndSpecifiedStr(wvs[i].getURL(), "login_by_code.html") || isEndSpecifiedStr(wvs[i].getURL(), "login.html")) {
				continue;
			}
			wvs[i].close();
		}
	}, 500);
}
/**
 * 关闭界面（手动关闭界面前必须用这个方法关闭，否则在Android很多机型上出现被关闭的界面一闪而过的情况）
 * @param {Object} id 界面id
 */
function closeWebview(id, isCloseLater) {
	if(id == "main") {
		var subpages = ['home/home_main.html', 'shop/shop_main.html', 'center/center_main.html'];
		for(var i = 0; i < subpages.length; i++) {
			var subpage = plus.webview.getWebviewById(subpages[i]);
			if(subpage != null) {
				subpage.hide();
			}
		}
		setTimeout(function() {
			for(var i = 0; i < subpages.length; i++) {
				var subpage = plus.webview.getWebviewById(subpages[i]);
				if(subpage != null) {
					subpage.close();
				}
			}
		}, 500);
	}
	var webview = plus.webview.getWebviewById(id);
	if(webview != null) {
		if(plus.os.name == "Android"){
			webview.hide();
		}
		onCommonPageCloseResult(id);
		setTimeout(function() {
			webview.close();
		}, isCloseLater ? 1500 : 500);
	}
}

/**
 * 获取本地设备ID
 * 0. 从缓存中获取
 * 1. iOS取uuid，Android取oaid
 * 2. 取个推clientid
 * 3. 自己生成
 */
function getLocalDeviceId(){
	//0. 从缓存中获取
	var deviceId = getCache(LOCAL_DEVICE_ID);
	if(deviceId && deviceId != 'null' && deviceId != 'undefined') return deviceId;
	deviceId = setLocalDeviceId(); //本地自动生成
	return deviceId;
}

/**
 * 设置本地设备ID
 * 0. 从缓存中获取
 * 1. 取uuid
 * 2. 取个推clientid
 * 3. 自己生成
 */
function setLocalDeviceId(){
	//0. 从缓存中获取
	var deviceId = getCache(LOCAL_DEVICE_ID);
	if(deviceId && deviceId != 'null' && deviceId != 'undefined') return deviceId;
	deviceId = plus.device.uuid;
	if(!deviceId || deviceId == 'null' || deviceId == 'undefined'){
		deviceId = getCache(DEVICE_OAID_KEY);
	}
	if(deviceId == '00000000-0000-0000-0000-000000000000' || deviceId == '00000000000000000000000000000000'){
		deviceId = null;
	}
	if(!deviceId || deviceId == 'null' || deviceId == 'undefined'){
		deviceId = getClientId();
	}
	if(!deviceId || deviceId == 'null' || deviceId == 'undefined'){
		deviceId = getUuid();
	}
	if(deviceId && deviceId.length > 80){
		deviceId = deviceId.substring(0, 80);
	}
	setCache(LOCAL_DEVICE_ID, deviceId);
	return deviceId;
}

/**
 * 设置UserAgent
 */
function setLocalUserAgent(){
	try{
		var userAgent = navigator.userAgent;
		if(userAgent.indexOf("/yunmaapp.NET/") < 0){
			userAgent = userAgent + " " + (plus.os.name == "iOS" ? (" (Immersed/" + plus.navigator.getStatusbarHeight() + ") WKWebview " + "ZJYXYwebviewbroswer ZJYXYIphone tourCustomer") : "ZJYXYwebviewbroswer ZJYXYAndroid tourCustomer") + 
				" /yunmaapp.NET/liferider.NET/" + plus.runtime.version + "/" + getLocalDeviceId();
			plus.navigator.setUserAgent(userAgent);
		}
		console.log("userAgent: " + userAgent);
	}catch(e){
	}
}

/**
 * 生成uuid
 */
function getUuid() {
	var s = [];
	var hexDigits = "0123456789abcdef";
	for(var i = 0; i < 36; i++) {
		s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}
	s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
	s[8] = s[13] = s[18] = s[23] = "-";

	uuid = "yunma" + s.join("");
	return uuid;
}

/**封装加载等待框的显示和关闭*/
var waitingCount = 0;
/**
 * 显示等待框
 * @param {Object} interfaceNum 接口数
 */
function showWaiting(interfaceNum) {
	if (navigator.userAgent.indexOf("Html5Plus") < 0) return; // 浏览器模式
	if(waitingCount < 0) waitingCount = 0;
	if(interfaceNum && interfaceNum > 1) {
		waitingCount += interfaceNum;
	} else {
		waitingCount++;
	}
	plus.nativeUI.closeWaiting();
	plus.nativeUI.showWaiting('');
}

/**
 * 关闭等待框(当返回接口数减为0后关闭)
 */
function closeWaiting() {
	if (navigator.userAgent.indexOf("Html5Plus") < 0) return; // 浏览器模式
	waitingCount--;
	if(waitingCount <= 0) {
		waitingCount = 0;
		plus.nativeUI.closeWaiting();
	}
}

/**
 * 设置状态栏背景为蓝底白字
 */
function setStatusBarDefault() {
	// 设置状态栏背景颜色
	if (plus.os.name == "iOS") {
		plus.navigator.setStatusBarBackground("#f2f2f2");
		plus.navigator.setStatusBarStyle("UIStatusBarStyleDefault");
	} else {
		plus.navigator.setStatusBarBackground("#f2f2f2");
		plus.navigator.setStatusBarStyle("dark");
	}
}

/**
 * 设置状态栏 渐变色 首页等界面
 */
function setStatusBarMain() {
	if (plus.os.name == "iOS") {
		// 设置状态栏背景颜色
		plus.navigator.setStatusBarBackground("#FF5959");
		plus.navigator.setStatusBarStyle("UIStatusBarStyleBlackOpaque");
	} else {
		plus.navigator.setStatusBarBackground("#FF5959");
		plus.navigator.setStatusBarStyle("light");
	}
}


/**
 * 设置状态栏背景为黑色、字体为白色
 */
function setStatusBarBlack() {
	if (plus.os.name == "iOS") {
		// 设置状态栏背景颜色
		plus.navigator.setStatusBarBackground("#000000");
		plus.navigator.setStatusBarStyle("UIStatusBarStyleBlackOpaque");
	} else {
		plus.navigator.setStatusBarBackground("#000000");
		plus.navigator.setStatusBarStyle("light");
	}
}

/**
 * 返回时 设置上个界面状态栏颜色
 * @param {Object} sourceStatusBarType default black main
 */
function setUpViewStatusBar(sourceStatusBarType) {
	//返回，把等待框关掉
	closeWaiting();
	if(sourceStatusBarType == STATUS_BAR_MAIN_KEY) {
		setStatusBarMain();
	}else if(sourceStatusBarType == STATUS_BAR_BLACK_KEY){
		setStatusBarBlack();
	}else{
		setStatusBarDefault();
	}
}

/**
 * 获取当前的状态栏类型
 */
function getCurrentStatusBarType(){
	var sBarBg = plus.navigator.getStatusBarBackground();
    if(sBarBg == '#ff5959' || sBarBg == '#FF5959') return STATUS_BAR_MAIN_KEY;
	else if(sBarBg == '#ffffff' || sBarBg == '#FFFFFF') return STATUS_BAR_DEFAULT_KEY;
	else return STATUS_BAR_DEFAULT_KEY;
}

function fullscreen() {
	plus.navigator.setFullscreen(true);
}

function unfullscreen() {
	plus.navigator.setFullscreen(false);
}

//是否是字符串类型. eg: isString(requestCode)
function isString(str) {
	return(typeof str == 'string') && (str.constructor == String);
}

/*
 * 获取clientId 
 */
function getClientId(){
	var clientId = getCache(CLIENT_ID_NEW_KEY);
	if(clientId && clientId.length > 0 && clientId == encodeURIComponent(clientId)){
		return clientId;
	}
	removeCache(CLIENT_ID_NEW_KEY);
	var clientInfo = plus.push.getClientInfo();
	clientId = clientInfo ? clientInfo.clientid : "";
	if(clientId != null &&  clientId != "" && clientId != "null" && clientId == encodeURIComponent(clientId)){
		setCache(CLIENT_ID_NEW_KEY, clientId);
		return clientId;
	} else {
		return "";
	}
}

var setClientIdInterval;
var setClientIdNum = 0;
/*
 * 存储clientId 
 */
function setClientId() {
	if(getCache(CLIENT_ID_NEW_KEY) != null && getCache(CLIENT_ID_NEW_KEY).length > 0){
		return;
	}
	var clientInfo = plus.push.getClientInfo();
	var clientId = clientInfo ? clientInfo.clientid : "";
	if(clientId != null && clientId != "" && clientId != "null" && clientId == encodeURIComponent(clientId)) {
		setCache(CLIENT_ID_NEW_KEY, clientId);
		return;
	}
	setClientIdInterval = setInterval(function() {
		setClientIdNum++;
		clientInfo = plus.push.getClientInfo();
		clientId = clientInfo ? clientInfo.clientid : "";
		if(clientId != null && clientId != "" && clientId != "null" && clientId == encodeURIComponent(clientId)) {
			setCache(CLIENT_ID_NEW_KEY, clientId);
			clearInterval(setClientIdInterval);
			return;
		}
		if(setClientIdNum > 10) clearInterval(setClientIdInterval);
	}, 3000);
}

/**
 * 添加右滑返回事件
 */
function drawCloseCurWeb(webview, color, style){
	if(plus.os.name == "iOS") {
		webview.drag({callbackStep:'35',direction:'right',moveMode:'followFinger'}, {view:"webview",moveMode:'follow'}, function(e){
			if(e.type == "end" && e.result == true){
				setUpViewStatusBar(color, style);	
				webview.close();
			}
		});
	}
}

/**
 * 打印日志
 * @param {Object} logInfo: 要输出的日志内容
 */
function outputLog(logInfo, isError){
	if(!logInfo) return;
	if(isError){
		console.error(logInfo);
	}else{
		console.log(logInfo);
	}
	if(navigator.userAgent.indexOf("Html5Plus") >= 0 && plus.os.name == 'iOS'){
         plus.ios.invoke("NativeJsTool", "log:", logInfo);
    }
}

/**
 * 弹框居中显示
 */
function toast(message){
	if(!window.plus || message == null || message == undefined || message == 'null' || message == 'undefined'){
		return;
	}
	plus.nativeUI.toast(message, {verticalAlign:"center"});
}

/**
 * 判断是否登录
 */
function isLogin() {
	var account = getCache(ACCOUNT_KEY);
	var userToken = getCache(USER_TOKEN_KEY);
	if(account != null && userToken != null && account.length > 0 && userToken.length > 0) {
		return true;
	}
	return false;
}

/**
 * 获取用户信息
 */
function getUserInfo(){
	var userInfoStr = getCache(USER_INFO_KEY);
	if(userInfoStr){
		return JSON.parse(userInfoStr);
	}
	return {};
}

/**
  * 更新用户登录信息
  * @param {Object} phone
  * @param {Object} userInfo
  */
function updateLoginInfo(phone, userInfo){
	removeCache(IS_SHOW_UNLOGIN_KEY);
	
	setCache(IS_LOGIN_KEY, "true");
	if(phone) setCache(ACCOUNT_KEY, phone);
	if(userInfo.qrcodePrivateKey) setCache(QRCODE_PRIVATE_KEY, userInfo.qrcodePrivateKey);
	setCache(USER_INFO_KEY, JSON.stringify(userInfo));
	setCache(USER_TOKEN_KEY, userInfo.token);
	if(userInfo.uuToken) setCache(UU_TOKEN_KEY, userInfo.uuToken);
	setCache(USER_ID_KEY, userInfo.id);//用户id
	setCache(REAL_NAME_KEY, userInfo.userName);//姓名
	setCache(NICK_NAME_KEY, userInfo.nickName);//昵称
	setCache(IMAGE_URL_KEY, userInfo.headImg);// 头像
	setCache(USER_PHONE_KEY, userInfo.mobilePhone);// 手机
	setCache(USER_TEST_ACCOUNT, userInfo.testAccount);
	setCache(WALLET_ACCOUNT_ID, userInfo.stlAccountId);//用户钱包id
	//处理账号
	mui.fire(plus.webview.getLaunchWebview(), "onUserAccountUpdate", {});
}
/**
 * 用户点击退出登录时，清除登录信息
 */
function clearLoginInfo(){
	setCache(IS_LOGIN_KEY, "false");
	removeCache(USER_INFO_KEY);
	removeCache(USER_TOKEN_KEY);
	removeCache(QRCODE_PRIVATE_KEY);
	removeCache(UU_TOKEN_KEY);
	removeCache(USER_ID_KEY);
	removeCache(REAL_NAME_KEY);
	removeCache(NICK_NAME_KEY);
	removeCache(IMAGE_URL_KEY);
	removeCache(USER_PHONE_KEY);
	removeCache(USER_TEST_ACCOUNT);
	removeCache(WALLET_ACCOUNT_ID);
	removeCache(WALLET_STATUS_INFO);
}

/**
 * 清除微信授权登录
 */
function clearWxLogin() {
	plus.oauth.getServices(function(services) {
		var auths = services;
		outputLog(JSON.stringify(auths));
		for ( var i in auths ) {
			var s = auths[i];
			outputLog(JSON.stringify(s));
			s.logout(function(e){
				outputLog( "注销登录认证成功！" );
			}, function(e){
				outputLog( "注销登录认证失败！" + JSON.stringify(e) );
			});
		}
	}, function(e) {
		outputLog("获取分享服务列表失败：" + e.message + " - " + e.code);
	});
}

/**
 * 缓存未读消息数
 */
function setUnReadCount(count){
	setCache(USER_UN_READ_MSG_COUNT + getCache(USER_ID_KEY), count);
}

/**
 * 获取未读消息数
 */
function getUnReadCount(){
	var count = getCache(USER_UN_READ_MSG_COUNT + getCache(USER_ID_KEY));
	if(!count || parseInt(count) < 0){
		count = 0;
	}
	return count;
}

/**
 * 添加到粘贴版
 * @param {Object} linkUrl
 */
function copyLink(linkUrl, hideToast) {
	if(plus.os.name == 'Android') {
		var Context = plus.android.importClass("android.content.Context");
		var main = plus.android.runtimeMainActivity();
		var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
		plus.android.invoke(clip, "setText", linkUrl);
		if(linkUrl && !hideToast) toast("已复制到剪贴板");
	} else if(plus.os.name == 'iOS') {
		var UIPasteboard = plus.ios.importClass("UIPasteboard");
		var generalPasteboard = UIPasteboard.generalPasteboard();
		generalPasteboard.setValueforPasteboardType(linkUrl, "public.utf8-plain-text");
		if(linkUrl && !hideToast) toast("已复制到剪贴板");
	} else {
		toast("不支持的系统类型");
	}
}

/**
 * 获取粘贴版内容
 */
function getPasteContent() {
	if(plus.os.name == 'Android') {
		var Context = plus.android.importClass("android.content.Context");
		var main = plus.android.runtimeMainActivity();
		var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
		var content = plus.android.invoke(clip, "getText");
		return content?content.toString():content;
	} else if(plus.os.name == 'iOS') {
		var UIPasteboard  = plus.ios.importClass("UIPasteboard");  
		var generalPasteboard = UIPasteboard.generalPasteboard();  
		// 获取文本内容:  
		var content = generalPasteboard.valueForPasteboardType("public.utf8-plain-text");    
		return content;
	} else {
		toast("不支持的系统类型");
	}
}

/**========================本地缓存管理   start==========================*/
/*key键名*/
var LAUNCH_FLAG_YUNMA_KEY = "launchFlagYunma"; //应用第一次启动标识
var IS_SHOW_UNLOGIN_KEY = "isShowUnlogin"; //显示未登录
var ACCOUNT_KEY = "account"; //用户账号key
var USER_PHONE_KEY = "userPhone"; //用户账号key
var QRCODE_PRIVATE_KEY = "qrcodePrivateKey"; //手机号私钥
var USER_TOKEN_KEY = "userToken"; //登录token
var UU_TOKEN_KEY = "uuToken"; //用户token
var LOCAL_DEVICE_ID = "localDeviceIdNew"; //用户token
var IS_LOGIN_KEY = "isLogin"; //登录标识key
var USER_INFO_KEY = "userInfo"; //用户信息key
var USER_ID_KEY = "userId"; //用户ID key
var REAL_NAME_KEY = "realName"; //用户真实姓名key
var NICK_NAME_KEY = "nickName"; //用户昵称key
var IMAGE_URL_KEY = "imageUrl"; //用户头像地址key
var CLIENT_ID_NEW_KEY = "clientIdNew"; //clientId key
var LOCATION_POSITION_KEY = "localPosition"; //用户定位信息
var USER_TEST_ACCOUNT = "testAccount"; //是否测试账号（0是1否）
var WEBVIEW_PAGE_ID = "webview_page_id"; //是否测试账号（0是1否）
var DMS_USER_INFO_KEY = "dmsUserInfo"; //配送用户信息
//状态栏相关
var STATUS_BAR_DEFAULT_KEY = "default"; //默认色调(白)
var STATUS_BAR_MAIN_KEY = "main"; //主色调
var STATUS_BAR_BLACK_KEY = "black"; //黑色调
//消息相关
var USER_UN_READ_MSG_COUNT = "userUnReadMsgCount"; //用户未读消息数
//发布之前用户选择的系统环境
var USER_SELECT_API_EVN = "userSelectApiEnv"; //用户选择的环境
var USER_SELECT_API_URL = "userSelectApiUrl"; //用户选择的环境
//是否有增量新版本更新
var WGT_NEWEST_VERSION_FLAG = "wgtNewestVersinoFlag";
var WGT_VERSION_FLAG = "wgtVersinoFlag";
var WGT_VERSION_FILE_LIST = "wgtVersinoFileList";
//启动页广告
var START_AD_DATA = "startAdData"; //启动页广告数据
var START_AD_IMAGE = "startAdImage"; //启动页广告图片
//首页公告
var HOME_NOTICE_ID = "homeNoticeID"; //首页公告数据
//隐私政策和协议弹框
var LOGIN_PRIVATEP_ROTOCOL = "loginPrivateProtocol";
//心愿首页页面ID
var FUND_WISH_HOME_ID = "fundWishHomeId";
//匿名设备标识符
var DEVICE_OAID_KEY = "deviceOaidKey";
//域名
var YUNMA_DOMAIN_INFO = "yunmaDomainInfo";
var CURRENT_DOMAIN_URL = "currentDomainUrl";
//tab 3个页面是否加载完成
var TAB_WEBVIEW_LOADED = "tabWebviewLoaded";
//钱包相关
var WALLET_STATUS_INFO = "walletStatusInfo";
var WALLET_ACCOUNT_ID = "walletAccountId"; //用户二类账号唯一编码
/**
 * 设置存储值
 * @param {Object} key
 * @param {Object} value
 */
function setCache(key, value){
	if(!window.plus) {
		return;
	}
	if(key == null || key.length <= 0 || value == null || value.length <= 0) return;
	value += "";
	plus.storage.setItem(key, value);
}
/**
 * 获取存储值
 * @param {Object} key
 */
function getCache(key){
	if(!window.plus) {
		return;
	}
	if(key == null || key.length <= 0) return;
	return plus.storage.getItem(key);
}
/**
 * 移除存储值
 * @param {Object} key
 */
function removeCache(key){
	if(!window.plus) {
		return;
	}
	if(key == null || key.length <= 0) return;
	return plus.storage.removeItem(key);
}
/**========================本地缓存管理   end  ==========================*/

//=======对话框===========
/**
 * 确认对话框
 * @param {Object} tipTitle  可以为空
 * @param {Object} tipSubTitle 不能为空
 * @param {Object} leftBtnTitle 左边按钮 title
 * @param {Object} rightBtnTitle  右边按钮 title
 * @param {Object} leftBtnCallback  左边按钮点击回调
 * @param {Object} rightBtnCallback  右边按钮点击回调
 */
function confirmDialog(tipTitle, tipSubTitle, leftBtnTitle, rightBtnTitle, leftBtnCallback, rightBtnCallback){
	//tipSubTitle 不能为空
	if(!tipSubTitle || tipSubTitle.length==0)	return;
	
	var btnArray = [leftBtnTitle, rightBtnTitle];
	if(plus.os.name == "Android") {//iOS和安卓上 按钮的方向是相反的
		btnArray = [rightBtnTitle, leftBtnTitle];
	}
	plus.nativeUI.confirm(tipSubTitle, function(e) {
		if(e.index < 0) return;
		if((e.index == 0 && plus.os.name == "iOS") || (e.index == 1 && plus.os.name == "Android")) { //left
			leftBtnCallback ? leftBtnCallback() : null;
		} else{//right
			rightBtnCallback ? rightBtnCallback() : null;
		}
	}, tipTitle, btnArray);
}

/**
 * 获取带unionid的url
 */
function getUnionUrl(url){
	if(!url) return url;
	url = getExchangeDomainUrl(url);
	
	if(!url || url.indexOf("unionid=") > 0) return url;
	if(url.indexOf("?") > 0){
		return url + "&unionid=" + getCache(USER_ID_KEY);
	}else{
		return url + "?unionid=" + getCache(USER_ID_KEY);
	}
}

/**
 * 获取带unionid的url
 */
function getAuthUnionUrl(url){
	if(!url) return url;
	
	url = commonDelParamByKeyAndUrl(url, "unionid");
	url = commonDelParamByKeyAndUrl(url, "schoolCode");
	
	url = getExchangeDomainUrl(url);
	
	if(url.indexOf("?") > 0){
		return url + "&unionid=" + getCache(USER_ID_KEY);
	}else{
		return url + "?unionid=" + getCache(USER_ID_KEY);
	}
}

/**
 * 删除url中指定参数
 */
function commonDelParamByKeyAndUrl(url, paramKey){
    var urlParam = url.split("?");   //页面参数
    var beforeUrl = urlParam[0];   //页面主地址（参数之前地址）
    var nextUrl = "";

    var arr = new Array();
    if (urlParam.length > 1) {
        var urlParamArr = urlParam[1].split("&"); //将参数按照&符分成数组
        for (var i = 0; i < urlParamArr.length; i++) {
            var paramArr = urlParamArr[i].split("="); //将参数键，值拆开
            //如果键雨要删除的不一致，则加入到参数中
            if (paramArr[0] != paramKey) {
                arr.push(urlParamArr[i]);
            }
        }
    }
    if (arr.length > 0) {
        nextUrl = "?" + arr.join("&");
    }
    return beforeUrl + nextUrl;
}

/**
 * 在链接后面追加参数
 * @param {Object} url
 * @param {Object} params
 */
function appendParamsUrl(url, params){
	if(!params) return url;
	for(var key in params){
		if(url.indexOf("?") > 0){
			url = url + "&" + key +"=" + params[key];
		}else{
			url = url + "?" + key +"=" + params[key];
		}
	}
	return url;
}

/**沉浸式状态栏判断*/
(function(w) {
	var immersed = 0;
	var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
	if(ms && ms.length >= 3) {
		immersed = parseFloat(ms[2]);
	}
	w.immersed = immersed;
	if(!immersed) {
		return;
	}
	var hhh = document.getElementById('header');
	hhh && (hhh.style.height = 44 + immersed + 'px', hhh.style.paddingTop = immersed + 'px');
	mmm = document.getElementById('main');
	if(mmm && mmm.classList.contains("wrapper")){
		hhh && (mmm.style.top = 44 + immersed + 'px');
		!hhh && (mmm.style.top = immersed + 'px');
	}else if(mmm){
		hhh && (mmm.style.paddingTop = 44 + immersed + 'px');
		!hhh && (mmm.style.paddingTop = immersed + 'px');
	}
	mappp = document.getElementById('map');
	mappp && (mappp.style.marginTop = immersed + 'px');
	scanWapper = document.getElementById('scanWapper');
	scanWapper && (scanWapper.style.top = immersed + 280 + 44 + 'px');
	homeTabGroup = document.getElementById('homeTabGroup');
	homeTabGroup && (homeTabGroup.style.top = immersed + 44 + 54 + 'px');
	closeBtnnn = document.getElementById('closeBtn');
	closeBtnnn && (closeBtnnn.style.top = immersed + 'px');
	settingBtnnn = document.getElementById('settingBtn');
	settingBtnnn && (settingBtnnn.style.top = immersed + 'px');
	tabGrouppp = document.getElementById('tabGroup');
	tabGrouppp && (tabGrouppp.style.top = immersed + 44 + 'px');
	searchBtn = document.getElementById('searchBtn');
	searchBtn && (searchBtn.style.top = immersed +'px');
})(window);

/**
 * 获取状态栏高度
 */
function getStatusImmersed(){
	var immersed = 0;
	var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
	if(ms && ms.length >= 3) {
		immersed = parseFloat(ms[2]);
	}
	if(!immersed) {
		return 0;
	}
	return immersed;
}

/*
 *  权限判断
 *  相机: CAMERA,  相册: GALLERY, 通讯录: CONTACTS, 定位:LOCATION 
 */
function checkUserPermission(permissionType, webView, successBack, cancelBack){
	if(!permissionType || permissionType.length <= 0) return false;
	var promptTitle = "";
	var androidPermission = new Array();
	switch(permissionType){
		case 'CAMERA'://相机
			promptTitle= plus.os.name == "Android" ? "您的相机权限未打开，是否去打开相机权限" : "您的相机权限未打开，请在当前应用设置-隐私-相机来开打此权限";
			androidPermission.push("android.permission.CAMERA");
			break;
		case 'GALLERY'://相册
			promptTitle= plus.os.name == "Android" ? "您的存储权限未打开，是否去打开存储权限" : "您的相册权限未打开，请在当前应用设置-隐私-相册来开打此权限";
			androidPermission.push("android.permission.WRITE_EXTERNAL_STORAGE");
			androidPermission.push("android.permission.READ_EXTERNAL_STORAGE");
			break;
		case 'CONTACTS'://通讯录
			promptTitle= plus.os.name == "Android" ? "您的通讯录权限未打开，是否去打开通讯录权限" : "您的通讯录权限未打开，请在当前应用设置-隐私-通讯录来开打此权限";
			androidPermission.push("android.permission.READ_CONTACTS");
			androidPermission.push("android.permission.WRITE_CONTACTS");
			break;
		case 'LOCATION'://定位
			promptTitle= plus.os.name == "Android" ? "您的定位权限未打开，是否去打开定位权限" : "您的定位权限未打开，请在当前应用设置-隐私-位置来开打此权限";
			androidPermission.push("android.permission.ACCESS_FINE_LOCATION");
			androidPermission.push("android.permission.ACCESS_COARSE_LOCATION");
			break;	
		case 'SCREEN'://系统设置
			androidPermission.push("android.permission.WRITE_SETTINGS");
			break;	
		default:
			break;
	}
	//Android授权
	if(plus.os.name == 'Android'){
		try{
			var Utils = plus.android.importClass("com.app.yunma.common.Utils");
			var permissionResult = Utils.checkUserPermission(permissionType, androidPermission[0]);
			if(permissionResult) return true;
			if(permissionType == 'SCREEN' && getCache("showScreen") != 'yes'){ //判断屏幕亮度是否可直接修改
				setCache("showScreen", "yes");
				confirmDialog("", "授权“系统设置”权限后，可自动调节屏幕亮度，提高二维码识别率", "取消", "去授权", null, function() {
					var main = plus.android.runtimeMainActivity();
					var Settings = plus.android.importClass('android.provider.Settings');
					var Uri = plus.android.importClass('android.net.Uri');
					var Intent = plus.android.importClass("android.content.Intent");
					var mIntent = new Intent(Settings.ACTION_MANAGE_WRITE_SETTINGS);
					var uri = Uri.fromParts("package", main.getPackageName(), null);
					mIntent.setData(uri);
					main.startActivity(mIntent);
				});
			}
			if(permissionType == 'SCREEN') return false;
		}catch(e){
			return true;
		}
		plus.android.requestPermissions(androidPermission, function(e){
			if(e.granted.length > 0){ //权限被允许
				successBack ? successBack(): null;
			}else if(e.deniedPresent.length > 0){ //权限被临时拒绝
				cancelBack ? cancelBack(): null;
			}else if(e.deniedAlways.length > 0 && permissionType != 'SCREEN'){ //权限被永久拒绝
				confirmDialog("", promptTitle, "取消", "去打开", function() {
					cancelBack ? cancelBack(): null;
				}, function() {
					var main = plus.android.runtimeMainActivity();
					var Settings = plus.android.importClass('android.provider.Settings');
					var Uri = plus.android.importClass('android.net.Uri');
					var Intent = plus.android.importClass("android.content.Intent");
					var Settings = plus.android.importClass('android.provider.Settings');
					var mIntent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
					var uri = Uri.fromParts("package", main.getPackageName(), null);
					mIntent.setData(uri);
					main.startActivity(mIntent);
				});
			}
		}, function(e){
			outputLog('Request Permissions error:'+JSON.stringify(e));
		});
		return false;
	}
	//iOS授权
	var permission = plus.navigator.checkPermission(permissionType);
	if(permission != "denied"){//已开启权限或者还未提示获取权限
		return true;
	}
	confirmDialog("", promptTitle, "确定", "取消", function sureCallback() {
		plus.ios.invoke("NativeJsTool", "openAlbumReject");
		if(webView) webView.close();
		//iOS 走success方法  只是跳转设置中心 权限并未打开
		cancelBack ? cancelBack(): null;
	}, function cancelCallback(){
		if(webView) webView.close();
		cancelBack ? cancelBack(): null;
	});
	return false;
}
/*
 * 两位小数，不足用0补齐
 */
function toDecimalTwo(x) {
   var f = parseFloat(x);
   if (isNaN(f)) {
      return false;
   }
   var f = Math.round(x*100)/100;
   var s = f.toString();
   var rs = s.indexOf('.');
   if (rs < 0) {
      rs = s.length;
      s += '.';
   }
   while (s.length <= rs + 2) {
      s += '0';
   }
   return s;
}

/*
 * 账号登出, 清空消息
 */
function clearPushMessage(){
	plus.push.clear();
	if(plus.os.name == "Android") return;
	var nativeJsToolClass = plus.ios.importClass("NativeJsTool");
	var nativeJsToolObj = plus.ios.newObject("NativeJsTool");
	plus.ios.invoke(nativeJsToolObj, "resetBadgeNum");
}
/*
 * 只清空角标 不清空消息中心的消息
 */
function clearPushNumberMessage(){
	plus.runtime.setBadgeNumber("0");
	if(plus.os.name == "Android") return;
	var nativeJsToolClass = plus.ios.importClass("NativeJsTool");
	var nativeJsToolObj = plus.ios.newObject("NativeJsTool");
	plus.ios.invoke(nativeJsToolObj, "resetBadgeNum");
}
/**
 * 友盟自定义事件次数统计
 */
function statisticEvent(enentId, extObj){
	if(!window.plus || apiEnvironment != 'RELEASE') return;
	var user = getUserInfo();
	var vObj = {};
	if(extObj){
		mui.extend(vObj, extObj);
	}
	if(user.id){
		vObj.schoolName = user.schoolName ? user.schoolName : '未知';
		vObj.realNameStatus = user.realNameStatus == 1 ? "实名" : "未实名";
		vObj.bindCardStatus = user.bindCardStatus == 1 ? "绑卡" : "未绑卡";
	}
	vObj.mobileType = plus.device.model;
	if(plus.os.name == 'Android'){
		plus.statistic.eventTrig(enentId, JSON.stringify(vObj));
	}else{
		plus.statistic.eventTrig(enentId, vObj);
	}
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersions( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	var b=false;
	var ova = ov.split(".",4);
	var nva = nv.split(".",4);
	for ( var i=0; i<ova.length&&i<nva.length; i++ ) {
		var so=ova[i],no=parseInt(so),sn=nva[i],nn=parseInt(sn);
		if ( nn>no || sn.length>so.length  ) {
			return true;
		} else if ( nn<no ) {
			return false;
		}
	}
	if ( nva.length>ova.length && 0==nv.indexOf(ov) ) {
		return true;
	}
	return false;
}

/**
 * 获取url中指定的参数
 * @param {Object} url
 * @param {Object} name
 */
function comGetUrlParamByName(url, name) {
	if(!url || url.indexOf("?") < 0) return null;
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = url.split("?")[1].match(reg);
	if(r != null) return decodeURIComponent(r[2]);
	return null;
}
/*
 * 根据开户行 设置和获取钱包状态
 */
function setEacctStatus(status, eacctType){
	var eacctStatus = (getUserInfo().eacctStatus ? getUserInfo().eacctStatus : 0).toString();
	if(status == null || status === "" || !eacctType){
		return eacctStatus;
	}
	if(eacctType == 'ICBC'){
		return eacctStatus && eacctStatus.length <= 1 ? status.toString() : (eacctStatus.substr(0, 1) + status.toString());
	}
	if(eacctType == 'EABC'){
		return status.toString() + eacctStatus.substr(eacctStatus.length-1, 1);
	}
}
function getEacctStatus(eacctType){
	if(!eacctType){
		return 0;
	}
	var eacctStatus = (getUserInfo().eacctStatus ? getUserInfo().eacctStatus : 0).toString();
	if(eacctType == 'ICBC'){
		return parseInt(eacctStatus.substr(eacctStatus.length-1, 1));
	}
	if(eacctType == 'EABC'){
		return eacctStatus && eacctStatus.length <= 1 ? 0 : parseInt(eacctStatus.substr(0, 1));
	}
	return 0;
}

/**
 * 打开开户页面
 */
function openAuthPage(statusBarType, authFrom, fromThirdAuth, webPageId, fromWalletThirdAuth, eacctType, isCloseOpener, source) {
	//判断开户状态
	//1未实名 2申请中 3认证成功 4认证失败
	var realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
	statusBarType = statusBarType ? statusBarType : getCurrentStatusBarType();
	if((!eacctType || eacctType.length <= 0) && (realNameStatus == 2 || realNameStatus == 3)){ //
		openWindow("walletMain", "../wallet/wallet_main.html", false, {isCloseOpener:isCloseOpener,statusBarType: statusBarType});
		return;
	}
	var eacctStatus = getEacctStatus(eacctType);
	if(eacctStatus == 1) { //钱包启用
		toast('实名认证已通过!');
		if(!isCloseOpener) return;
		setTimeout(function(){
			closeWebview(plus.webview.currentWebview().id);
		}, 1000);
		return;
	} else if(eacctStatus == 3) { //钱包关闭
		openWindow("bankAddFirst", "../wallet/bank_add_first.html", false, {
			fromThirdAuth: fromThirdAuth,
			fromWalletThirdAuth: fromWalletThirdAuth,
			webPageId: webPageId,
			eacctType: eacctType,
			statusBarType: statusBarType,
			isCloseOpener:isCloseOpener,
		});
		return;
	}
	if(!authFrom) authFrom = "authAPP";
	//如果没有选择学校，则选择学校
	var schoolCode = getCache(SCHOOL_CODE_KEY);
	if(!schoolCode){
		openWindow("selectSchool", "../login/select_school.html", false, {
			statusBarType: statusBarType, 
			from: 'auth', 
			authFrom: authFrom,
			fromThirdAuth: fromThirdAuth,
			webPageId: webPageId,
			eacctType: eacctType?eacctType:'',
			isCloseOpener:isCloseOpener,
		}, null, true);
		return;
	}
	//已选择学校，打开开户页面
	openWindow("authFirst", "../center/auth_first.html", false, {
		statusBarType: statusBarType,
		from: authFrom,
		source: source ? source : (eacctStatus == 2 ? 'walletMain': ''),
		fromThirdAuth: fromThirdAuth,
		fromWalletThirdAuth: fromWalletThirdAuth,
		webPageId: webPageId,
		eacctType: eacctType?eacctType:'',
		isCloseOpener:isCloseOpener,
	});
}

/*
 * 设置键盘弹出模式 
 * Android 生效
 * iOS 新版XCODE 不支持 底部会黑影
 */
function keyboardAdjustResize(){
	if(plus.os.name == "iOS") return;
	plus.webview.currentWebview().setStyle({softinputMode:"adjustResize"});
}

/*
 * Android 判断APP是否安装
 */
function judgeThirdAPPIsInstalled(andAppid){
	if(plus.os.name == "iOS") return;
	var Utils = plus.android.importClass("com.app.yunma.common.Utils");
	var main = plus.android.runtimeMainActivity();
	return Utils.isAppExists(main, andAppid);
}

/**
 * 进入页面，弹出软键盘
 */
function showSoftKeyboard(inputId){
	setTimeout(function(){  
	    if (mui.os.android) {
            // 在执行的时候需要让当前webview获取焦点  
            /*var self = plus.android.currentWebview();  
            plus.android.importClass(self);  
            self.requestFocus();
            var Context = plus.android.importClass("android.content.Context");  
            var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");  
            var main = plus.android.runtimeMainActivity();  
            var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);  
            imm.toggleSoftInput(0,InputMethodManager.SHOW_FORCED);
            document.querySelector(inputId).focus();  */  
	    } else {
	    	var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
	        nativeWebview.plusCallMethod({
	            "setKeyboardDisplayRequiresUserAction": false
	        });
	        document.querySelector(inputId).focus();  
	    }
    }, mui.os.android ? 300 : 330);
}
/*
 * 获取系统语言是否为英文
 * zh-Hans-CN 中文
 * zh-Hant-CN 繁体中文
 * zh-Hant-TW 繁体台湾
 * zh-Hant-HK 繁体香港
 * zh-Hant-AM 繁体澳门
 * 
 * 安卓
 * zh_CN 中文
 * zh_HK
 */
function getLangIsEnglish(){
	var osLanguage = plus.os.language;
	var navLanguage = navigator.language;
	if((!osLanguage || osLanguage == undefined || osLanguage.length <= 0) && (!navLanguage || navLanguage == undefined || navLanguage.length <= 0)){
		return false;
	}
	var language = osLanguage + navLanguage;
	if(language.toLowerCase().indexOf('zh') >= 0){
		return false;
	}
	return true;
}
//页面关闭 是否需要回调
var old_back = mui.back;
mui.back = function(){
	onCommonPageCloseResult();
  	old_back();
}
// 打开App页面, 页面关闭回调
function onCommonPageCloseResult(webviewId){
	if(webviewId){
		var webview = plus.webview.getWebviewById(webviewId);
		if(webview.fromOpenCommonPage && webview.webPageId){
			mui.fire(plus.webview.getWebviewById(webview.webPageId), "onOpenCommonPageResult", {status: 'close'});
		}
		return;
	}
	if(plus.webview.currentWebview().fromOpenCommonPage && plus.webview.currentWebview().webPageId){
		mui.fire(plus.webview.getWebviewById(plus.webview.currentWebview().webPageId), "onOpenCommonPageResult", {status: 'close'});
	}
}

/**
 * ArrayBuffer转为字符串，参数为ArrayBuffer对象(采用UTF-16编码)
 */
function arrayBufferToString(buf) {
	return String.fromCharCode.apply(null, new Uint16Array(buf));
}

/**
 * 字符串转为ArrayBuffer对象，参数为字符串(采用UTF-16编码)
 */
function stringToArrayBuffer(str) {
	var buf = new ArrayBuffer(str.length*2); // 每个字符占用2个字节
	var bufView = new Uint16Array(buf);
	for (var i=0, strLen=str.length; i<strLen; i++) {
		bufView[i] = str.charCodeAt(i);
	}
	return buf;
}

/**
 * 保存网络图片地址到相册
 */
function saveWebImgToGallery(imageUrl){
	if(!imageUrl){
		toast("保存失败");
		return;
	}
	//判断权限
	if(!checkUserPermission("GALLERY", null, function(){
		saveWebImgToGallery(imageUrl);
	})){
		return;	
	}
	//先下载再存相册
	showWaiting();
	var fileUrl = '_doc/image/'+new Date().getTime()+'.jpg';
	var dtask = plus.downloader.createDownload(imageUrl, {filename:fileUrl}, function(d, status){
		closeWaiting();
		// 下载完成
		if(status != 200){ 
			 toast("保存失败");
			 return;
		}  
		//保存图片到系统相册
		saveImgToGallery(fileUrl);
	});
	dtask.start(); 
}

/**
 * 保存base64图片到相册
 */
function saveBase64ImgToGallery(base64Data){
	if(!base64Data){
		toast("保存失败");
		return;
	}
	//判断权限
	if(!checkUserPermission("GALLERY", null, function(){
		saveBase64ImgToGallery(base64Data);
	})){
		return;	
	}
	var bitmap = new plus.nativeObj.Bitmap('base64Bitmap');
	bitmap.loadBase64Data(base64Data, function(){
		var savePicPath = "_doc/image/" + new Date().getTime() + ".jpg";
		bitmap.save(savePicPath,{
			overwrite: true,
			quality: 100
		}, function(i){
			saveImgToGallery(savePicPath);
		}, function(e){
			closeWaiting();
			toast("保存失败");
		});
	}, function(){
		toast("保存失败");
	});
}

/**
 * 保存图片到系统相册
 */
function saveImgToGallery(fileUrl){
	plus.gallery.save(fileUrl, function(){
		toast("保存成功"); 
		//删除原图片
		plus.io.resolveLocalFileSystemURL(fileUrl, function(entry) {
			entry.remove(function(entry) {
				outputLog("文件删除成功");
			}, function(e) {
				outputLog("文件删除失败");
			});
		});
	});
}

/**分转元*/
function centToYuan(money) {
    return money ? parseFormatNum(money/100.00 , 2) : "0.00";
}
/**元转分*/
function yuanToCent(money) {
    return money ? parseFormatNum(money * 100.00, 0) : "0";
}
/**格式化金额*/
function parseFormatNum(number, n){
    if(n != 0 ){
        n = (n > 0 && n <= 20) ? n : 2;
    }
    return parseFloat((number + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
}

/**去除字符串两端空格**/
function commonTrim(str){
	if(!str) return str;
	if(typeof(str) != 'string') return str;
	return str.replace(/^\s+|\s+$/g, "");
}
/*
 * 设置屏幕亮度
 * iOS 13 需要本地设置
 */
function plusSetBrightness(brightness){
	if(brightness == null || brightness == undefined) return;
	if(plus.os.name == "iOS"){
		plus.ios.invoke("NativeJsTool", "setBrightness:", brightness.toString());
	} else {
		try{
			plus.screen.setBrightness(brightness);
		}catch(e){}
	}
}

/**
 * 检查消息通知是否开启
 */
function isNotificationEnabled(){
	if(plus.os.name == 'Android'){
		var Utils = plus.android.importClass("com.app.yunma.common.Utils");
		return Utils.isNotificationEnabled();
	}else{
		var permission = plus.navigator.checkPermission("NOTIFITION");
		if(permission != "denied" && permission != 'undetermined'){//已开启权限或者还未提示获取权限
			return true;
		}
		return false;
	}
}

/**
 * 设置消息通知
 */
function setNotification(){
	if(plus.os.name == 'Android'){
		var Utils = plus.android.importClass("com.app.yunma.common.Utils");
		Utils.setNotification();
	}else{
		plus.ios.invoke("NativeJsTool", "openAlbumReject");
	}
}

/**
 * 公共广告点击事件
 * @param {Object} banner 广告
 * @param {Object} page 展现页面
 * @param {Object} pos 广告位置
 * @param {Object} bannerType 默认广告 model首页模块:链接字段为moreUrl
 */
function onCommonBannerClick(banner, page, pos, bannerType, statusBarType){
	if(!banner || (!banner.url && !banner.moreUrl)) return;
	//添加统计事件
	statisticEvent("bannerClickTime", {"title" : banner.title, "from" : page, "pos": pos});
	var user = getUserInfo();
	if(banner.type == 0 && banner.validBindStatus == 0 && user.bindCardStatus == 0){ //未绑卡
		openBindCard();
		return;
	}
	var linkUrl = banner.url;
	if(bannerType === 'model'){
		linkUrl = banner.moreUrl;
		banner.type = banner.moreType;
	}
	if(linkUrl && linkUrl.indexOf("wxapp://") === 0){ //微信小程序
		openWxAppByUrl(linkUrl);
	}else if(linkUrl && linkUrl.indexOf("alipays://platformapi/startapp") === 0){ //支付宝小程序
		openAliAppByUrl(linkUrl);
	}else if((banner.type == 0 && banner.appType == 0) || banner.type == 2) { //应用数据型 或 数据型
		openWindow(linkUrl, linkUrl, false, {"statusBarType": statusBarType}, null, false);
	}else if(linkUrl){
		openWindow(linkUrl, '../common/web_page.html', false, {
			"webUrl": linkUrl,
			"imgPath": banner.image,
			"statusBarType": statusBarType
		}, null, false);
	}
	if(banner.enableLog !== 1){
		//采集上报
		aliyunPostData("click", [generateUserAndBannerObj(user, banner, page)]);
	}
}

/**
 * 曝光量上报
 */
function showBannerDataUpload(bannerMap){
	//构造数据
	var datas = [];
	var user = getUserInfo();
	for(var key in bannerMap){
		for(var i in bannerMap[key]){
			if(bannerMap[key][i].enableLog !== 1){
				datas.push(generateUserAndBannerObj(user, bannerMap[key][i]));
			}
		}
	}
	//采集上报
	aliyunPostData("show", datas);
	return bannerMap;
}
function showModelBannerDataUpload(adModelList){
	if(!adModelList || adModelList.length <= 0) return;
	//构造数据
	var datas = [];
	var user = getUserInfo();
	for (var i in vueObj.adModelList) {
		var item = vueObj.adModelList[i];
		if(item.modelType != 2) continue;
		for(var k in item.advertisingList){
			if(item.advertisingList[k].enableLog !== 1){
				datas.push(generateUserAndBannerObj(user, item.advertisingList[k]));
			}
		}
	}
	//采集上报
	aliyunPostData("show", datas);
}

/**
 * 生成上报实体
 */
function generateUserAndBannerObj(user, banner, page, statusName){
	var updateObj = {
		os: plus.os.name, env: apiEnvironment, pageId: plus.webview.currentWebview().id,
		userId: user.id, channel: user.invitationCode ? user.invitationCode : "0", eacctStatus: user.eacctStatus, realNameStatus: user.realNameStatus,
		bindCardStatus: user.bindCardStatus, schoolCode: user.schoolCode, schoolIdentityType: user.schoolIdentityType,
		title: banner.title, bannerId: banner.mainId, addressCode: banner.addressCode, provider: banner.adProvider
	}
	var resultObj = {};
	for(var key in updateObj) {
		if(updateObj[key] || updateObj[key] === 0){
			resultObj[key] = updateObj[key] + "";
		}
	}
	return resultObj;
}

/**
 * 手工登录上报
 */
function aliyunLoginDataPost(source){
	var user = getUserInfo();
	var updateObj = {from: source, userId: user.id, os: plus.os.name, mobileType:plus.device.model, version: plus.os.version, schoolCode: user.schoolCode,
		appVer: plus.runtime.version, wgtVer: getCache(WGT_VERSION_FLAG), uuid: getLocalDeviceId(), oaid: getCache(DEVICE_OAID_KEY) };
	var resultObj = {};
	for(var key in updateObj) {
		if(updateObj[key] || updateObj[key] === 0){
			resultObj[key] = updateObj[key] + "";
		}
	}
	aliyunPostData("login", [resultObj], 3);
}

/**
 * 应用上报
 */
function aliyunAppDataPost(appItem, source){
	var user = getUserInfo();
	var updateObj = {from: source, userId: user.id, os: plus.os.name, schoolCode: user.schoolCode, bind: user.bindCardStatus,
		appCode: appItem.appCode, appName: appItem.appName};
	var resultObj = {};
	for(var key in updateObj) {
		if(updateObj[key] || updateObj[key] === 0){
			resultObj[key] = updateObj[key] + "";
		}
	}
	aliyunPostData("apps", [resultObj], 2);
}

/**
 * 阿里云上报
 * type 1营销 2APP相关
 */
function aliyunPostData(topic, datas, type){
	if(!datas || datas.length < 1) return;
	var aliUrl = "https://compus-browse-statistics.cn-hangzhou.log.aliyuncs.com/logstores/compus-browse-statistics/track";
	if(type === 2){
		aliUrl = "https://compus-log.cn-hangzhou.log.aliyuncs.com/logstores/compus-log-store/track";
	}else if(type === 3){
		aliUrl = "https://second-card.cn-hangzhou.log.aliyuncs.com/logstores/second-card-store/track";
	}
	mui.ajax(aliUrl, {
		data: {
			"__topic__": topic,
			"__source__": "LIFE_DELIVERY",
			"__logs__": datas
		},
		crossDomain: true,
		dataType: 'json',
		type: "POST",
		timeout: 10000,
		headers: {
			'Content-Type': 'application/json',
			"x-log-apiversion": "0.6.0",
			"x-log-bodyrawsize": "1234"
		},
		success: function(data) {
			outputLog("aliyunPostData success:" + JSON.stringify(data));
		},
		error: function(xhr, type, errorThrown) {
			outputLog("aliyunPostData error: " + JSON.stringify(xhr))
		}
	});
}

/**
 * 获取本地域名信息
 */
function getDomainInfo(){
	var domainInfo = getCache(YUNMA_DOMAIN_INFO);
	if(domainInfo){
		domainInfo = JSON.parse(domainInfo);
	}else{
		//默认值
		domainInfo = {testList:[{"url":"dxid11.xiaofubao.com", "indexs":"1,3,2"},{"url":"dxid12.xiaofubao.com", "indexs":"0,3,2"},{"url":"ydid11.xiaofubao.com", "indexs":"0,3,1"},{"url":"ltid11.xiaofubao.com", "indexs":"0,2,1"}],replaceUrls: "https://lifeapp.xiaofubao.com,https://pay.xiaofubao.com,https://auth.xiaofubao.com"};
	}
	return domainInfo;
}

/**
 * 测试连接和速度
 */
function testAllDomainUrl(isUpload){
	//测速缓存，间隔时间默认为30秒
	var testAllDomainUrlTime = getCache("testAllDomainUrlTime");
	var testIntervalTime = 60000;
	if(getCache("testAllDomainUrlFailedNum")){
		testIntervalTime = 60000 * parseInt(getCache("testAllDomainUrlFailedNum"));
	}
	if(testAllDomainUrlTime && (new Date().getTime() - parseInt(testAllDomainUrlTime)) < testIntervalTime){
		return;
	}
	setCache("testAllDomainUrlTime", new Date().getTime());
	//获取缓存domain
	var domainInfo = getDomainInfo();
	//拼接检测domain
	var allDomainUrls = "";
	for(var i in domainInfo.testList){
		allDomainUrls = allDomainUrls + "," + domainInfo.testList[i].url;
	}
	if(allDomainUrls.length > 0){
		allDomainUrls = allDomainUrls.substring(1);
	}
	//检测
	if(plus.os.name == 'Android'){
		var CurlUtils = plus.android.importClass("com.app.yunma.common.CurlUtils");
		CurlUtils.startTestDomains(allDomainUrls, plus.android.implements("com.app.yunma.common.OnTestResultBack", {
			"onResult": function(testResults) {
				handleTestDomainResult(testResults, isUpload, domainInfo);
			}
		}));
	}else{
	 	var plugin = window.plus.bridge;
	    plugin.exec("NativeJsDomainPlugin", "startTestDomains", [plugin.callbackId(function(testResults){
	        if(!testResults) return;
	        handleTestDomainResult(testResults,isUpload,domainInfo);
	    }, function(){}), allDomainUrls]);
	}
}

/**
 * 处理检测结果
 */
function handleTestDomainResult(testResults, isUpload, domainInfo){
	outputLog("testResults================>" + testResults);
	//没有测试结果，直接返回
	if(!testResults || testResults.length < 1){
		return;
	}
	//查询失败的域名
	var failIndex;
	for(failIndex = 0; failIndex < testResults.length; failIndex++){
		if(!testResults[failIndex] || testResults[failIndex].indexOf("SUCCESS:") < 0){
			break;
		}
	}
	//测试结果都是成功的，则使用主域名
	if(failIndex >= testResults.length){
		if(getCache(CURRENT_DOMAIN_URL)){
			removeCache(CURRENT_DOMAIN_URL);
			resetAllPagesHost();
		}
		removeCache("testAllDomainUrlFailedNum");
		if(!isUpload || apiEnvironment !== 'RELEASE'){
			return;
		}
	}
	//上报(启动页检测，不进行线路切换)
	if(isUpload && apiEnvironment === 'RELEASE'){
		aliyunPostData("domain", [{os:plus.os.name,result:testResults.join("/")}], 2);
		return;
	}
	//取出对应域名替换的顺序下标
	var indexs = domainInfo.testList[failIndex].indexs.split(",");
	for(var i in indexs){
		var index = parseInt(indexs[i]);
		if(testResults[index] && testResults[index].indexOf("SUCCESS:") === 0){
			setCache(CURRENT_DOMAIN_URL, domainInfo.testList[index].url);
			resetAllPagesHost();
			break;
		}
	}
	//判断是否都为失败的
	var successIndex;
	for(successIndex = 0; successIndex < testResults.length; successIndex++){
		if(testResults[successIndex] && testResults[failIndex].indexOf("SUCCESS:") === 0){
			break;
		}
	}
	//所有都是失败的
	if(successIndex >= testResults.length){
		var testAllDomainUrlFailedNum = 0;
		if(getCache("testAllDomainUrlFailedNum")){
			testAllDomainUrlFailedNum = parseInt(getCache("testAllDomainUrlFailedNum"));
		}
		testAllDomainUrlFailedNum++;
		setCache("testAllDomainUrlFailedNum", testAllDomainUrlFailedNum);
	}else{
		removeCache("testAllDomainUrlFailedNum");
	}
}

/**
 * 转换地址
 */
function getExchangeDomainUrl(domainUrl){
	var domainInfo = getDomainInfo();
	var nowDomains = domainUrl.split("/");
	if(domainInfo && domainInfo.replaceUrls && nowDomains.length > 2 && domainInfo.replaceUrls.indexOf(nowDomains[2]+'') >= 0){
		var domain = getCache(CURRENT_DOMAIN_URL);
		if(domain){
			domainUrl = domainUrl.replace(".xiaofubao.com", "-" + domain);
		}
	}
	return domainUrl;
}

/**
 * 重置所有页面HOST
 */
function resetAllPagesHost(){
	var wvs=plus.webview.all();
	for(var i = 0; i < wvs.length; i++) {
		mui.fire(wvs[i], "onDomainUrlChanged", {});
	}
}

/**
 * 判断是否重复、连续的数字
 */
function judgeContinueRepeat(numStr){
	var numArray = numStr.split("");
	var isContinue = true;
	for(var i=0; i<numArray.length-2; i++){
		if((parseInt(numArray[i+1])-parseInt(numArray[i])) != (parseInt(numArray[i+2])-parseInt(numArray[i+1]))){
			isContinue = false;
			break;
		}
	}
	return isContinue;
}

/**
 * 打开微信小程序
 * @param {Object} url 以wxapp://开头
 */
function openWxAppByUrl(url){
	var id = comGetUrlParamByName(url, "id");
	var path = comGetUrlParamByName(url, "path");
	var type = comGetUrlParamByName(url, "type");
	var webUrl = comGetUrlParamByName(url, "webUrl");
	plus.share.getServices(function(services) {
		var service;
		for(var i in services) {
			if(services[i].id === 'weixin'){
				service = services[i];
				break;
			}
		}
		if(!service) {
			toast("初始化微信服务失败");
			return;
		}
		if(!service.nativeClient) {
			toast("未安装微信客户端");
			return;
		}
		var param = {id:id};
		if(path) param.path = path; 
		if(type >= 0) param.type = type;
		if(webUrl) param.webUrl = webUrl;
		if(id === 'gh_993daa28f3fa' && path){
			path = path + (path.indexOf("?") > 0 ? "&" : "?");
			param.path = path + "schoolCode="+getCache(SCHOOL_CODE_KEY)+"&userId="+getCache(USER_ID_KEY)+"&uuToken="+getCache(UU_TOKEN_KEY);
		}
		console.log("wxapp path: " + param.path);
		service.launchMiniProgram(param);
	}, function(e) {
	});
}

/**
 * 打开支付宝小程序
 * @param {Object} url 以alipays://开头
 */
function openAliAppByUrl(url){
	var appId = comGetUrlParamByName(url, "appId");
	var query = comGetUrlParamByName(url, "query");
	if(appId === '2021001156623446'){
		var user = getUserInfo();
		if(query){
			query += ("&schoolCode="+getCache(SCHOOL_CODE_KEY)+"&userId="+getCache(USER_ID_KEY)+"&uuToken="+getCache(UU_TOKEN_KEY));
			url = url.substring(0, url.indexOf("query=")) + "query=" + encodeURIComponent(query);
		}else{
			query = "schoolCode="+getCache(SCHOOL_CODE_KEY)+"&userId="+getCache(USER_ID_KEY)+"&uuToken="+getCache(UU_TOKEN_KEY)
			url = url + "&query=" + encodeURIComponent(query);
		}
	}
	console.log("alipays url: " + url);
	plus.runtime.openURL(url);
}
/*
 * 根据角色 打开首页
 */
function openHomeMainHtml(isCloseOpener){
	var dmsUserRole = getUserInfo().dmsUserRole;
	openWindow('main', dmsUserRole===1?'../home/home_main_admin.html':'../home/home_main.html', false, {isCloseOpener:isCloseOpener}, null, true);
}
