/**
 * ===========================
 * 照片选取工具
 * ===========================
 * 2017-03-14
 */


/**
 * 拍照
 */
function takePhoto(taked) {
	var cmr = plus.camera.getCamera();
	var res = cmr.supportedImageResolutions[0];
	var fmt = cmr.supportedImageFormats[0];
	cmr.captureImage(function(p) {
		plus.io.resolveLocalFileSystemURL(p, function(entry) {
			if(taked) {
				taked(entry.toLocalURL());
			}
		}, function(e) {
			toast("读取拍照文件错误：" + e.message);
		});
	}, function(e) {
		toast("失败：" + e.message);
	}, {
		resolution: res,
		format: fmt
	});
}

/**
 * 从相册中选择图片
 */
function selectPhoto(selected) {
	if(!selected) {
		selected = function(path) {
			toast(path);
		};
	}
	plus.gallery.pick(selected, function(e) {
		toast("取消选择图片");
	}, {
		filter: "image"
	});
}

/**
 * 从相册中选择多张图片（最多8张）
 */
function selectPhotos(selected) {
	if(!selected) {
		selected = function(files) {
			toast(JSON.stringify(files));
		};
	}
	plus.gallery.pick(function(e){
		selected(e.files);
	}, function(e) {
		toast("取消选择图片");
	}, {
		filter: "image",
		multiple: true,
		maximum: 8,
		system: false,
		onmaxed: function() {
			toast("最多只能选择8张图片");
		}
	});
}

/**
 * 拍照和相册选取照片，带压缩
 * 页面需要导入libs/imgTool/common.js  libs/imgTool/image-new.js  app.js 三个文件
 * uploadType 必须为字符串如： "0"
 * callBack, isClipCamera, group, cameraType, isBankCard, scene, deleteFileName, isMultiple, maxNum, isClip, uploadType, itemCallBack, appId
*/
function popCompressSelectPic(options){
	// 弹出系统选择按钮框
	plus.nativeUI.actionSheet({
			cancel: "取消",
			buttons: [{
				title: "拍照上传"
			}, {
				title: '从相册上传'
			}]
		},
		function(e) {
			if(e.index == 2) { //点击从相册选择
				imageTool.galleryImgs(options);
			} else if(e.index == 1) {
				imageTool.camera(options);
			}
		}
	);
}
/*
 * 图片本地路径转换Base64
 */
function pathToBase64(path, cb) {
    plus.io.resolveLocalFileSystemURL(getLocalFilePath(path), function(entry) {
	    entry.file(function(file) {
		var fileReader = new plus.io.FileReader();
			fileReader.onload = function(data) {
				cb(data.target.result);
			}
			fileReader.onerror = function(error) {
				cb(false);
			}
			fileReader.readAsDataURL(file)
		}, function(error) {
			cb(false);
		});
	}, function(error) {
		cb(false);
	});
}
function getLocalFilePath(path) {
    if (path.indexOf('_www') === 0 || path.indexOf('_doc') === 0 || path.indexOf('_documents') === 0 || path.indexOf('_downloads') === 0) {
        return path
    }
    if (path.indexOf('file://') === 0) {
        return path
    }
    if (path.indexOf('/storage/emulated/0/') === 0) {
        return path
    }
    if (path.indexOf('/') === 0) {
        var localFilePath = plus.io.convertAbsoluteFileSystem(path)
        if (localFilePath !== path) {
            return localFilePath
        } else {
            path = path.substr(1)
        }
    }
    return '_www/' + path
}