var wgtVer = null;
var wgtSerVer = null;
var curVer = null;
function plusReady() {
	// 获取本地应用资源版本号
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
		outputLog("当前应用资源版本：" + wgtVer);
	});
	curVer = plus.runtime.version;
	//如果没有同意隐私政策，则返回
	if(!isLogin()){
		return;
	} 
	//2秒后检查资源升级
	setTimeout(function() {
		checkUpdate();
	}, 2000);
}
if(window.plus) {
	plusReady();
} else {
	document.addEventListener('plusready', plusReady, false);
}

/**
 * 增量升级wgt
 */
function checkUpdate() {
	if(location.href.indexOf("start/start.html") > 0 && apiEnvironment != "RELEASE") return;
	var params = {
		updateType: "0",
		applyVersion: curVer
	};
	webCall2("/routecps/route/compus/appversion/getAppVersioList", params, 1001, function(data, requestCode){
		//data.data.version ==>  服务端配置的最新的增量包版本号，整包版本集合
		if (data.data && data.data && data.data.version) {
			wgtSerVer = data.data.version;
			if (!compareVersion(wgtVer, wgtSerVer)) { // 无增量升级，获取差量升级
				checkWgtuUpdate();
				return;
			}
			downWgt(data.data.url); // 下载升级包
			return;
		}
		//差量升级
		checkWgtuUpdate();
	});
}

/**
 * 差量升级wgtu
 */
function checkWgtuUpdate() {
	var params = {
		updateType: "2",
		applyVersion: wgtVer
	};
	webCall2("/routecps/route/compus/appversion/getAppVersioList", params, 1002, function(data, requestCode){
		if (data.data && data.data && data.data.version) {
			var wgtuSerVer = data.data.version;
			if (!compareVersion(wgtVer, wgtuSerVer)) { // 无需增量升级
				return;
			}
			downWgt(data.data.url, true); // 下载升级包
		}
	});
}

/**
 * 比较整包版本，如果新版本nv等于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareBundleVersion( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	if (nv == ov && 0==nv.indexOf(ov) ) {
		return true;
	}
	return false;
}


/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersion( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	var b=false;
	var ova = ov.split(".",4);
	var nva = nv.split(".",4);
	for ( var i=0; i<ova.length&&i<nva.length; i++ ) {
		var so=ova[i],no=parseInt(so),sn=nva[i],nn=parseInt(sn);
		if ( nn>no || sn.length>so.length  ) {
			return true;
		} else if ( nn<no ) {
			return false;
		}
	}
	if ( nva.length>ova.length && 0==nv.indexOf(ov) ) {
		return true;
	}
	return false;
}

function downWgt(wgtUrl, isWgtu) {
	outputLog("下载wgt文件...");
	plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		if(status == 200) {
			if(plus.os.name == "iOS"){
				saveWgtFile(d.filename, isWgtu);
			} else {
				installWgt(d.filename, isWgtu); // 安装wgt包
			}
		} else {
			outputLog("下载wgt失败！");
		}
	}).start();
}
// 更新应用资源
function installWgt(path, isWgtu) {
	outputLog("安装wgt文件...");
	plus.runtime.install(path, {force:true}, function() {
		wgtVer = wgtSerVer;
		//标记有新版本更新
		setCache(WGT_NEWEST_VERSION_FLAG, "yes");
		//增量升级完成后，检查差量升级
		if(!isWgtu){
			checkWgtuUpdate();
		}
		//清理缓存
		outputLog("安装wgt成功...");
		plus.cache.clear();
	}, function(e) {
		outputLog("安装wgt失败: " + JSON.stringify(e));
	});
}
//iOS wgt包保存下载路径
function saveWgtFile(path, isWgtu){
	outputLog("保存wgt文件路径...");
	wgtVer = wgtSerVer;
	if(!isWgtu){
		checkWgtuUpdate();
	}
	var fileList = new Array();
	if(getCache(WGT_VERSION_FILE_LIST)){
		fileList = JSON.parse(getCache(WGT_VERSION_FILE_LIST));
	}
	fileList.push(path);
	setCache(WGT_VERSION_FILE_LIST, JSON.stringify(fileList));
}
// 更新应用资源
function iOSInstallWgt() {
	var fileList;
	var count = 0;
	if(getCache(WGT_VERSION_FILE_LIST)) {
		fileList = JSON.parse(getCache(WGT_VERSION_FILE_LIST));
	} else {
		return;
	}
	for(var i in fileList) {
		plus.runtime.install(fileList[i], {
			force: true
		}, function() {
			count++;
			if(count == fileList.length) {
				appRestart()
			}
			outputLog("安装wgt成功...");
		}, function(e) {
			count++;
			if(count == fileList.length) {
				appRestart()
			}
			outputLog("安装wgt失败: " + JSON.stringify(e));
		});
		
	}
}
//应用重启
function appRestart(){
	//清理缓存
	plus.cache.clear();
	removeCache(WGT_VERSION_FILE_LIST);
	plus.runtime.restart();
}
