/**
 * @author 1020450921@qq.com
 * @link http://www.cnblogs.com/phillyx
 * @link http://ask.dcloud.net.cn/people/%E5%B0%8F%E4%BA%91%E8%8F%9C
 */
var imageTool = (function(mui, com) {
	/**
	 * 1.使用native.js压缩
	 * 1.1.拍照上传
	 * 1.2.选择图片上传
	 */
	var endReturn = [];
	var itool = {
		options: {
			uploadUrl: '/app/common/upload/uploadFile', //图片上传地址
			appId: null, //第三方的appid
			multiple: false, //是否多图上传
			maxPicsCount: 8, //默认一次最多选择8张图片
			isZoom: true, //默认通过native.js压缩
			isClip: false, //是否要剪裁
			group: null, //私有目录，传值公有目录不传
			deleteFileName: null, //要删除的文件
			scene: null, //场景 authCard认证身份证图片
			uploadType: null, //上传类型
			itemCb: null, //批量上传单文件上传回调
			ZoomBox: 1200, //缩放宽高，默认1200px,横图缩放宽度，高度根据比例计算，同理竖图
			ZoomQuality: 70, //压缩图片的质量
			isUpload: true, //默认不上传
			system: false, //设置为true时，如果系统自带相册选择控件时则优先使用，否则使用5+统一相册选择控件；设置为false则不使用系统自带相册选择控件，直接使用5+统一相册选择界面。
		},
		setUploadData: function(task) {
			task.addData("id", getCache(USER_ID_KEY));
			task.addData("token", getCache(USER_TOKEN_KEY));
			task.addData("deviceId", getLocalDeviceId());
			task.addData("osType", plus.os.name);
			task.addData("mobileType", plus.device.model);
			task.addData("platform", "LIFE_DELIVERY");
			if(itool.options.appId){
				task.addData("appId", itool.options.appId);
			}
			if(itool.options.group){
				task.addData("group", itool.options.group);
			}
			if(itool.options.scene && itool.options.scene.length > 0){
				task.addData("scene", itool.options.scene);
			}
			if(itool.options.deleteFileName && itool.options.deleteFileName.length > 0){
				task.addData("deleteFileName", itool.options.deleteFileName);
			}
			if(itool.options.uploadType != null && itool.options.uploadType != ""){
				task.addData("uploadType", itool.options.uploadType);
			}
		}
	};
	/**
	 * @description get images from an album
	 * @param {Object} callBack(err,files)
	 * callBack, itemCb, isMultiple, maxNum, isClip, group, isBankCard, uploadType, scene, deleteFileName, appId
	 */
	function galleryImgs(options) {
		//权限判断
		if(!checkUserPermission("GALLERY", null, function(){
			galleryImgs(options);
		})){
			return;	
		}
		//参数重置
		for(var key in options){
			itool.options[key] = options[key];
		}
		if(options.isBankCard){
			itool.options.uploadUrl = "/common/ocr/bankcard";
		}else if(options.appId){
			itool.options.uploadUrl = "/open/upload/uploadFile";
		}
		//重置
		endReturn = [];
		plus.gallery.pick(function(e) {
			if (itool.options.multiple) {
				/*if(e.files.length > itool.options.maxPicsCount){
					return callBack && callBack('最多选择'+itool.options.maxPicsCount+'张图片');
				}*/
			}
			processing_imgs(itool.options.multiple ? e.files : e, options.callBack);
		}, function(error) {
			options.callBack && options.callBack(error.message);
		}, {
			filter: "image",
			multiple: itool.options.multiple,
			maximum: itool.options.multiple ? parseInt(itool.options.maxPicsCount) : 1,
			system: false,
			onmaxed: function() {
				toast('最多选择' + (itool.options.multiple ? itool.options.maxPicsCount : 1) + '张图片');
			}
		});
	};

	var endReturn = [];

	function processing_imgs(files, cb) {
		plus.nativeUI.closeWaiting();
		plus.nativeUI.showWaiting('');
		if (typeof(files) === "string") {
			files = [files];
		}
		com.myasync(files, processing_img, function() {
			plus.nativeUI.closeWaiting();
			cb && cb(false, endReturn);
		});
	};
	/**
	 * @description 压缩并上传图片单独拎出来，拍照也可用到
	 * @param {Object} pic
	 * @param {Object} next
	 */
	function processing_img(pic, next) {
		if (pic) {
			//是否需要剪裁
			if (itool.options.isClip) {
				clip_img(pic, next);
			}else{
				//是否需要压缩
				if (itool.options.isZoom) {
					zoomImage(pic, function(err, p) {
						processing_img_x(p, next);
					});
				} else {
					processing_img_x(pic, next);
				}
			}
		}
	};
	
	function clip_img(pth, next){
		if(plus.os.name == 'iOS'){
			var plugin = window.plus.bridge;
			plugin.exec("NativeJsDomainPlugin", "openCropToolVC", [plugin.callbackId(function(result) {
				if(!result || result == "cancel") {
					toast("取消上传");
					plus.nativeUI.closeWaiting();
					return;
				}
				var picPath = "file://" + result;
				outputLog("picPath" + picPath);
				//剪裁不需要压缩
				processing_img_x(picPath, next);
			}, function() {}), plus.io.convertLocalFileSystemURL(pth)]);
		}else{
			var main = plus.android.runtimeMainActivity();
			var UCropUtils = plus.android.importClass("com.app.yunma.common.UCropUtils");
			var UCrop = plus.android.importClass("com.yalantis.ucrop.UCrop");
			var outPutPath = UCropUtils.startUCrop(main, plus.io.convertLocalFileSystemURL(pth), itool.options.maxWidth, itool.options.maxHeight);
			main.onActivityResult = function(requestCode, resultCode, data) {
				if(requestCode == UCrop.REQUEST_CROP && resultCode == main.RESULT_OK ){
					//剪裁不需要压缩
					processing_img_x(outPutPath, next);
				}else if(requestCode == UCrop.REQUEST_CROP && resultCode == UCrop.RESULT_ERROR){
					toast("取消上传");
					plus.nativeUI.closeWaiting();
				}
			}
		}
	}

	function processing_img_x(pic, next) {
		if (itool.options.isUpload) {
			imgUploadCom(pic, function(err, imgUrl, localPath) {
				endReturn.push({
					error: err,
					imgUrl: imgUrl,
					localPath: localPath
				});
				next();
			});
		} else {
			endReturn.push({
				imgUrl: pic
			});
			next();
		}
	}
	/**
	 * @description 上传图片带参数 
	 * @param {Object} path
	 * @param {Object} cb
	 */
	function imgUploadCom(path, cb) {
		var task = plus.uploader.createUpload(uploadHost + itool.options.uploadUrl, {
			method: "POST",
			timeout: 60,  //上传任务超时时间（s）
			retry: 2,  //上传任务重试次数
			retryInterval: 5 //上传任务重试间隔时间
		}, function(t, status) {
			outputLog("t.responseText" + t.responseText);
			if (status == 200 && t.responseText && t.responseText.indexOf("data") >= 0) {
				var data = JSON.parse(t.responseText);
				//上传成功后后台返回的数据格式规范为{code:200,url:'网络链接'}
				if (data && data.statusCode == 0) {
					var imgurl = data.data;
					cb && cb(false, imgurl, path);
					itool.options.itemCb && itool.options.itemCb(imgurl, path);
				} else {
					cb && cb(data.message);
				}
			}else if (t.responseText && t.responseText.indexOf("message") >= 0) {
				toast(JSON.parse(t.responseText).message);
				cb && cb('上传失败！');
			} else {
				toast("上传失败 , 请重试");
				cb && cb('上传失败！');
			}
		});
		task.addFile(path, {
			key: "file"
		});
		//添加上传的其他参数
		itool.setUploadData(task);
		task.start();
	}
	/**
	 * @description 缩放图片
	 * @param {Object} pth 图片本地路径
	 * @param {Object} cb 
	 */
	function zoomImage(pth, cb) {
		//Android判断图片旋转
		var rotate = 0;
		if(plus.os.name == 'Android'){
			try{
				var Utils = plus.android.importClass("com.app.yunma.common.Utils");
				rotate = Utils.getExifOrientation(pth);
				outputLog("图片旋转角度=========>" + rotate);
			}catch(e){
				JSON.stringify(e);
			}
		}
		//不覆盖原图
		var newImgSrc = "_downloads/" + (+new Date()) + pth.substr(pth.lastIndexOf('.'));
		var conf = {
			src: pth,
			dst: newImgSrc,
			//dst:pth,
			//overwrite:true,
			quality: itool.options.ZoomQuality,
			rotate: rotate
		};
		//iOS HEIC 转换成 png
		if(pth.indexOf("HEIC") >= 0 || pth.indexOf("heic") >= 0) {
			conf.dst = newImgSrc.replace("HEIC", "jpg").replace("heic", "jpg");
			conf.format = "jpg";
			conf.overwrite = true;
		}
		//判断图片宽度，如果大于ZoomBox值，则进行压缩
		var sourceImg = new Image();
		if(plus.os.name == "iOS"){
			pathToBase64(pth, function(res){
				sourceImg.src = res;
			});
		} else {
			sourceImg.src = pth;
		}
		sourceImg.onload = function(){
			if(sourceImg.width && sourceImg.width > itool.options.ZoomBox){
				conf['width'] = itool.options.ZoomBox + 'px';
			}
			plus.zip.compressImage(conf, function(data) {
				cb(false, data.target);
			}, function(err) {
				cb(err.message, pth);
			});
		};
	};
	/**
	 * @description 手机拍照并压缩(上传)
	 * @param {Object} callBack(err,files)
	 * @param {Object} err
	 * callBack, itemCb, isClip, isClipCamera, group,cameraType, isBankCard, uploadType, scene, deleteFileName, appId
	 */
	function camera(options) {
		//判断Android是否禁用权限
		if(!checkUserPermission("CAMERA", null, function(){
			camera(options);
		})){return}
		//参数重置
		for(var key in options){
			itool.options[key] = options[key];
		}
		if(options.isBankCard){
			itool.options.uploadUrl = "/common/ocr/bankcard";
		}else if(options.appId){
			itool.options.uploadUrl = "/open/upload/uploadFile";
		}
		//重置 拍照无用，重置不要占内存
		endReturn = [];
		//自定义线框拍照
		if(plus.os.name == 'iOS' && options.isClipCamera){
			var prompt = "";
			if(cameraType == "front") {
				prompt = "将身份证头像页置于此区域，并对齐扫描框边缘"
			} else if(cameraType == "back"){
				prompt = "将身份证国徽页置于此区域，并对齐扫描框边缘"
			} else {
				prompt = "将银行卡正面置于此区域，并对齐扫描框边缘"
			}
			//更新调用实名认证拍照方式
			var plugin = window.plus.bridge;
			plugin.exec("NativeJsDomainPlugin", "openCameraToolVC", [plugin.callbackId(function(result){
				if(!result) return;
				var picPath =  "file://" + result;
				outputLog("picPath" + picPath);
				//身份证拍照不需要压缩 压缩之后无法上传
				itool.options.isZoom = false;
				processing_imgs(picPath, options.callBack);
			}, function(){}), prompt]);
			return;
		}
		//普通拍照
		var cmr = plus.camera.getCamera();
		cmr.captureImage(function(p) {
			plus.io.resolveLocalFileSystemURL(p, function(entry) {
				//妈蛋 entry.fullPath 有坑，在ios上获取不到
				var u = entry.toLocalURL();
				processing_imgs(u, options.callBack);
			}, function(err) {
				toast("读取拍照文件错误 , 请重试");
				options.callBack && options.callBack(err.message);
			});
		}, function(err) {
			//未测拍照权限 err.code
			if(plus.os.name == 'Android' && err.message == 'null'){
				toast("请在设置中允许使用相机");
			}
			options.callBack && options.callBack(err.message);
		}, {
			filename: "_doc/camera/",
			index: 1
		});
	};

	/**
	 * @description 打开相册失败，请求系统权限
	 * @param {Error} e
	 */
	function sys_permission(e) {
		if (plus.os.name == "iOS") {
			if (e.code == 8) {
				checkUserPermission("GALLERY");
			}
		} else if (plus.os.name == "Android") {
			if (e.code != 12) {
				mui.alert("您的相册权限未打开，请在应用列表中找到您的程序，将您的权限打开", function() {
					var android = plus.android.importClass('com.android.settings');
					var main = plus.android.runtimeMainActivity();
					var Intent = plus.android.importClass("android.content.Intent");
					var mIntent = new Intent('android.settings.APPLICATION_SETTINGS');
					main.startActivity(mIntent);
				});
			}
		}
	};
	itool.galleryImgs = galleryImgs;
	itool.imgUpload = imgUploadCom;
	itool.zoomImage = zoomImage;
	itool.camera = camera;
	return itool;
})(mui, common);