/** 网络请求码 */
var QUERY_USER_INFO = 1001;
var myScroll;
var isPull = true;
	var vueObj = new Vue({
		el: '#main',
		data: {
			dmsUserInfo: {}, //配送用户信息
			isShowNotify: false,
			dmsUserRole: null, //角色 1管理员 2取餐员 3分拣员 4分送员 5跑楼员
		},
		beforeMount: function() {
			mui.init({
				//监听返回事件
				beforeback: function() {
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
					return true;
				}
			});
			mui.plusReady(function() {
				setStatusBarMain();
				plus.webview.currentWebview().addEventListener("popGesture", function(e) {
					if(e.type == 'start'){ //侧滑开始
						setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
					}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
						setStatusBarMain();
					}
				}, false);
				//处理状态栏
				vueObj.handleStatusBar();
				window.addEventListener("userPhoneChange", function(event){
					vueObj.userPhone = getCache(USER_PHONE_KEY);
				});
				//用户数据
				vueObj.initData();
				vueObj.queryUserInfo();
				vueObj.checkNotifyStatus();
			});
		},
		methods: {
			/*
			 * 请求用户信息 刷新用户认证状态
			 */
			queryUserInfo: function(){
				webCall2("/app/delivery/ums/dms/user/getDetailById", {dmsUserId:getUserInfo().dmsUserId}, QUERY_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
			},
			/**
			 * 初始化数据
			 */
			initData: function() {
				vueObj.dmsUserRole = getUserInfo().dmsUserRole;
				var dmsUserInfo = getCache(DMS_USER_INFO_KEY)
				if(dmsUserInfo){
					vueObj.dmsUserInfo = JSON.parse(dmsUserInfo);
				}
			},
			/**
			 * 接口访问成功返回
			 * @param {Object} data
			 * @param {Object} requestCode
			 */
			onSuccess: function(data, requestCode) {
				switch(requestCode) {
				case QUERY_USER_INFO: //用户信息查询
					vueObj.dmsUserInfo = data.data;
					setCache(DMS_USER_INFO_KEY, JSON.stringify(vueObj.dmsUserInfo));
					break;
				default:
					break;
				}
			},
			/**
			 * 接口访问失败返回
			 * @param {Object} resultCode
			 * @param {Object} resultMsgDesc
			 */
			onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			},
			/**
			 * 点击事件监听
			 */
			onButtonClick: function(e) {
				//添加统计事件
				statisticEvent("centerButtonClick", {"btnType" : e.currentTarget.dataset.type});
				switch (e.currentTarget.dataset.type){
				case "person": //人员管理
					if(vueObj.dmsUserRole !== 1){
						toast("您没有此功能权限");
						return;
					}
					openWindow("personManage", "../center/person_manage.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
					break;
				case "statics": //工单统计
					if(vueObj.dmsUserRole !== 1){
						openWindow("orderStaticsStaff", "../center/order_statics_staff.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
						return;
					}
					openWindow("orderStatics", "../center/order_statics.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
					break; 
				case "order": //订单设置
					if(vueObj.dmsUserRole !== 1){
						toast("您没有此功能权限");
						return;
					}
					openWindow("order", "../center/order_setting.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
					break;
				case "setting": //设置
					openWindow("setting", "../setting/setting.html", false, {
						supportAuth: vueObj.supportAuth,
						statusBarType: STATUS_BAR_MAIN_KEY
					});
					break;	
				case "notice"://通知提醒打开
					if(plus.os.name == 'Android'){
						var Utils = plus.android.importClass("com.app.yunma.common.Utils");
						Utils.setNotification();
					}else{
						plus.ios.invoke("NativeJsTool", "openAlbumReject");
					}
					break;
				case "noticeClose"://通知提醒关闭
					setCache('closteNotice'+getCache(USER_ID_KEY), true);
					vueObj.isShowNotify = false;
					break;
				case "service": //客服电话
					plus.device.dial("400-100-9591", true);
					break;
				case "wallet": //钱包
					if(!getCache(WALLET_ACCOUNT_ID)) {
						toast("暂无权限");
						return;
					}
					openWindow("walletMain", "../wallet/wallet_main.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
					break;	
				case "feedback": //意见反馈
					openWindow("feedback", "feedback.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break
				default:
					break;
				}
			},
			/*
			 *  检测通知是否开启 
			 */
			checkNotifyStatus: function(){
				if(getCache('closteNotice'+getCache(USER_ID_KEY)) || isNotificationEnabled()) {
					vueObj.isShowNotify = false;
					return;
				}
				vueObj.isShowNotify = true;
			},
			handleStatusBar: function() {
				var immersed = 0;
				var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
				if(ms && ms.length >= 3) {
					immersed = parseFloat(ms[2]);
				}
				if(!immersed) {
					return;
				}
				document.getElementById("topBar").style.height = immersed + 'px';
			}
		}
});