//请求码
var QUERY_DATA = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		order: {}
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//监听用户数据变化
			window.addEventListener("onInfoEditCallback", function(event){
				Vue.set(vueObj.order, event.detail.type, event.detail.value);
			});
			window.addEventListener("onOrderSettingChanged", function(event){
				vueObj.loadData();
			});
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function(){
			//加载数据
			showWaiting();
			webCall2("/app/dms/delivery/company/getInfo", null, QUERY_DATA, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DATA: //
				vueObj.order = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'time': //配送时间
				openWindow("orderSettingTime", "../center/order_setting_time.html", false, {
					type: vueObj.order.isAllDayWork,
					times: vueObj.order.deliveryTimeListStr
				});
				break;
			case 'capacity': //每人取餐份数
				openWindow("shopInfoEdit", "../center/shop_info_edit.html", false, {
					type: "userMaxCapacityNum",
					title: "每人每店取餐份数",
					value: vueObj.order.userMaxCapacityNum ? vueObj.order.userMaxCapacityNum : ''
				});
				break;
			case 'get': //取餐超时异常
				openWindow("shopInfoEdit", "../center/shop_info_edit.html", false, {
					type: "unTakeExpireTime",
					title: "取餐超时预警时间(分钟)",
					value: vueObj.order.unTakeExpireTime ? vueObj.order.unTakeExpireTime : ''
				});
				break;
			case 'check': //核验超时异常
				openWindow("shopInfoEdit", "../center/shop_info_edit.html", false, {
					type: "unCheckExpireTime",
					title: "核验超时预警时间(分钟)",
					value: vueObj.order.unCheckExpireTime ? vueObj.order.unCheckExpireTime : ''
				});
				break;
			default:
				break;
			}
		}
	}
});