//请求码
var DO_SAVE = 1002;
var timePicker;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		type: 0, //0:24小时配送. 1:自定义时段配送
		times: [{}],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//switch监听
			document.getElementById("typeSwitch").addEventListener('toggle', function(event) {
				if(event.detail.isActive){
					//24小时配送
					vueObj.type = 0;
				}else{
					vueObj.times = [{}];
					vueObj.type = 1;
				}
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.type = parseInt(plus.webview.currentWebview().type);
			var times = plus.webview.currentWebview().times;
			if(times){
				vueObj.times = JSON.parse(times);
			}
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_SAVE: //保存成功
				toast("配送时间设置成功");
				mui.fire(plus.webview.currentWebview().opener(), "onOrderSettingChanged", {});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'add': //添加配送时间
				vueObj.times.push({});
				break;
			case 'time': //时间选择
				var index = e.currentTarget.dataset.index;
				var name = e.currentTarget.dataset.name;
				if(!timePicker){
					timePicker = new mui.PopPicker({layer: 2});
					var children = [{text:"00"},{text:"15"},{text:"30"},{text:"45"}]
					timePicker.setData([
						{text:"00", children:children},{text:"01", children:children},{text:"02", children:children},
						{text:"03", children:children},{text:"04", children:children},{text:"05", children:children},
						{text:"06", children:children},{text:"07", children:children},{text:"08", children:children},
						{text:"09", children:children},{text:"10", children:children},{text:"11", children:children},
						{text:"12", children:children},{text:"13", children:children},{text:"14", children:children},
						{text:"15", children:children},{text:"16", children:children},{text:"17", children:children},
						{text:"18", children:children},{text:"19", children:children},{text:"20", children:children},
						{text:"21", children:children},{text:"22", children:children},{text:"23", children:children}
					]);
				}
				timePicker.show(function(items) {
					var hour = parseInt(items[0].text);
					var minute = parseInt(items[1].text);
					//如果是开始时间，则判断是否小于结束时间
					if(name == "startTime" && vueObj.times[index].endTime){
						var timeArray = vueObj.times[index].endTime.split(":");
						if(hour > parseInt(timeArray[0]) || (hour == parseInt(timeArray[0])
							&& minute >= parseInt(timeArray[1]))) {
							toast("开始时间不能大于结束时间");
							return;
						}
					}
					//如果是结束时间，则判断是否大于开始时间
					if(name == "endTime" && vueObj.times[index].startTime){
						var timeArray = vueObj.times[index].startTime.split(":");
						if(hour < parseInt(timeArray[0]) || (hour == parseInt(timeArray[0])
							&& minute <= parseInt(timeArray[1]))) {
							toast("结束时间不能小于开始时间");
							return;
						}
					}
					Vue.set(vueObj.times[index], name, items[0].text + ":" + items[1].text);
				});
				break;
			case 'save': //保存
				if(vueObj.type === 1){
					for(var i in vueObj.times){
						if(!vueObj.times[i].startTime || !vueObj.times[i].endTime){
							toast("请选择自定义配送时间");
							return;
						}
					}
				}
				showWaiting();
				var params = {isAllDayWork: vueObj.type}
				if(vueObj.type === 1){
					params.deliveryTimeListStr = JSON.stringify(vueObj.times);
				}
				webCall2("/app/dms/delivery/company/doUpdate", params, DO_SAVE, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			default:
				break;
			}
		}
	}
});