//请求码
var DO_SAVE = 1001, DO_DELETE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		person: {},
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//switch监听
			document.getElementById("typeSwitch").addEventListener('toggle', function(event) {
				Vue.set(vueObj.person, "status", event.detail.isActive ? 1 : 0)
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			var person = plus.webview.currentWebview().person;
			if(person){
				vueObj.person = person;
				Vue.set(vueObj.person, "changeRole", person.role);
				vueObj.setRoleStr(person);
				document.getElementById("title").innerText = "编辑人员";
			}else{
				document.getElementById("title").innerText = "新增人员";
			}
		});
	},
	methods: {
		setRoleStr: function(person){
			Vue.set(vueObj.person, "roleStr", person.role===1?'管理员':(person.role===2?'取餐员':(person.role===3?'分拣员':(person.role===4?'分送员':'跑楼员'))))
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_SAVE: //保存成功
				toast("保存成功");
				mui.fire(plus.webview.currentWebview().opener(), "onPersonChanged", {});
				mui.back();
				break;
			case DO_DELETE: //删除成功
				toast("删除成功");
				mui.fire(plus.webview.currentWebview().opener(), "onPersonChanged", {});
				mui.back();
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'role': //角色选择
				if(vueObj.person.id && vueObj.person.changeRole == 1) return;
				plus.nativeUI.actionSheet({
					title: "角色选择",
					cancel:"取消",
					buttons:[{title:"管理员"},{title:"取餐员"},{title:"分拣员"},{title:"分送员"},{title:"跑楼员"}]},
					function(e){
						if(e.index < 1) return;
						vueObj.person.role = e.index;
						vueObj.setRoleStr(vueObj.person);
					}
				);
				break;
			case 'save': //保存分类
				if(!vueObj.person.userName){
					toast("请输入姓名");
					return;
				}
				if(!vueObj.person.mobilePhone){
					toast("请输入电话");
					return;
				}
				if(!regexMobile(vueObj.person.mobilePhone)){
					toast("请输入正确的11位手机号");
					return;
				}
				if(!vueObj.person.role){
					toast("请选择角色");
					return;
				}
				showWaiting();
				webCall2("/app/delivery/ums/dms/user/addOrUpdate", {
					dmsUserId: vueObj.person.id,
					mobilePhone: vueObj.person.mobilePhone,
					userName: vueObj.person.userName,
					role: vueObj.person.role,
					status: vueObj.person.status===0 ? 0 : 1,
				}, DO_SAVE, vueObj.onSuccess, vueObj.onErrorBefore);
				break; 
			case 'delete': //删除
				if(!vueObj.person.id || vueObj.person.changeRole == 1) return;
				confirmDialog('', "删除后将无法找回，确认删除吗?", "确定", "取消", function(){
					showWaiting();
					webCall2("/app/delivery/ums/dms/user/delete", {
						dmsUserId: vueObj.person.id,
					}, DO_DELETE, vueObj.onSuccess, vueObj.onErrorBefore);
				}, null);
				break;	
			default:
				break;
			}
		}
	}
});