//请求码
var QUERY_DETAIL = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		detailId: null, //文章ID
		detailData: {}, //数据
		protocol:false,//是否是协议
		source:"",//来源  walletQuestion 钱包常见问题
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			var self = plus.webview.currentWebview();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.detailId = plus.webview.currentWebview().detailId;
			vueObj.source = plus.webview.currentWebview().source;
			vueObj.protocol = plus.webview.currentWebview().protocol;
			//加载数据
			vueObj.loadData();
			//拦截超链接
			self.overrideUrlLoading({ 
				mode: "reject",
				effect: "touchstart"
			}, function(e) {
				// 拦截新的页面在新的webview里面加载URL页面
				if(!e.url) return;
				if(e.url.indexOf("tel:") == 0){
					plus.device.dial(e.url.substring(4), true);
					return;
				}
				if(e.url.indexOf("http") < 0) return;
				openWindow(e.url, '../common/web_page.html', false, {
					"webUrl": e.url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			});
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting();
			var url;
			// 加载钱包常见问题数据
			if(vueObj.source == "walletQuestion"){
				url = "/compus/article/faq/getDetail";
			} else {
				url = "/compus/article/getArticleDetail";
			}
			webCall2(url, {articleId: vueObj.detailId}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DETAIL: //数据加载
				vueObj.detailData = data.data;
				if(vueObj.protocol == "walletProtocol"){  
					document.getElementById("title").innerHTML = vueObj.detailData && vueObj.detailData.title ? vueObj.detailData.title :'';
				} else {
					document.getElementById("title").innerHTML = "常见问题";
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});