var DO_SUBMIT = 1001
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		type: null,
		title: '',
		value: '',
		editIndex: -1
	},
	beforeMount: function() {
		mui.plusReady(function(){
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.type = plus.webview.currentWebview().type;
			vueObj.title = plus.webview.currentWebview().title;
			vueObj.value = plus.webview.currentWebview().value;
			vueObj.editIndex = plus.webview.currentWebview().editIndex;
			//初始化界面
			document.getElementById("title").innerText = "设置" + vueObj.title;
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_SUBMIT: //提交
				//通知父页面输入结果
				mui.fire(plus.webview.currentWebview().opener(), "onInfoEditCallback", {
					type: vueObj.type,
					value: vueObj.value
				});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 输入监听
		 */
		onInput: function(e){
			if(vueObj.type === 'deliveryPriceStr'){
				var value = e.currentTarget.value;
				//去除特殊字符
				value = value.replace(/[^0-9.]/g, '');
				e.currentTarget.value = value;
				//控制输入两位小数
				value = value + '';
				var values = value.split('.');
				if(values.length > 1) {
					if(values[1].length > 2) {
						value = values[0] + '.' + values[1].substring(0, 2);
					} else {
						value = values[0] + '.' + values[1];
					}
				} else {
					value = values[0];
				}
				if(values.length > 1 && (values[0].length <= 0 || values[0] == "")) {
					value = "0.";
				}
				vueObj.value = value;
				e.currentTarget.value = value;
			}else if(vueObj.type === 'userMaxCapacityNum' || vueObj.type === 'unCheckExpireTime' || vueObj.type === 'unTakeExpireTime'){
				var value = e.currentTarget.value;
				//去除特殊字符
				value = value.replace(/[^0-9]/g, '');
				vueObj.value = value;
				e.currentTarget.value = value;
			}
		}
	}
});

//保存按钮监听
document.getElementById("saveBtn").addEventListener("tap", function(e){
	vueObj.value = commonTrim(vueObj.value);
	if(!vueObj.value){
		toast("请输入" + vueObj.title);
		return;
	}
	document.activeElement.blur();
	var reqUrl;
	var params = {};
	if(vueObj.type === 'userMaxCapacityNum' || vueObj.type === 'unCheckExpireTime' || vueObj.type === 'unTakeExpireTime'){
		reqUrl = "/app/dms/delivery/company/doUpdate";
		vueObj.value = parseInt(vueObj.value);
		params[vueObj.type] = vueObj.value;
	}
	//执行接口
	showWaiting();
	webCall2(reqUrl, params, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore);
});