mui.init({
	//监听返回事件
	beforeback: function() {
		setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
		return true;
	}
}); 
// DOMContentloaded事件处理
document.addEventListener("DOMContentLoaded",function(){
	em=document.getElementById("map");
	window.plus&&plusReady();
},false);

if(window.plus){
	plusReady();
}else{
	document.addEventListener("plusready", plusReady, false);
}
var self=null, wo=null;
var em=null, map=null;
var zoom = 16;//地图缩放比例 默认:16
var curUserPosition; //用户当前位置
var shopsPosition; //商家坐标
// H5 plus事件处理
function plusReady(){ 
	//状态栏设置
	setStatusBarDefault();
	plus.webview.currentWebview().addEventListener("popGesture", function(e) {
		if(e.type == 'start'){ //侧滑开始
			setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
		}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
			setStatusBarDefault();
		}
	}, false);
	
	if(!em || self){return};
	// 获取窗口对象
	self=plus.webview.currentWebview();
	wo=self.opener();
	//如果传进来的坐标系为WGS-84 转换为GCJ-02
	if(self.coordsType && self.coordsType == "WGS-84"){
		var pointResutl = GPS.gcj_encrypt(self.latitude, self.longitude);
		self.latitude = pointResutl.lat;
		self.longitude = pointResutl.lon;
	}
	document.getElementById("title").innerText = self.address ? self.address : '校帅';
	// 显示页面并关闭等待框
    map = new plus.maps.Map("map");
    setShopsLocation();
    setUserLocation();    
}
/*
 * 定位当前用户位置
 */
function setUserLocation(){
	map.showUserLocation(true);
	map.getUserLocation(function(state,pos){
		if(0==state){
			curUserPosition = pos;
		} else {
			toast("定位失败，请检查您的定位权限或打开GPS重试");
		}
		setMapCenterAndZoom();
	});
}
/*
 * 设置商家位置
 */
function setShopsLocation(){
	shopsPosition = new plus.maps.Point(self.longitude, self.latitude);
	var marker = new plus.maps.Marker(shopsPosition);
	var iconUrl = "_www/ui/common/images/location_icon";
	if(plus.os.name == 'iOS'){
		iconUrl = iconUrl + ".png";
	}else{
		if(plus.screen.scale >= 3) iconUrl = iconUrl + "@3x.png";
		else if(plus.screen.scale ==2)  iconUrl = iconUrl + "@2x.png";
		else  iconUrl = iconUrl + ".png";
	}
	marker.setIcon(iconUrl);
	var bubble = new plus.maps.Bubble(self.address);
	marker.setBubble(bubble);
	map.addOverlay(marker);
	
	// 用户点击气泡将弹出气泡上的标题信息
	bubble.onclick = function(bubble) {
		var marker = bubble.belongMarker();
		startNavi(marker.getPoint(), bubble.getLabel());
	};
}

//设置地图中心和缩放级别 通过用户和商家的距离 计算地图缩放级别
function setMapCenterAndZoom(){
	if(curUserPosition.longitude && curUserPosition.latitude && shopsPosition.getLat() && shopsPosition.getLng()) {
		var dis = GPS.distance(shopsPosition.latitude, shopsPosition.longitude, curUserPosition.latitude, curUserPosition.longitude);
		if(dis > 2000000) {
			zoom = 4;
		} else if(dis > 1000000) {
			zoom = 5;
		} else if(dis > 500000) {
			zoom = 6;
		} else if(dis > 200000) {
			zoom = 7;
		} else if(dis > 100000) {
			zoom = 8;
		} else if(dis > 50000) {
			zoom = 9;
		} else if(dis > 25000) {
			zoom = 10;
		} else if(dis > 20000) {
			zoom = 11;
		} else if(dis > 10000) {
			zoom = 12;
		} else if(dis > 5000) {
			zoom = 13;
		} else if(dis > 2000) {
			zoom = 14;
		} else if(dis > 1000) {
			zoom = 15;
		} else if(dis > 500) {
			zoom = 16;
		} else if(dis > 200) {
			zoom = 17;
		} else if(dis > 0) {
			zoom = 18;
		}
	}
	if(curUserPosition && !shopsPosition){
		map.centerAndZoom(curUserPosition, zoom);
		return;
	}
	map.centerAndZoom(shopsPosition, zoom);
}

/*destPt(longitude, latitude): 目的地经纬度, navDesc: 描述，eg:卸货目的地*/
function startNavi(destPt, navDesc) {
	if (plus.os.name == "iOS") {
		//导入导航类
        var PhoneGPSViewController = plus.ios.importClass("PhoneGPSViewController");
        //创建导航实例对象
        var phoneGpsVC = plus.ios.newObject("PhoneGPSViewController");
        phoneGpsVC.plusSetAttribute("endX", parseFloat(destPt.latitude));
        phoneGpsVC.plusSetAttribute("endY",parseFloat(destPt.longitude));
        plus.ios.invoke(phoneGpsVC,"startNav");
	} else {
		if(!checkUserPermission("LOCATION", null, function(){
			startNavi(destPt, navDesc);
		})){
			setNoDataBackground("main", true);
			return null;
		} 
		// 弹出导航选择对话框
		var nowCoord = getNowPositionCoord();//longitude, latitude
		var convert = {"lat": destPt.latitude, "lon": destPt.longitude};
		var convertNow = {"lat": nowCoord.latitude, "lon": nowCoord.longitude};
		navigationChoose(convert, navDesc, convertNow);
	}
}
/*
 * 获取当前用户位置
 */
function getNowPositionCoord(){//longitude, latitude
	plus.geolocation.getCurrentPosition(function(p) {
		setCache(LOCATION_POSITION_KEY, JSON.stringify(p));
	}, function(e) {
		toast("定位失败，请检查您的定位权限或打开GPS重试");
		setNoDataBackground("main", true);
	}, {
		provider: 'amap', //amap>baidu>system
		coordsType: 'gcj02'
	});
	var nowPos = JSON.parse(getCache(LOCATION_POSITION_KEY));
	if (nowPos && nowPos.coords){
		return nowPos.coords;
	}
	return null;
}

/*
* 开始定位
*/

function startPosition() {
	plus.geolocation.getCurrentPosition(function(p) {
		setCache(LOCATION_POSITION_KEY, JSON.stringify(p));
	}, function(e) {
		toast("定位失败，请检查您的定位权限或打开GPS重试");
	}, {
		provider: 'amap', //amap>baidu>system
		coordsType: 'gcj02'
	});
}