/** 网络请求码 */
var QUERY_ORDER_INFO = 1001, QUERY_TAKE_MEAL = 1002, QUERY_SORT_CENTER = 1003;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		imgResizeParam: imgResizeParam,
		dmsUserRole: null, //配送人员角色 1管理员 2取餐员 3分拣员 4分送员 5跑楼员 
		orderNo:'',//订单id
		orderInfo: {},
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			window.addEventListener("onOrderDataUpdate", function(event){
				vueObj.loadOrderInfo();
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//角色
			vueObj.dmsUserRole = getUserInfo().dmsUserRole;
			vueObj.orderNo = plus.webview.currentWebview().orderNo;
			vueObj.loadOrderInfo();
		});
	},
	methods: {
		/*
		 * 设置二维码
		 */
		setQRCodeObj: function(){
			document.getElementById("qrcode").innerHTML = "";
			var qrCodeObj = new QRCode(document.getElementById("qrcode"), {
				width: "120",
				height: "120",
			});
			qrCodeObj.makeCode("oms" + vueObj.orderInfo.orderNo);
		},
		/**
		 * 订单信息查询
		 */
		loadOrderInfo: function(){
			if(!vueObj.orderNo) return;
			showWaiting();
			webCall2("/app/delivery/oms/order/orderDetail", {orderNo: vueObj.orderNo}, QUERY_ORDER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ORDER_INFO: //查询订单信息
				vueObj.orderInfo = data.data;
				vueObj.setQRCodeObj();
				//管理员 待取餐或待分拣的订单 显示转派按钮
				if(vueObj.dmsUserRole === 1 && (vueObj.orderInfo.deliveryDetailStatus===40||vueObj.orderInfo.deliveryDetailStatus===50)){
					document.getElementById("transferBtn").style.display = "block";
				}
				break;
			case QUERY_TAKE_MEAL: //确认取餐
				toast("取餐成功");
				vueObj.loadOrderInfo()
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});	
				if(plus.webview.getWebviewById("scan")) {
					mui.fire(plus.webview.getWebviewById("scan"), "onOrderDataChange", {});
				}
				break;
			case QUERY_SORT_CENTER: //送达分拣中心
				toast("送达成功");
				vueObj.loadOrderInfo();
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});	
				break;
			default:
				break;
			} 
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "copy": //复制
				copyLink(vueObj.orderNo);
				break;	
			case "tel": //打电话
				plus.device.dial(vueObj.orderInfo.phone, true);
				break;
			case "takeTel": //取餐员电话
				plus.device.dial(e.currentTarget.dataset.number, true);
				break;
			case "takeMeal": //取餐
				showWaiting();
				webCall2("/app/delivery/oms/order/takeMeal", {orderNo: vueObj.orderNo}, QUERY_TAKE_MEAL, vueObj.onSuccess, vueObj.onErrorBefore);
				break;	
			case "service": //送达分拣中心
				showWaiting();
				webCall2("/app/delivery/oms/order/inSortingCenter", {orderNo: vueObj.orderNo}, QUERY_SORT_CENTER, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			default:
				break;
			}
		},
	}
});
//订单转派
document.getElementById("transferBtn").addEventListener("tap", function(){
	openWindow("orderTransfer", "../home/order_transfer.html", false, {
		orderNo: vueObj.orderNo,
		userName: vueObj.orderInfo.takeName,
		takeDmsId: vueObj.orderInfo.takeDmsId,
		statusBarType: STATUS_BAR_DEFAULT_KEY
	});
});