/** 网络请求码 */
var QUERY_ADS = 1001, QUERY_ORDER_INFO = 1003;
var reqOrderNum = 0;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		orderInfo: {},
		tranNo: null,
		appName: null,
		payType: null,
		money: null,
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		bindCardStatus: -1 //绑卡状态 1已经绑卡 0未绑卡
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
			});
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			//参数接收
			vueObj.tranNo = plus.webview.currentWebview().tranNo;
			vueObj.payType = plus.webview.currentWebview().type;
			vueObj.money = plus.webview.currentWebview().money;
			vueObj.appName = plus.webview.currentWebview().appName;
			//查询广告
			showWaiting();
			webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList:"1004,5003"}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
			//通知订单页
			var orderDetailWeb = plus.webview.getWebviewById("orderDetail");
			var orderListWeb = plus.webview.getWebviewById("orderList");
			if(orderDetailWeb){
				mui.fire(orderDetailWeb, "onOrderChange", {});
			}
			if(orderListWeb){
				mui.fire(orderListWeb, "onOrderChange", {});
			}
			//判断是否第三方调起
			if(vueObj.appName == 'HMZKAPP'){
				confirmDialog("", "支付成功，是否返回【恒镁智卡】APP?", "返回", "留在校帅", function(){
					plus.runtime.openURL("hmxd://third/yunma?code=01");
				});
				return;
			}
			vueObj.loadOrderInfo();
		});
	},
	methods: {
		/**
		 * 订单信息查询
		 */
		loadOrderInfo: function(){
			if(!vueObj.tranNo || reqOrderNum >= 10) return;
			webCall2("/routepay/route/order/getOrderCache", {tranNo: vueObj.tranNo}, QUERY_ORDER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			reqOrderNum++;
		},
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ORDER_INFO: //查询订单信息
				vueObj.orderInfo = data.data;
				if(vueObj.orderInfo.redbagSendStatus != 1) return;
				setTimeout(function(){
					vueObj.loadOrderInfo();
				}, 1200);
				break;
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.data["1004"];
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				});
				//查询红包弹窗信息
				var popData = data.data['5003'] && data.data['5003'].length > 0 ? data.data['5003'] : null;
				if(!popData) return;
				//构造弹窗
				var marketingPop = plus.webview.create('../app/marketing_pop.html', 'marketing_pop', {
					top: '0', bottom: '0', background: 'transparent',contentAdjust: false
				},{
					marketingObj:popData, statusBarType:STATUS_BAR_DEFAULT_KEY
				});
				plus.webview.currentWebview().append(marketingPop);
				marketingPop.hide();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			onCommonBannerClick(JSON.parse(e.currentTarget.dataset.item), "支付成功页", null, null, STATUS_BAR_DEFAULT_KEY);
		},
		/**
		 * 分转元
		 */
		centToYuan: function(cent){
			return centToYuan(cent);
		},
		/**
		 * 红包点击
		 */
		onRedbagClick: function(){
			openWindow("walletRedbag", "../wallet/wallet_redbag.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		}
	}
});