var dtpicker;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		hideMode: true, //是否隐藏类型
		isMust:false, //时间是否必选
		mode: 1, //1 按月选择 2按日选择
		timeMode: 1, //1 开始时间 2结束时间
		monthTime:'',//选择的月时间
		startTime:'',//开始时间
		endTime:'',//结束时间
		sourceId:'',//来源 orderList交易记录
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				} 
			}, false);
			mui('.mui-scroll-wrapper').scroll();
			vueObj.hideMode = plus.webview.currentWebview().hideMode;
			vueObj.mode = plus.webview.currentWebview().mode ? plus.webview.currentWebview().mode : vueObj.mode;
			vueObj.isMust = plus.webview.currentWebview().isMust ? plus.webview.currentWebview().isMust : vueObj.isMust;
			vueObj.sourceId = plus.webview.currentWebview().sourceId;
			//当前时间 年月
			if(plus.webview.currentWebview().mode == 1){
				vueObj.startTime = formatDate(new Date().getTime()).substring(0,10);
				vueObj.monthTime = plus.webview.currentWebview().monthTime;
			} else if(plus.webview.currentWebview().mode == 2){
				vueObj.monthTime = formatDate(new Date().getTime()).substring(0,7);
				vueObj.startTime = plus.webview.currentWebview().startTime ? plus.webview.currentWebview().startTime : '';
				vueObj.endTime = plus.webview.currentWebview().endTime ? plus.webview.currentWebview().endTime : '';
			} else {
				vueObj.monthTime = formatDate(new Date().getTime()).substring(0,7);
				vueObj.startTime = formatDate(new Date().getTime()).substring(0,10);
			}
			vueObj.selectDate(vueObj.mode == 2 ? vueObj.startTime : vueObj.monthTime);
		}); 
	},
	methods: {
		/**
		 * 选择日期
		 */
		selectDate: function(time) {
			if(dtpicker == null){
				var beginDate = new Date(2020, 0, 1);
				var endDate = new Date(); 
				dtpicker = new mui.DtPicker({
				    type: vueObj.mode == 2 ? "date" : 'month',//设置日历初始视图模式  
				    beginDate: beginDate,//设置开始日期 
				    endDate: endDate,//设置结束日期 
				    value: time,
				}); 
			}
			dtpicker.show(function(e) {
				console.error(JSON.stringify(e))
			}, function(selectedItem){
				if(vueObj.mode == 1){
					if(selectedItem.value == vueObj.monthTime) return;
					vueObj.monthTime = selectedItem.value;
					return;
				}
				if( vueObj.timeMode == 1){
					if(selectedItem.value == vueObj.startTime) return;
					vueObj.startTime = selectedItem.value;
				} else {
					if(selectedItem.value == vueObj.endTime) return;
					vueObj.endTime = selectedItem.value;
				}
			});
		},
		/*
		 * 
		 */
		onBunttonClick: function(e){
			switch (e.currentTarget.dataset.type){
				case 'switch':
					vueObj.pickerDispose();
					vueObj.mode = vueObj.mode == 1 ? 2 : 1;
					vueObj.selectDate(vueObj.mode == 1 ? vueObj.monthTime : (vueObj.timeMode==1?vueObj.startTime:vueObj.endTime));
					break;
				case 'monthTime':
					if(dtpicker) return;
					vueObj.selectDate(vueObj.monthTime);
					break;	
				case 'startTime':
					if(dtpicker && vueObj.timeMode == 1) return;
					vueObj.pickerDispose();
					vueObj.timeMode = 1;
					vueObj.selectDate(vueObj.startTime);
					break;
				case 'endTime':
					if(dtpicker && vueObj.timeMode == 2) return;
					vueObj.pickerDispose();
					vueObj.timeMode = 2;
					vueObj.selectDate(vueObj.endTime);
					break;	
				case 'delete':
					vueObj.pickerDispose();
					if(vueObj.mode == 2){
						vueObj.startTime = null;
						vueObj.endTime = null;
					} else {
						vueObj.monthTime = null;
					}
					break;	
				default:
					break;
			}
		},
		/*
		 * 注销picker
		 */
		pickerDispose: function(){
			if(!dtpicker) return;
			var pickers = document.getElementsByClassName('mui-dtpicker');
			if(!pickers || pickers.length <= 0) return;
			pickers[0].style.display = 'none';
			dtpicker.dispose();
			dtpicker = null;
		},
		/*
		 * 计算时间跨度是否为超出6个月
		 */
		calTimeDistance: function(){
			if(vueObj.sourceId != "orderList" || vueObj.mode != 2)return false;
			if(!vueObj.startTime || !vueObj.endTime) return false;
			var newYear1 = parseInt(vueObj.startTime.replace(/-/g,"").substring(0, 4));
			var newYear2 = parseInt(vueObj.endTime.replace(/-/g,"").substring(0, 4));
			var newMonth1 = parseInt(vueObj.startTime.replace(/-/g,"").substring(4, 6));
			var newMonth2 = parseInt(vueObj.endTime.replace(/-/g,"").substring(4, 6));
		   	var x = newYear2 - newYear1;
   			newMonth2 = newMonth2+13*x;
			if(Math.abs(newMonth2 - newMonth1) > 6) {
				return true
			}
			return false;
		},
	}
});
//取消按钮监听
document.getElementById("cancelBtn").addEventListener("tap", function(e){
	setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
	closeWebview(plus.webview.currentWebview().id);
});
//保存按钮监听
document.getElementById("saveBtn").addEventListener("tap", function(e){
	//时间必选
	if(vueObj.isMust){
		if(vueObj.mode == 1 && !vueObj.monthTime){
			toast("请选择时间");
			return;
		}
		if(vueObj.mode == 2){
			if(!vueObj.startTime){
				toast("请选择开始时间");
				return;
			}
			if(!vueObj.endTime){
				toast("请选择结束时间");
				return;
			}
		}
	}
	//判断时间跨度
	if(vueObj.calTimeDistance()) {
		plus.nativeUI.alert("选择的时间范围超过了6个月, 请缩小范围后重试", null, null, "知道了");
		return;
	}
	var tempStartTime = vueObj.startTime;
	var tempEndTime = vueObj.endTime;
	if(vueObj.mode == 2) {
		if(vueObj.startTime && vueObj.endTime){
			var startTimeNum = parseFloat(tempStartTime.replace(/-/g,""));
			var endTimeNum = parseFloat(tempEndTime.replace(/-/g,""));
			tempStartTime = startTimeNum > endTimeNum ? vueObj.endTime : vueObj.startTime;
			tempEndTime= startTimeNum > endTimeNum ? vueObj.startTime : vueObj.endTime;
		} else {
			tempStartTime = vueObj.startTime ? vueObj.startTime : vueObj.endTime;
			tempEndTime = '';
		}
	}
	mui.fire(plus.webview.currentWebview().opener(),'onDateUpdate',{
		mode:vueObj.mode,
		monthTime: vueObj.mode == 1 ? vueObj.monthTime : '' ,
		startTime: tempStartTime,
		endTime: tempEndTime,
	});
	setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
	closeWebview(plus.webview.currentWebview().id);
});