//请求码
var QUERY_DATA = 1001;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		provinceCode: null, //传递的参数
		provinceName: null, //传递的参数
		cityCode: null, //传递的参数
		cityName: null, //传递的参数
		areaCode: null, //传递的参数
		areaName: null, //传递的参数
		type: null, //加载类型：province city area
		datas: [], //数据
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.type == 'province') setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					if(vueObj.type == 'province') setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//获取参数
			var self = plus.webview.currentWebview();
			vueObj.provinceCode = self.provinceCode;
			vueObj.provinceName = self.provinceName;
			vueObj.cityCode = self.cityCode;
			vueObj.cityName = self.cityName;
			vueObj.areaCode = self.areaCode;
			vueObj.areaName = self.areaName;
			vueObj.type = self.type;
			//加载数据
			showWaiting();
			var title, url, params;
			if(vueObj.type == 'province'){
				title = "选择省份";
				url = "/common/area/getProvinceList";
			}else if(vueObj.type == 'city'){
				title = "选择城市";
				url = "/common/area/getCityList";
				params = {provinceCode:vueObj.provinceCode};
			}else if(vueObj.type == 'area'){
				title = "选择区";
				url = "/common/area/getAreaList";
				params = {cityCode:vueObj.cityCode};
			}
			document.getElementById("title").innerText = title;
			webCall2(url, params, QUERY_DATA, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 列表点击按钮
		 */
		onItemClick: function(e){
			var selectId = e.currentTarget.dataset.id;
			var selectText = e.currentTarget.dataset.text;
			if(vueObj.type == 'province'){
				openWindow("selectCity", "select_list.html", false, {
					webviewId:plus.webview.currentWebview().webviewId,
					type: "city",
					provinceCode: selectId,
					provinceName: selectText,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
			}else if(vueObj.type == 'city'){
				openWindow("selectArea", "select_list.html", false, {
					webviewId:plus.webview.currentWebview().webviewId,
					type: "area",
					provinceCode: vueObj.provinceCode,
					provinceName: vueObj.provinceName,
					cityCode: selectId,
					cityName: selectText,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
			}else if(vueObj.type == 'area'){
				//触发监听事件
				var userInfoMoreWeb = plus.webview.getWebviewById("userInfoMore");
				if(userInfoMoreWeb) {
					mui.fire(userInfoMoreWeb,"onAddressSelect", {
						areaCode: selectId,
						areaName: selectText,
						cityCode: vueObj.cityCode,
						cityName: vueObj.cityName,
						provinceCode: vueObj.provinceCode,
						provinceName: vueObj.provinceName
					});
				}
				var webview = plus.webview.getWebviewById(plus.webview.currentWebview().webviewId);
				if(webview) {
					mui.fire(webview,"onAddressSelect", {
						areaCode: selectId,
						areaName: selectText,
						cityCode: vueObj.cityCode,
						cityName: vueObj.cityName,
						provinceCode: vueObj.provinceCode,
						provinceName: vueObj.provinceName
					});
				}
				//关闭页面
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				closeWebview("selectProvince");
				closeWebview("selectCity");
				closeWebview("selectArea");
			}
		},
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_DATA: //数据加载
				vueObj.datas = data.rows;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});