var self;
//初始化 分享模块Vue
var vueObj = new Vue({
	el: '#morePopover',
	data: {
		shareTitle: '',
		shareContent: '',
		href: 'https://h5.xiaofubao.com/dms',
		title: '校帅',
		content: '校园专送，使命必达',
		imgUrl: '_www/img/logo_small.png',
		type: null,
		osName: null
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				mui("#morePopover").popover('toggle');
				plus.webview.currentWebview().hide();
				return false;
			}
		});
		mui.plusReady(function(){
			vueObj.osName = plus.os.name;
			self = plus.webview.currentWebview();
			initShareServices(self.opener());
			//监听分享弹框变化
			window.addEventListener("showMorePop", function(event){
				if(event.detail.shareTitle) vueObj.shareTitle = event.detail.shareTitle;
				if(event.detail.shareContent) vueObj.shareContent = event.detail.shareContent;
				if(event.detail.href) vueObj.href = event.detail.href;
				if(event.detail.title) vueObj.title = event.detail.title;
				if(event.detail.content) vueObj.content = event.detail.content;
				if(event.detail.imgUrl) vueObj.imgUrl = event.detail.imgUrl;
				vueObj.type = event.detail.type;
				vueObj.showHidePop();
			});
			//监听调用事件
			window.addEventListener("onShareCallListener", function(event){
				if(event.detail.shareTitle) vueObj.shareTitle = event.detail.shareTitle;
				if(event.detail.shareContent) vueObj.shareContent = event.detail.shareContent;
				if(event.detail.href) vueObj.href = event.detail.href;
				if(event.detail.title) vueObj.title = event.detail.title;
				if(event.detail.content) vueObj.content = event.detail.content;
				if(event.detail.imgUrl) vueObj.imgUrl = event.detail.imgUrl;
				vueObj.type = event.detail.type;
				if(event.detail.hideDialog){
					return;
				}
				vueObj.showHidePop();
			});
			//监听微信登录调用事件
			window.addEventListener("onWechatLoginCallListener", function(event){
				onWechatLogin();
			});
		});
	},
	methods: {
		/**
		 * 显示页面
		 */
		showHidePop: function(){
			var sharePop = document.getElementById("morePopover");
			if(sharePop.classList.contains('mui-active')) {
				mui("#morePopover").popover('toggle');
				self.hide();
			} else {
				self.show();
				mui("#morePopover").popover('toggle');
			}
		},
		/*
		 * 分享
		 */
		onShare: function(e) {
			if(!vueObj.imgUrl) vueObj.imgUrl = "_www/img/logo_small.png";
			var params = {
				"href": vueObj.href,
				"title": vueObj.title,
				"content": vueObj.content,
				"imgUrl": vueObj.imgUrl,
				"type": vueObj.type
			}
			//添加统计
			statisticEvent("appShareClick", {type:(e.currentTarget.dataset.type+"_"+vueObj.title)});
			switch(e.currentTarget.dataset.type) {
				case "weixin":
					shareToWeixin(params);
					break;
				case "qq":
					shareToQQ(params);
					break;
				case "group":
					shareToWeixinGroup(params);
					break;
				case "weibo":
					shareToWeibo(params);
					break;
				default:
					break;
			}
			//界面消失
			self.hide();
		},
		onButtonClick: function(e){
			switch (e.currentTarget.dataset.type){
				case "web": //在浏览器中打开
				case "copy": //复制链接
				case "refresh": //刷新页面
					mui.fire(self.opener(),'onMoreDialogListener',{type:e.currentTarget.dataset.type})
					break;
				default:
					break;
			}
			//界面消失
			self.hide();
		},
		onDialogClick: function(){
		}
	}
	
});
//取消按钮点击
mui("#morePopover").on("tap", ".more-cancel-btn", function(e) {
	mui("#morePopover").popover('toggle');
	self.hide();
});
//蒙层点击
mui("html").on("tap", "body", function(e) {
 	mui("#morePopover").popover('toggle');
 	self.hide();
 	var sharePop = document.getElementById("morePopover");
 	sharePop.classList = "mui-popover more-popover";
});
