//请求码
var QUERY_TAKE_DATA = 1001, QUERY_CHECK_DATA = 1002, QUERY_TAKE_PHONE = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		takerDatas:[],//超时取餐员列表
		shopDatas:[],//超时商家列表
		checkDatas:[],//分拣员列表
		unusualType: null,//异常订单类型 1核验超时 2取餐超时
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			vueObj.unusualType = plus.webview.currentWebview().unusualType;
			document.getElementById("title").innerHTML = vueObj.unusualType==1?'核验超时':'取餐超时';
			if(vueObj.unusualType==1){
				webCall2("/app/delivery/oms/statistics/sortingWorkList", {}, QUERY_CHECK_DATA, vueObj.onSuccess, vueObj.onErrorBefore);
			} else {
				webCall2("/app/delivery/oms/statistics/deliveryTakeUnusualStatistics", {}, QUERY_TAKE_DATA, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		});
	},
	methods: {
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_TAKE_DATA: //取餐超时统计数据
				vueObj.takerDatas = data && data.data && data.data.takeUnusualUserDataList ? data.data.takeUnusualUserDataList : [];
				vueObj.shopDatas =  data && data.data && data.data.takeUnusualShopDataList ? data.data.takeUnusualShopDataList : [];
				document.getElementById("noContent").style.display = (vueObj.takerDatas.length + vueObj.shopDatas.length)===0 ? "" : "none";
				break;
			case QUERY_CHECK_DATA: //分拣员列表
				vueObj.checkDatas = data.rows;
				document.getElementById("noContent").style.display = vueObj.checkDatas.length === 0 ? "" : "none";	
				break;	
			case QUERY_TAKE_PHONE: //获取骑手电话
				plus.device.dial(data.data, true);
				break;	
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "item": //搜索
				openWindow("homeOrderList", "home_order_list.html", false, {
					isUnusual:0,
					takeDmsId:e.currentTarget.dataset.dmsId,
					shopId:e.currentTarget.dataset.shopId,
					unusualType: vueObj.unusualType,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			case "tel": //订单点击
				showWaiting();
				webCall2("/app/delivery/ums/dms/user/getMobileById", {dmsUserId:e.currentTarget.dataset.dmsId}, QUERY_TAKE_PHONE, vueObj.onSuccess, vueObj.onErrorBefore);
				break;	
			default:
				break; 
			}
		},
	}
});