var myScrolls = [], sliderIndex = 0, isLoadingMore = [], isNoMore = [], starts = [], isPullDonw = [];
/** 网络请求码 */
var QUERY_DMS_USER = 1001, GO_WORK = 1002, OFF_WORK = 1003, QUERY_BATCH_CENTER = 1004, QUERY_SORT_CENTER = 1005, QUERY_DELIVER_NUM = 1006, QUERY_CALL_ALL = 1007, QUERY_CALL_ONE = 1008;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		dmsUserRole: null, //配送人员角色 1管理员 2取餐员 3分拣员 4分送员 5跑楼员
		tabs: [], //tab列表，根据身份类型来
		datas: [],
		netWorkTips: true,
		batchTotal:0,//批量送达分拣中心 总数
	},
	beforeMount: function() {
		mui.plusReady(function() {
			// 关闭侧滑返回功能
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE || plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_UNKNOW) {
				vueObj.netWorkTips = true;
			}
			plus.navigator.closeSplashscreen();
			//静默登录信息变更
			window.addEventListener("onUserInfoChange", function(event){
				vueObj.dmsUserRole = getUserInfo().dmsUserRole;
				if(vueObj.dmsUserRole===1){openHomeMainHtml(true);}
			});
			window.addEventListener("onOrderDataChange", function(event){
				//取餐员  分拣员  跑楼员
				if(vueObj.dmsUserRole === 2 || vueObj.dmsUserRole === 3 || vueObj.dmsUserRole === 5){
					starts[0] = 0;
					vueObj.pulldownRefresh(0);
					if(vueObj.dmsUserRole === 5) return;
					starts[1] = 0;
					vueObj.pulldownRefresh(1);
				}
			});
			vueObj.onSimplePwdTips();
			//界面初始化
			vueObj.initUI();
			//加载配送用户信息
			webCall2("/app/delivery/ums/dms/user/getDetailById", {dmsUserId:getUserInfo().dmsUserId}, QUERY_DMS_USER, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
		});
	},
	methods: {
		/*
		 * 密码简单提示
		 * 0需要提醒 1已提醒
		 */
		onSimplePwdTips: function(){
			if(getCache("isSimplePwdTips") != 0) return;
			setCache("isSimplePwdTips", 1);
			confirmDialog("温馨提示", "由于您的密码过于简单, 为了您的账户安全，请及时修改密码！", "取消", "去修改", null, function(){
				openWindow("modifyPwd", "../login/modify_pwd.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
			});
		},
		initUI: function(){
			vueObj.setClockStatus();
			//角色
			vueObj.dmsUserRole = getUserInfo().dmsUserRole;
			if(vueObj.dmsUserRole === 1){
				document.getElementById("clockBtn").style.display = "none";
			}
			if(vueObj.dmsUserRole === 5){
				document.getElementById("arriveBtn").style.display = "none";
			}
			//标题
			var userRoleName = "我是" + (vueObj.dmsUserRole===1?'管理员':(vueObj.dmsUserRole===2?'取餐员':(vueObj.dmsUserRole===3?'分拣员':
				(vueObj.dmsUserRole===4?'分送员':'跑楼员'))));
			document.getElementById("userRoleName").innerText = userRoleName;
			//tab初始化
			if(vueObj.dmsUserRole===1){ //管理员
				vueObj.tabs = [{name:'待派单',status:30},{name:'待取餐',status:40},{name:'待分拣',status:50},{name:'待核验',status:60},{name:'待送达',status:70},{name:'异常订单',status:-1}];
			}else if(vueObj.dmsUserRole===2){ //取餐员
				vueObj.tabs = [{name:'待取餐',status:40},{name:'待分拣',status:50},{name:'异常订单',status:40,isUnusual:0}, {name:'待出餐',status:90}];
			}else if(vueObj.dmsUserRole===3){ //分拣员
				vueObj.tabs = [{name:'待核验',status:60},{name:'待分拣',status:50},{name:'异常订单',status:-1}];
			}else if(vueObj.dmsUserRole===4){ //分送员
				vueObj.tabs = [];
			}else if(vueObj.dmsUserRole===5){ //跑楼员
				vueObj.tabs = [{name:'已送达',status:80}];
			}
			//初始化scroller
			Vue.nextTick(function(){
				initScroller();
			});
		},
		/**
		 * 下拉刷新具体业务实现
		 */
		pulldownRefresh: function(index) {
			//跑楼员 没有数据统计
			if(starts[index]===0 && vueObj.dmsUserRole!==5){
				//获取配送数量
				webCall2("/app/delivery/oms/order/deliveryStatisticsData", {}, QUERY_DELIVER_NUM, vueObj.onSuccess, vueObj.onErrorBefore);			
			}
			var status = vueObj.tabs[index].status;
			var reqUrl = "/app/delivery/oms/order/processListData";
			if(status === 30 || status === 40){
				reqUrl = "/app/delivery/oms/order/shopGroupList";
			}else if(status === -1 || status === 80){
				reqUrl = "/app/delivery/oms/order/detailListData";
			} else if(status === 90){
				reqUrl = "/app/delivery/oms/order/waitMealOutGroupList";
			}
			webCall2(reqUrl, {
				offset: starts[index],
				limit: 10,
				unusualType: status === -1 ? 1:null,
				deliveryDetailStatus: status === -1 || status === 90 ? null : status,
				isUnusual: status === -1 || vueObj.tabs[index].isUnusual===0 ? 0 : null
			}, "list"+index, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DMS_USER: //配送员信息
				vueObj.dmsUserInfo = data.data;
				setCache(DMS_USER_INFO_KEY, JSON.stringify(vueObj.dmsUserInfo));
				vueObj.setClockStatus();
				//提醒上班
				if(vueObj.dmsUserRole !== 1 && vueClock.workStatus === 2) {
					vueClock.showPop = true;
					vueClock.startTime();
				}
				break;
			case QUERY_DELIVER_NUM: //数量信息
				for(var i in vueObj.tabs){
					var item = vueObj.tabs[i];
					var name = item.name.substr(0, 3);
					if(item.status===30){
						item.name = name + (data.data.waitDispatchNumber>0?'('+data.data.waitDispatchNumber+')':'');
					}else if(item.status===-1){ //分拣员异常订单数量
						item.name = item.name.substr(0, 4) + (data.data.checkOvertimeNumber>0?'('+data.data.checkOvertimeNumber+')':'');
					}else if(item.status===40 && item.isUnusual===0){//取餐员异常订单数量
						item.name = item.name.substr(0, 4) + (data.data.takeOvertimeNumber>0?'('+data.data.takeOvertimeNumber+')':'');
					}else  if(item.status===40){
						item.name = name + (data.data.waitTakeNumber>0?'('+data.data.waitTakeNumber+')':'');
					}else if(item.status===50){
						item.name = name + (data.data.waitSortingNumber>0?'('+data.data.waitSortingNumber+')':'');
					}else if(item.status===60){
						item.name = name + (data.data.waitCheckNumber>0?'('+data.data.waitCheckNumber+')':'');
					}else if(item.status===70){
						item.name = name + (data.data.waitArrivedNumber>0?'('+data.data.waitArrivedNumber+')':'');
					}
					//使用Set方法更新数组
					Vue.set(vueObj.tabs, i, item);
				}
				break;	
			case GO_WORK: //上班
				toast("上班打卡成功");
				vueClock.showPop = false;
				vueObj.dmsUserInfo.workStatus = 1;
				setCache(DMS_USER_INFO_KEY, JSON.stringify(vueObj.dmsUserInfo));
				vueObj.setClockStatus();
				break;
			case OFF_WORK: //下班
				toast("下班打卡成功");
				vueClock.showPop = false;
				vueObj.dmsUserInfo.workStatus = 2;
				setCache(DMS_USER_INFO_KEY, JSON.stringify(vueObj.dmsUserInfo));
				vueObj.setClockStatus();
				break;
			case QUERY_SORT_CENTER: //单个送达分拣中心
				toast("送达成功");
				starts[1] = 0;
				vueObj.pulldownRefresh(1);
				break;		
			case QUERY_BATCH_CENTER: //批量送达分拣中心
				toast("送达成功");
				starts[sliderIndex] = 0;
				vueObj.pulldownRefresh(sliderIndex);
				break;
			case QUERY_CALL_ONE: //单个智能呼叫
				toast("智能呼叫请求已发出");
				break;	
			case QUERY_CALL_ALL: //一键呼叫
				toast("一键呼叫成功");
				break;		
			default:
				//判断当前数据是加载的第几个tab
				var oprationIndex = 0;
				for(var i=0; i<vueObj.tabs.length; i++){
					if(requestCode == ("list"+i)){
						oprationIndex = i;
						break;
					}
				}
				//待送达分拣中心总数
				if(vueObj.dmsUserRole==2&&vueObj.tabs[oprationIndex].status==50){
					vueObj.batchTotal = data.total ? data.total : 0;
				}
				//更新数据
				vueObj.datas[oprationIndex] = ( starts[oprationIndex] == 0 ? data.rows : vueObj.datas[oprationIndex].concat(data.rows));
				//使用Set方法更新数组
				Vue.set(vueObj.datas, oprationIndex, vueObj.datas[oprationIndex]);
				
				starts[oprationIndex] = vueObj.datas[oprationIndex].length;
				//无数据图
				document.getElementById("noContent" + oprationIndex).style.display = vueObj.datas[oprationIndex].length === 0 ? "" : "none";
				document.getElementById("item" + oprationIndex + "mobileSpan").style.display = vueObj.datas[oprationIndex].length < 4 ? "none" : "";
				vueObj.closePullStatus(data.rows, oprationIndex);	
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			if((requestCode+"").indexOf("list") === 0){
				vueObj.closePullStatus();
				for(var i=0; i<vueObj.tabs.length; i++){
					if(starts[i] == 0 && requestCode == ("list"+i)){
						document.getElementById("item" + i + "mobileSpan").style.display = "none";
					}
				}
				return;
			}
			if(requestCode != QUERY_DMS_USER && requestCode != QUERY_DELIVER_NUM){
				onError(resultCode, resultMsgDesc);
			}
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data, oprationIndex) {
			if(data){
				document.getElementById("item" + oprationIndex + "mobileSpan").innerHTML = data.length < 10 ? "没有更多数据了" : "正在加载...";
				isNoMore[oprationIndex] = data.length < 10;
				isLoadingMore[oprationIndex] = (starts[oprationIndex] > 0) ? false : true;
				isPullDonw[oprationIndex] = false;
			}
			//刷新列表
			Vue.nextTick(function(){
				for(var i=0; i<myScrolls.length; i++){
					myScrolls[i].refresh();
				}
				setTimeout(function(){
					myScrolls[sliderIndex].refresh();
				}, 200);
			});
		},
		/**
		 * 监听slider切换
		 */
		onSliderChange: function(e) {
			sliderIndex = e.detail.slideNumber;
			//关闭下拉上拉刷新
			vueObj.closePullStatus();
			//切换后数据为空，则加载数据
			if(vueObj.datas[sliderIndex].length <= 0){
				starts[sliderIndex] = 0;
				vueObj.pulldownRefresh(sliderIndex);					
			}
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "search": //搜索
				openWindow("homeSearch", "home_search.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "scan": //扫一扫点击
				openWindow("scan", "../scan/scan.html", false, {
					shopId:e.currentTarget.dataset.shopId,
					status:vueObj.tabs[sliderIndex].status,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "detial": //查看明细
				openWindow("homeMealList", "home_meal_list.html", false, {
					shopId:e.currentTarget.dataset.shopId,
					shopName:e.currentTarget.dataset.shopName,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			case "service": //送达分拣中心
				showWaiting();
				webCall2("/app/delivery/oms/order/inSortingCenter", {orderNo:e.currentTarget.dataset.orderNo}, QUERY_SORT_CENTER, vueObj.onSuccess, vueObj.onErrorBefore);
				break;	
			case "batch": //批量送达
				showWaiting();
				webCall2("/app/delivery/oms/order/batchInSortingCenter", {}, QUERY_BATCH_CENTER, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			case "item": //订单点击
				if(!e.currentTarget.dataset.orderNo){
					if(vueObj.dmsUserRole == 2 && vueObj.tabs[sliderIndex].status !== 90){
						//扫码取餐
						openWindow("scan", "../scan/scan.html", false, {
							shopId:e.currentTarget.dataset.shopId,
							status:vueObj.tabs[sliderIndex].status,
							statusBarType: STATUS_BAR_DEFAULT_KEY
						});
					}else{
						//查看明细
						openWindow("homeMealList", "home_meal_list.html", false, {
							shopId:e.currentTarget.dataset.shopId,
							shopName:e.currentTarget.dataset.shopName,
							statusBarType: STATUS_BAR_DEFAULT_KEY
						});
					}
					return;
				}
				openWindow("orderDetail", "../common/order_detail.html", false, {
					orderNo:e.currentTarget.dataset.orderNo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "call": //单个订单拨打电话
				var item = JSON.parse(e.currentTarget.dataset.item);
				var buttons = [{title: '呼叫' + item.phone}];
				if(item.isVoiceNotice == 0){
					buttons.unshift({title: "智能呼叫"});
				}
				plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: buttons
				}, function(e) {
					if(e.index <= 0) return;
					//智能呼叫
					if(item.isVoiceNotice == 0 && e.index==1){
						if(item.isVoiceAccept==3){
							toast("智能呼叫中, 请稍后再试");
							return;
						}
						if(item.isVoiceAccept==0){ 
							confirmDialog("提示", "您已呼叫成功过，是否再次呼叫", "取消", "呼叫", null, function(){
								showWaiting();
								webCall2("/app/delivery/oms/order/smartCall", {orderNo:item.orderNo}, QUERY_CALL_ONE, vueObj.onSuccess, vueObj.onErrorBefore);
							});
							return;
						}
						showWaiting();
						webCall2("/app/delivery/oms/order/smartCall", {orderNo:item.orderNo}, QUERY_CALL_ONE, vueObj.onSuccess, vueObj.onErrorBefore);
					} else {//普通拨打电话
						plus.device.dial(item.phone, true);
					}
				});
				break;
			case "callAll": //一键呼叫
				confirmDialog("温馨提示", "一键呼叫仅限呼叫半小时内，未进行智能呼叫的订单。", "取消", "呼叫", null, function(){
					showWaiting();
					webCall2("/app/delivery/oms/order/oneKeyCall", {}, QUERY_CALL_ALL, vueObj.onSuccess, vueObj.onErrorBefore);
				});
				break;	
			default:
				break;
			}
		},
		/**
		 * 设置上下班文案
		 */
		setClockStatus: function(){
			var dmsUserInfo = getCache(DMS_USER_INFO_KEY)
			if(!dmsUserInfo) return;
			vueClock.workStatus = JSON.parse(dmsUserInfo).workStatus;
			document.getElementById("clockBtn").innerText = vueClock.workStatus === 1 ? '下班' : '上班';
		}
	}
});
/*iscroll下拉刷新组件初始化需要*/
function initScroller(){
	var pullDownAction = function() {
		if(isPullDonw[sliderIndex]){
			vueObj.closePullStatus();
			return;
		}
		isNoMore[sliderIndex] = false;
		isPullDonw[sliderIndex] = true;
		setTimeout(function() {
			starts[sliderIndex] = 0;
			vueObj.pulldownRefresh(sliderIndex);
		}, 300);
	};
	var pullLoadMoreAction = function() {
		if (isLoadingMore[sliderIndex] || isPullDonw[sliderIndex]) {
			return;
		}
		if (isNoMore[sliderIndex]) {
			myScrolls[sliderIndex].refresh();
			return;
		};
		setTimeout(function() {
			isLoadingMore[sliderIndex] = true;
			vueObj.pulldownRefresh(sliderIndex);
		}, 300);
	};
		
	//初始化下拉刷新
	for (var i = 0; i < vueObj.tabs.length; i++) {
		vueObj.datas[i] = [];
		isLoadingMore[i] = false;
		isNoMore[i]= false;
		starts[i] = 0;
		myScrolls[i] = iscrollAssist.newVerScrollForPull(mui('#list' + i), pullDownAction, pullLoadMoreAction);
		myScrolls[i].refresh();
	}
	if(vueObj.tabs.length > 0){
		//触发第一个tag
		mui.trigger(document.getElementById("tab0"),'touchstart');
		mui('.mui-slider').slider()._reLayout();
		mui('.mui-slider').slider().gotoItem(0, 0);
		//加载数据
		vueObj.pulldownRefresh(sliderIndex);
	}
}

var vueClock = new Vue({
	el: '#clockMain',
	data: {
		showPop: false,
		workStatus: -1, //工作状态 1上班中 2未上班
		nowTime: '',
	},
	methods: {
		onButtonClick: function(e){
			switch (e.currentTarget.dataset.type){
				case 'close': //关闭
					vueClock.showPop = false;
					break;
				case 'on': //上班
					showWaiting();
					webCall2("/app/delivery/ums/dms/user/clockIn", {}, GO_WORK, vueObj.onSuccess, vueObj.onErrorBefore);
					break;
				case 'off': //下班
					showWaiting();
					webCall2("/app/delivery/ums/dms/user/clockOut", {}, OFF_WORK, vueObj.onSuccess, vueObj.onErrorBefore);
					break;
				default:
					break;
			}
		},
		/**
		 * 开始走秒
		 */
		startTime: function(){
			if(!vueClock.showPop) return;
			var d = new Date();
			vueClock.nowTime = vueClock.getTwo(d.getHours()) + ":" + vueClock.getTwo(d.getMinutes()) + ":" + vueClock.getTwo(d.getSeconds());
			setTimeout(function(){
				vueClock.startTime();
			}, 1000);
		},
		getTwo: function(s){
			if(parseInt(s) < 10) {
				return "0" + s;
			} else {
				return "" + s;
			}
		}
	}
});

//个人中心
document.getElementById("centerIcon").addEventListener("tap", function(){
	openWindow("centerMain", "../center/center_main.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, "slide-in-left");
});
//上下班
document.getElementById("clockBtn").addEventListener("tap", function(){
	if(vueClock.workStatus !== 1 && vueClock.workStatus !== 2) return;
	vueClock.showPop = true;
	vueClock.startTime();
});
//扫码送达按钮点击
document.getElementById("arriveBtn").addEventListener("tap", function(){
	openWindow("scan", "../scan/scan.html", false, {
		status: 80,
		statusBarType: STATUS_BAR_DEFAULT_KEY
	});
});

/**
 * 网络状态监听
 */
document.addEventListener("netchange", function() { //监听网络变化事件
	var types = {};
	types[plus.networkinfo.CONNECTION_UNKNOW] = "Unknown connection";
	types[plus.networkinfo.CONNECTION_NONE] = "No connection";
	types[plus.networkinfo.CONNECTION_ETHERNET] = "Ethernet connection";
	types[plus.networkinfo.CONNECTION_WIFI] = "WiFi connection";
	types[plus.networkinfo.CONNECTION_CELL2G] = "Cellular 2G connection";
	types[plus.networkinfo.CONNECTION_CELL3G] = "Cellular 3G connection";
	types[plus.networkinfo.CONNECTION_CELL4G] = "Cellular 4G connection";
	if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE || plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_UNKNOW) {
		vueObj.netWorkTips = true;
	} else {
		if(vueObj.netWorkTips){
			vueObj.netWorkTips = false;
		}
		starts[sliderIndex] = 0;
		vueObj.pulldownRefresh(sliderIndex);
	}
	outputLog("网络类型：" + types[plus.networkinfo.getCurrentType()]);
}, false);

//首页返回键处理
mui.back = function() {
	//退出应用到后台
	var main = plus.android.runtimeMainActivity();
	main.moveTaskToBack(false);
};