var myScroll;
/** 网络请求码 */
var QUERY_DATA = 1001;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		staticsData: {},//统计数据
		netWorkTips: true,
	},
	beforeMount: function() {
		mui.plusReady(function() {
			setStatusBarMain();
			// 关闭侧滑返回功能
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE || plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_UNKNOW) {
				vueObj.netWorkTips = true;
			}
			plus.navigator.closeSplashscreen();
			//静默登录信息变更
			window.addEventListener("onUserInfoChange", function(event){
				vueObj.dmsUserRole = getUserInfo().dmsUserRole;
				if(vueObj.dmsUserRole!==1){openHomeMainHtml(true);}
			});
			window.addEventListener("onOrderDataChange", function(event){
				vueObj.loadData();
			});
			vueObj.onSimplePwdTips();
			vueObj.loadData();
		});
	},
	methods: {
		/*
		 * 密码简单提示
		 * 0需要提醒 1已提醒
		 */
		onSimplePwdTips: function(){
			if(getCache("isSimplePwdTips") != 0) return;
			setCache("isSimplePwdTips", 1);
			confirmDialog("温馨提示", "由于您的密码过于简单, 为了您的账户安全，请及时修改密码！", "取消", "去修改", null, function(){
				openWindow("modifyPwd", "../login/modify_pwd.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY
				}, null, true);
			});
		},
		/**
		 * 下拉刷新具体业务实现
		 */
		loadData: function() {
			webCall2("/app/delivery/oms/statistics/deliveryCompanyStatistics", {}, QUERY_DATA, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			vueObj.closePullStatus();
			closeWaiting();
			switch(requestCode) {
			case QUERY_DATA:
				vueObj.staticsData = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			vueObj.closePullStatus();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			//刷新列表
			Vue.nextTick(function(){
				setTimeout(function(){
					myScroll.refresh();
				}, 200); 
			}); 
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "search": //搜索
				openWindow("homeSearch", "home_search.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			case "abnormal": //异常订单点击
				openWindow("homeAbnormalList", "home_abnormal_list.html", false, {
					unusualType: e.currentTarget.dataset.unusualType,
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;	
			default: //其他订单点击
				openWindow("homeOrderList", "home_order_list.html", false, {
					isUnusual:e.currentTarget.dataset.status==-1?0:1,
					deliveryStatus:e.currentTarget.dataset.status>0?e.currentTarget.dataset.status:-1,
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			}
		}
	}
});
/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.loadData();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	}); 
})(mui);
//个人中心
document.getElementById("centerIcon").addEventListener("tap", function(){
	openWindow("centerMain", "../center/center_main.html", false, {statusBarType: STATUS_BAR_MAIN_KEY}, "slide-in-left");
});
//订单转派
document.getElementById("transferBtn").addEventListener("tap", function(){
	openWindow("orderTransfer", "../home/order_transfer.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
});

/**
 * 网络状态监听
 */
document.addEventListener("netchange", function() { //监听网络变化事件
	var types = {};
	types[plus.networkinfo.CONNECTION_UNKNOW] = "Unknown connection";
	types[plus.networkinfo.CONNECTION_NONE] = "No connection";
	types[plus.networkinfo.CONNECTION_ETHERNET] = "Ethernet connection";
	types[plus.networkinfo.CONNECTION_WIFI] = "WiFi connection";
	types[plus.networkinfo.CONNECTION_CELL2G] = "Cellular 2G connection";
	types[plus.networkinfo.CONNECTION_CELL3G] = "Cellular 3G connection";
	types[plus.networkinfo.CONNECTION_CELL4G] = "Cellular 4G connection";
	if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE || plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_UNKNOW) {
		vueObj.netWorkTips = true;
	} else {
		if(vueObj.netWorkTips){
			vueObj.netWorkTips = false;
		}
		vueObj.loadData();
	}
	outputLog("网络类型：" + types[plus.networkinfo.getCurrentType()]);
}, false);

//首页返回键处理
mui.back = function() {
	//退出应用到后台
	var main = plus.android.runtimeMainActivity();
	main.moveTaskToBack(false);
};