var myScroll, isLoadingMore, isNoMore, start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		dmsUserRole: null, //配送人员角色 1管理员 2取餐员 3分拣员 4分送员 5跑楼员
		shopId:'',
		shopName:'',
		datas: [],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			vueObj.shopId = plus.webview.currentWebview().shopId;
			vueObj.shopName = plus.webview.currentWebview().shopName;
			vueObj.dmsUserRole = getUserInfo().dmsUserRole;
			document.getElementById("shopName").innerText = vueObj.shopName;
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			if(vueObj.dmsUserRole == 2){//取餐员 待出餐列表
				webCall2("/app/delivery/oms/order/shopWaitMealOutList", {
					shopId: vueObj.shopId,
					offset: start,
					limit: 10,
				}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
				return;
			}
			webCall2("/app/delivery/oms/order/scanTakeList", {
				shopId: vueObj.shopId,
				deliveryDetailStatus: 40,//待取餐
				offset: start,
				limit: 10,
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //消息查询成功
				//更新数据
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				document.getElementById("item0mobileSpan").style.display = vueObj.datas.length < 4 ? "none" : "";
				closePullStatus(data.rows);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "item": //订单点击
				if(!e.currentTarget.dataset.orderNo || vueObj.dmsUserRole == 2) return;
				openWindow("orderDetail", "../common/order_detail.html", false, {
					orderNo:e.currentTarget.dataset.orderNo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			default:
				break;
			}
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/** 
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		document.getElementById("item0mobileSpan").innerHTML = data.length < 10 ? "没有更多数据了" : "正在加载...";
		isNoMore = data.length < 10;
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}