var myScroll, isLoadingMore, isNoMore, start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		selectTypeRows:[],//类型列表
		currentSelectType:{title:'全部', status: 40},//当前选择类型
		deliveryStatus:null,//配送状态
		isUnusual: null, //是否为异常订单  0是1否
		unusualType: null,//异常订单类型 1核验超时 2取餐超时
		takeDmsId:'',//取餐员id
		shopId:'',//店铺id
		orderNum:0,//订单数量
		datas: [],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			vueObj.deliveryStatus = plus.webview.currentWebview().deliveryStatus>0 ? plus.webview.currentWebview().deliveryStatus : '';
			vueObj.isUnusual = plus.webview.currentWebview().isUnusual===0 ? 0 : '';
			vueObj.unusualType = plus.webview.currentWebview().unusualType>=1 ? plus.webview.currentWebview().unusualType : '';
			vueObj.takeDmsId = plus.webview.currentWebview().takeDmsId;
			vueObj.shopId = plus.webview.currentWebview().shopId;
			//类型列表数据
			if(vueObj.isUnusual===0 && !vueObj.unusualType){ //全部异常订单
				vueObj.selectTypeRows=[{title:'全部', status: -1}, {title:'取餐超时', status: 2}, {title:'核验超时', status:1}];
				vueObj.currentSelectType = vueObj.selectTypeRows[0];
			} else if (vueObj.isUnusual!==0){//其他正常订单类型
				vueObj.selectTypeRows=[{title:'全部', status: -1}, {title:'待派单', status: 30}, {title:'待取餐', status:40}, {title:'待分拣', status: 50}, {title:'待核验', status:60}, {title:'待送达', status: 70}, {title:'已送达', status:80}];
				vueObj.currentSelectType = vueObj.selectTypeRows[0];
				if(vueObj.deliveryStatus > 0){ //设置当前类型
					for(var i in vueObj.selectTypeRows){
						var item = vueObj.selectTypeRows[i];
						if(item.status != vueObj.deliveryStatus) continue;
						vueObj.currentSelectType = vueObj.selectTypeRows[i];
						break;
					}
				}
			}
			vueObj.loadData();
		});
	},
	methods: { 
		/**
		 * 加载数据
		 * deliveryDetailStatus 配送详情状态：20待出餐 30待派单 40待取餐 50待分拣 60待核验 70待送达 80已送达
		 * isUnusual 是否为异常订单 0是1否
		 * unusualType 异常订单类型 1核验超时 2取餐超时
		 */
		loadData: function() {
			var params = {
				offset: start, 
				limit: 10,
			};
			if(vueObj.isUnusual===0){params.isUnusual = 0;}
			//从取餐异常订单统计进来的 会有取餐员id 或 商家id
			if(vueObj.takeDmsId || vueObj.shopId){
				params.takeDmsId= vueObj.takeDmsId ? vueObj.takeDmsId : '';
				params.shopId= vueObj.shopId ? vueObj.shopId : '';
				params.unusualType = vueObj.unusualType > 0 ? vueObj.unusualType : '';
			} else if(vueObj.isUnusual===0){ //异常订单
				params.unusualType = vueObj.currentSelectType.status > 0 ? vueObj.currentSelectType.status : '';
			} else { //正常订单
				params.deliveryDetailStatus = vueObj.currentSelectType.status > 0 ? vueObj.currentSelectType.status : '';
			}
			webCall2("/app/delivery/oms/statistics/deliveryOrderListData", params, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //消息查询成功
				//更新数据
				vueObj.orderNum = data.total>=0 ? data.total : 0; 
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				document.getElementById("noContent").style.display = vueObj.datas.length === 0 ? "" : "none";
				document.getElementById("item0mobileSpan").style.display = vueObj.datas.length < 4 ? "none" : "";
				closePullStatus(data.rows);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "search": //搜索
				openWindow("homeSearch", "home_search.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			case "select": //选择类型
				plus.nativeUI.actionSheet({
					title: "类型选择",
					cancel:"取消",
					buttons:vueObj.selectTypeRows
				}, function(e){
					if(e.index < 1) return;
					var type = vueObj.selectTypeRows[e.index-1];
					if(type.status === vueObj.currentSelectType.status) return;
					vueObj.currentSelectType = vueObj.selectTypeRows[e.index-1];
					showWaiting();
					start = 0;
					vueObj.orderNum = 0;
					vueObj.loadData();
				});
				break;	
			case "item": //订单点击
				if(!e.currentTarget.dataset.orderNo) return;
				openWindow("orderDetail", "../common/order_detail.html", false, {
					orderNo:e.currentTarget.dataset.orderNo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			default:
				break; 
			}
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/** 
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		document.getElementById("item0mobileSpan").innerHTML = data.length < 10 ? "没有更多数据了" : "正在加载...";
		isNoMore = data.length < 10;
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}