var myScroll, isLoadingMore, isNoMore, start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		searchContent:'',//搜索内容
		datas: [],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			/**进入页面弹出键盘*/
		    showSoftKeyboard("#searchInput"); 
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/app/delivery/oms/order/detailListData", {
				offset: start,
				limit: 10,
				searchText: vueObj.searchContent,
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //消息查询成功
				//更新数据
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				document.getElementById("noContent").style.display = vueObj.datas.length === 0 ? "" : "none";
				document.getElementById("item0mobileSpan").style.display = vueObj.datas.length < 4 ? "none" : "";
				closePullStatus(data.rows);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){		
			case "item": //订单点击
				openWindow("orderDetail", "../common/order_detail.html", false, {
					orderNo:e.currentTarget.dataset.orderNo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			default:
				break;
			}
		},
		
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull($("#main"), null, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);
/** 
 * 搜索
*/
function onSearch(){
	document.getElementById("searchInput").blur();
	vueObj.searchContent = document.getElementById("searchInput").value;
	if(!vueObj.searchContent || vueObj.searchContent.length <= 0){
		toast("请输入手机号或订单编号查询");
		return;
	}
	showWaiting();
	start = 0;
	vueObj.loadData();
}
/** 
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		document.getElementById("item0mobileSpan").innerHTML = data.length < 10 ? "没有更多数据了" : "正在加载...";
		isNoMore = data.length < 10;
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
	}
	document.getElementById("main").style.backgroundImage = isNoData ? "url(../../img/no_content_bg.png)" : "none";
	document.getElementById("item0mobileSpan").style.display = isNoData ? "none" : "";
}