var QUERY_ORDER_LIST = 1001, DO_ORDER_TRANSFER = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		orderNo:'',//订单编号
		personA:{},//取餐员A
		personB:{},//取餐员B
		selectType: '',// 1是取餐员A 2是取餐员B
		waitTakeNumber:0,//取餐员A 待取餐订单数量
		waitSortingNumber:0,//取餐员A 待分拣订单数量
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault(); 
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//人员选择更新
			window.addEventListener("onPersonSelect", function(event){
				if(!event.detail.person) return;
				var person = JSON.parse(event.detail.person);
				if(vueObj.selectType=='personB'){
					vueObj.personB = person;
					return;
				} 
				//查询A取餐员下的订单
				if(!vueObj.personA || person.id != vueObj.personA.id){
					vueObj.waitTakeNumber = 0;
					vueObj.waitSortingNumber = 0; 
					webCall2("/app/delivery/oms/order/deliveryTransferData", {dmsId:person.id}, QUERY_ORDER_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
				}
				vueObj.personA = JSON.parse(event.detail.person);
			});
			//滚动初始化  
			mui('.mui-scroll-wrapper').scroll();
			vueObj.orderNo = plus.webview.currentWebview().orderNo;
			if(vueObj.orderNo){ 
				vueObj.personA = {userName:plus.webview.currentWebview().userName,id:plus.webview.currentWebview().takeDmsId};
			}
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_ORDER_LIST://取餐员名下的订单
				vueObj.waitTakeNumber= data.data.waitTakeNumber>0 ? data.data.waitTakeNumber : 0;
				vueObj.waitSortingNumber=data.data.waitSortingNumber>0 ? data.data.waitSortingNumber : 0;
				break;	 
			case DO_ORDER_TRANSFER: 
				toast("转派成功");
				if(vueObj.orderNo){
					mui.fire(plus.webview.getWebviewById("orderDetail"), "onOrderDataUpdate", {});
				}
				mui.back();
				break;	  
			default:
				break;
			}
		}, 
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "person": //人员
				vueObj.selectType = e.currentTarget.dataset.person;
				if(vueObj.orderNo && vueObj.selectType=="personA") return;
				openWindow("orderTransferPerson", "../home/order_transfer_person.html", false, {
					person:e.currentTarget.dataset.person,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "transfer": //转派点击
				if(!vueObj.personA || !vueObj.personA.id){
					toast("请选择A取餐员");
					return;
				}
				if(!vueObj.orderNo && vueObj.waitTakeNumber <=0 && vueObj.waitSortingNumber <=0){
					toast("当前A取餐员没有可以转派的订单");
					return;
				}
				if(!vueObj.personB || !vueObj.personB.id){
					toast("请选择B取餐员");
					return;
				}
				if(vueObj.personA.id == vueObj.personB.id){
					toast("A取餐员和B取餐员不能为同一个人");
					return;
				}
				var params = {
					fromUserId:vueObj.personA.id,
					toUserId:vueObj.personB.id
				};
				if(vueObj.orderNo){
					params.orderNo = vueObj.orderNo;
				} else {
					var waitTakeCheck = document.getElementById("waitTakeCheck").checked;
					var waitSortingCheck = document.getElementById("waitSortingCheck").checked;
					if(!waitTakeCheck && !waitSortingCheck){
						toast("请选择要转派的订单");
						return;
					}
					params.waitTake = waitTakeCheck ? 0 : 1;
					params.waitSorting = waitSortingCheck ? 0 : 1;
				}
				showWaiting();
				webCall2("/app/delivery/oms/order/orderTransfer", params, DO_ORDER_TRANSFER, vueObj.onSuccess, vueObj.onErrorBefore);
				break;	
			default:
				break;
			}
		},
	}
});