var QUERY_LIST = 1001;
var searchTime = null;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		originalPersonDatas:[],//原人员列表
		personDatas:[],//人员列表
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault(); 
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化  
			mui('.mui-scroll-wrapper').scroll();
			//获取所有取餐员
			webCall2("/app/delivery/ums/dms/user/listData", {role:2,status:1,offset: 0,limit: 1000}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore); 
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: 
				vueObj.personDatas = data.rows;
				vueObj.originalPersonDatas = data.rows;
				break;	 
			default:
				break;
			}
		}, 
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "item": //人员
				var item = vueObj.personDatas[e.currentTarget.dataset.index];
				mui.fire(plus.webview.getWebviewById("orderTransfer"), "onPersonSelect", {
					person:JSON.stringify(item)
				});
				mui.back();
				break;
			default:
				break;
			}
		},
		/*
		 * 搜索框未空时 重置数据
		 */
		onSearchInput: function(e){
			if(searchTime)  {clearTimeout(searchTime);searchTime = null;}
			searchTime = setTimeout(function(){
				var searchContent = document.getElementById("searchInput").value;
				if(!searchContent || searchContent.length <= 0){
					vueObj.personDatas = vueObj.originalPersonDatas;
				}
			}, 500);
		},
	}
});

mui('.mui-input-row').on('tap', '.mui-icon-clear', function() {
	vueObj.personDatas = vueObj.originalPersonDatas;
}, false);
//弹窗禁止滑动
document.addEventListener("touchmove", function(e){
	document.activeElement.blur();
});
/*
 * 搜索
 */
function onSearch() {
	document.getElementById("searchInput").blur();
	var searchContent = document.getElementById("searchInput").value;
	if(!searchContent || searchContent.length <= 0) {
		toast("请输入内容");
		return;
	}
	mui('.mui-scroll-wrapper').scroll().scrollTo(0, 0, 0);
	var tempPersonDatas = [];
	vueObj.originalPersonDatas.forEach(function(item) {
		if(item.userName.indexOf(searchContent) >= 0) {
			tempPersonDatas.push(item);
		}
	});
	vueObj.personDatas = tempPersonDatas;
}