//请求码
var DO_LOGIN = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		wxUser: null,
		userPhone: null,
		checkCode: null,
		invitationCode:null,//邀请码
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		userFlag: '', //新用户/老用户
		sendCount: 1, //短信验证码发送次数
		isNewUser:false,//是否为新用户 显示渠道码
	},
	beforeMount: function(){
		mui.plusReady(function(){
			setStatusBarDefault();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.wxUser = plus.webview.currentWebview().wxUser;
			//设置键盘弹出模式
			keyboardAdjustResize();
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			//初始显示手机号
			var cachePhone = getCache(ACCOUNT_KEY);
			if(cachePhone){
				document.getElementById("userPhone").value = cachePhone;
			}
		});
	},
	methods: {
		/**
		 * 绑定
		 */
		onBind: function(){
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone){
				toast("手机号码不能为空");
				return;
			}else if(!regexMobile(vueObj.userPhone) ){
				toast("请输入正确的手机号码");
				return;
			}
			vueObj.checkCode = document.getElementById("checkCode").value;
			if(!vueObj.checkCode){
				toast("验证码不能为空");
				return;
			}
			//判断邀请码是否为空
			if(document.getElementById("channelCode") && !stringIsNull(document.getElementById("channelCode").value)){
				vueObj.invitationCode = document.getElementById("channelCode").value;
			} else {
				vueObj.invitationCode = "";
			}
			document.activeElement.blur();
			showWaiting();
			webCall2("/login/doLoginByVerificationCode", {
				mobilePhone: vueObj.userPhone,
				verificationCode: vueObj.checkCode,
				clientId: getClientId(),
				osType: plus.os.name,
				osVersion: plus.os.version,
				mobileType: plus.device.model,
				invitationCode: vueObj.invitationCode,//邀请码
				application: "wechat",
				openid: vueObj.wxUser.openid,
				unionid: vueObj.wxUser.unionid,
				nickName: vueObj.wxUser.nickname,
				headImg: vueObj.wxUser.headimgurl,
				osUuid: plus.device.uuid,
				oaid: getCache(DEVICE_OAID_KEY),
				appAllVersion: plus.runtime.version,
				appWgtVersion: getCache(WGT_VERSION_FLAG)
			}, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码")
				return;
			}
			showWaiting();
			webCall2("/compus/user/sendLoginVerificationCode", {
				mobilePhone: vueObj.userPhone,
				sendCount: vueObj.sendCount
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "获取验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case DO_LOGIN:
				closeWebview("loginByCode");
				//清空消息
				clearPushMessage();
				//更新登录信息
				updateLoginInfo(vueObj.userPhone, data.data);
				//日志上报
				aliyunLoginDataPost("third");
				//跳转到选择身份页面
				if(getCache(SCHOOL_CODE_KEY) && data.data.alumniFlag == 0 &&  (!data.data.schoolIdentityType || data.data.schoolIdentityType <= 0)){
					openWindow("selectIdentity", "select_identity.html", false, {
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						source:'login',
						isCloseOpener:true,
					});
				} else if(getCache(SCHOOL_CODE_KEY)){ //已选学校，跳转到首页
					openWindow('main', '../main.html', false, {isCloseOpener:true,statusBarType:STATUS_BAR_DEFAULT_KEY}, null, true);
				}else{ //未选择学校，跳转到学校选择页
					var realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
					openWindow('selectSchool', '../login/select_school.html', false, {
						invitationCode: realNameStatus != 3 ? vueObj.invitationCode : "",//渠道邀请码
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						from: 'login',
						isCloseOpener:true,
					});
				}
				break;
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				vueObj.userFlag == (data.data && data.data.userExists) ? '用户登录' : '用户注册';
				vueObj.isNewUser = (data.data && data.data.userExists) ? false : true;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});