//请求码
var DO_LOGIN = 1001, GET_PUBLIC_KEY = 1002, GET_CODE = 1003, GET_PIC_CODE = 1004;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		showCheckCode: false, //是否显示短信验证码
		userPhone: null,
		userPwdEncrypt: null,
		checkCode: null,
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		sendCount: 1, //短信验证码发送次数
		showProtocol: true,
		securityObj: {},
	},
	beforeMount: function(){
		mui.plusReady(function(){
			unfullscreen();
			setStatusBarDefault();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			var self = plus.webview.currentWebview();
			//设置键盘弹出模式
			keyboardAdjustResize();
			//初始显示手机号
			var cachePhone = plus.webview.currentWebview().userPhone;
			if(cachePhone){
				document.getElementById("userPhone").value = cachePhone;
			}
		});
	},
	methods: {
		/**
		 * 登录（获取密钥）
		 */
		onLogin: function(){
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone){
				toast("手机号码不能为空");
				return;
			}else if(!regexMobile(vueObj.userPhone) ){
				toast("请输入正确的手机号码");
				return;
			}
			var userPwd = document.getElementById("userPwd").value;
			if(!userPwd){
				toast("密码不能为空");
				return;
			}
			document.activeElement.blur();
			if(vueObj.showCheckCode){
				vueObj.checkCode = document.getElementById("checkCode").value;
				if(!vueObj.checkCode){
					toast("验证码不能为空");
					return;
				}
				showWaiting();
				webCall2("/app/login/doLoginByVerificationCode", {
					mobilePhone: vueObj.userPhone,
					verificationCode: vueObj.checkCode,
					clientId: getClientId(),
					osType: plus.os.name,
					osVersion: plus.os.version,
					mobileType: plus.device.model,
					osUuid: plus.device.uuid,
					oaid: getCache(DEVICE_OAID_KEY),
					appAllVersion: plus.runtime.version,
					appWgtVersion: getCache(WGT_VERSION_FLAG)
				}, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
			}else{
				vueObj.userPwdEncrypt = hex_md5(userPwd);
				//获取公钥
				showWaiting();
				webCall2("/app/login/getPublicKey", { mobilePhone: vueObj.userPhone }, GET_PUBLIC_KEY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
			}
		},
		/**
		 * 执行登录
		 */
		doLogin: function(publicKey) {
			//密码加密
			var encrypt = new JSEncrypt();
			encrypt.setPublicKey(publicKey.publicKey);
			var encrypedPwd = encrypt.encrypt(vueObj.userPwdEncrypt);
		    
			var params = {
				mobilePhone: vueObj.userPhone, 
				password: encrypedPwd,
				clientId: getClientId(),
				osType: plus.os.name,
				osVersion: plus.os.version,
				mobileType: plus.device.model,
				osUuid: plus.device.uuid,
				oaid: getCache(DEVICE_OAID_KEY),
				appAllVersion: plus.runtime.version,
				appWgtVersion: getCache(WGT_VERSION_FLAG)
			};
			showWaiting();
			webCall2("/app/login/doLoginByPwd", params, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 跳转验证码登录页面
		 */
		onForgetPsw: function(){
			mui.back();
		},
		/**
		 * 注册按钮监听
		 */
		onRegister: function(){
			//openWindow("selectSchool", "select_school.html",false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, true);
			openWindow("register", "register.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, true);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case GET_PUBLIC_KEY: //获取加密公钥
				setTimeout(function(){
					vueObj.doLogin(data.data);
				}, 200);
				break;
			case DO_LOGIN: //登录成功
				closeWebview("loginByCode");	
				//清空消息
				clearPushMessage();
				document.activeElement.blur();
				//更新登录信息
				updateLoginInfo(vueObj.userPhone, data.data);
				//日志上报
				aliyunLoginDataPost("pwd");
				//登录免密小于8位 提示用户修改密码 0需要提醒 1已提醒
				var userPwd = document.getElementById("userPwd").value;
				if(userPwd.length < 8){
					setCache("isSimplePwdTips", 0);
				}
				//跳转首页
				openHomeMainHtml(true);	
				break;
			case GET_CODE: //获取验证码
				//toast("验证码发送成功");
				vueObj.sendCount++;
				document.getElementById("picCodeId").style.display = "none";
				document.activeElement.blur();
				//倒计时
				vueObj.setTimeCount();
				break;
			case GET_PIC_CODE: //获取图形验证码
				vueCodeObj.imgData = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data){
			closeWaiting();
			if(resultCode == 205){
				vueObj.showCheckCode = true;
				toast("设备更换，请输入验证码");
				//发送验证码
				vueObj.onGetCode();
				setTimeout(function(){
					document.getElementById("checkCode").focus();
				}, 300);
				return;
			}
			//需要图形验证码
			if(requestCode == GET_CODE && resultCode == 'code' && data && data.data){
				vueObj.securityObj = data.data;
				document.activeElement.blur();
				vueCodeObj.code = null;
				document.getElementById("picCodeId").style.display = "block";
				vueObj.onGetPicCode();
				return;
			}else if(requestCode == GET_CODE && data && data.bizCode == "10040"){
				toast(resultMsgDesc);
				vueCodeObj.code = null;
				vueObj.onGetPicCode();
				return;
			}
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(event, picCode){
			if(vueObj.timeCount != 0) return; //正在60s计时
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码")
				return;
			}
			showWaiting();
			if(picCode){
				webCall2("/app/message/sendLoginVerificationCode", {
					mobilePhone: vueObj.userPhone,
					sendCount: vueObj.sendCount,
					securityToken: vueObj.securityObj.securityToken,
					appSecurityToken: vueObj.securityObj.appSecurityToken,
					imageCaptchaValue: picCode
				}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
				return;
			}
			webCall2("/common/security/token", {
				mobilePhone: vueObj.userPhone,
				sendCount: vueObj.sendCount,
				sceneCode: "app_user_login"
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, {urlPath: "/app/message/sendLoginVerificationCode"});
		},
		/**
		 * 获取图形验证码
		 */
		onGetPicCode: function(){
			webCall2("/common/security/imageCaptcha", {
				securityToken: vueObj.securityObj.securityToken
			}, GET_PIC_CODE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 手机号输入监听
		 */
		phoneInput: function(e) {
			if(vueObj.timer) {
				clearInterval(vueObj.timer);
				vueObj.timer = null;
				vueObj.timeCount = 0;
			}
			vueObj.showCheckCode = false;
		}
	}
});

//Android监听软键盘
var originalHeight = document.documentElement.clientHeight ||document.body.clientHeight;
window.onresize = function(){
    //键盘弹起与隐藏都会引起窗口的高度发生变化
	var resizeHeight=document.documentElement.clientHeight || document.body.clientHeight;
	if(resizeHeight-0 < originalHeight-0){
	     //当软键盘弹起，在此处操作
		vueObj.showProtocol = false;
	}else{
	 	//当软键盘收起，在此处操作
	 	vueObj.showProtocol = true;
	}
}

//常见问题
document.getElementById("questionBtn").addEventListener("tap", function(){
	openWindow("questionMain", "../center/question_main.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
});
//vue初始化
var vueCodeObj = new Vue({
	el: '#picCodeId',
	data: {imgData:null, code: null},
	methods: {
		onButtonClick:function(e){
			switch (e.currentTarget.dataset.type){
			case 'close': //关闭弹窗
				document.getElementById("picCodeId").style.display = "none";
				document.activeElement.blur();
				break;
			case 'refresh': //刷新验证码
				vueObj.onGetPicCode();
				break;
			case 'submit': //提交验证
				if(!vueCodeObj.code){
					toast("请输入验证码");
					return;
				}
				if(commonTrim(vueCodeObj.code).length < 4){
					toast("请输入合法的验证码");
					return;
				}
				vueObj.onGetCode(null, vueCodeObj.code);
				break;
			default:
				break;
			}
		}
	}
});