//请求码
var DO_LOGIN = 1001, GET_CODE = 1002, GET_PIC_CODE = 1003;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		userPhone: null,
		checkCode: null,
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		nowEnv: 'RELEASE', //当前API环境
		userFlag: '', //新用户/老用户
		sendCount: 1, //短信验证码发送次数
		showThird: true, //是否显示第三方登录
		isShowWechatLogin: false, //是否显示第三第方登录
		wxUser: null, //微信登录信息
		isLoginOut: 0,//是否为登出 1为登出消息 2接口204 3退出 4销户
		loginFlag: 'code', //验证码code 微信third
		securityObj: {},
	},
	beforeMount: function(){
		mui.plusReady(function(){
			closeWaiting();
			//关闭启动页
			plus.navigator.closeSplashscreen();
			unfullscreen();
			setStatusBarDefault();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//微信登录回调监听
			window.addEventListener("onWechatLoginCallSuccessListener", function(event){
				vueObj.wxUser = event.detail;
				if(!vueObj.wxUser) return;
				vueObj.loginFlag = "third";
				showWaiting();
				webCall2("/login/authLogin", {
					application: "wechat",
					openid: event.detail.openid,
					unionid: event.detail.unionid,
					clientId: getClientId(),
					osType: plus.os.name,
					osVersion: plus.os.version,
					mobileType: plus.device.model,
					osUuid: plus.device.uuid,
					oaid: getCache(DEVICE_OAID_KEY),
					appAllVersion: plus.runtime.version,
					appWgtVersion: getCache(WGT_VERSION_FLAG)
				}, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//设置键盘弹出模式
			keyboardAdjustResize();
			//插件初始化
			iOSInitNativeJs();		
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			//初始显示手机号
			var cachePhone = getCache(ACCOUNT_KEY);
			if(cachePhone){
				document.getElementById("userPhone").value = cachePhone;
				setCache(LOGIN_PRIVATEP_ROTOCOL, true);
			}else{
				document.getElementById("protocolCkb").checked = false;
			}
			//设置系统环境
			vueObj.nowEnv = apiEnvironment;
			//触发启动页广告事件
			mui.fire(plus.webview.currentWebview().opener(), "onStartAdClickListener", {});
			vueObj.isLoginOut = plus.webview.currentWebview().isLoginOut ? plus.webview.currentWebview().isLoginOut : 0;
			vueObj.onProtocolPopManager();
			if(!plus.runtime.isAgreePrivacy() && !getCache(LOGIN_PRIVATEP_ROTOCOL)) return;
			vueObj.onClearCache();
			vueObj.initThirdLogin();
		});
	},
	methods: {
		initThirdLogin: function(){
			//第三方登录初始化 返回是否安装了微信
			if(plus.os.name == "iOS"){
				initShareServicesAndInstalledWechat(plus.webview.currentWebview(), function(isInstalledWechat){
					vueObj.isShowWechatLogin = isInstalledWechat;
				});
			} else {
				initShareServices(plus.webview.currentWebview());
				vueObj.isShowWechatLogin = true;
			}
		},
		/*
		 * 清理退出登录信息
		 */
		onClearCache:function(){
			if(vueObj.isLoginOut == 0) return;
			switch (vueObj.isLoginOut){
				case 1:
					plus.nativeUI.confirm("您的账号已被登出，请确认是否本人操作？", function() {}, "提示", ["确定"]);
					break;
				case 2:
					toast("您的账号已被登出或已失效，请重新登录");
					break;
				case 3:
				case 4:
					break;	
				default:
					break;
			}
			//清理缓存
			clearLocalAllCache();
			//清空消息
			clearPushMessage();
			//清除微信授权
			clearWxLogin();
			//清理本地信息
			clearLoginInfo();
			//关闭页面
			closeWebviewWhenLoginOut();
		},
		/**
		 * 登录
		 */
		onLogin: function(){
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone){
				toast("手机号码不能为空");
				return;
			}else if(!regexMobile(vueObj.userPhone) ){
				toast("请输入正确的手机号码");
				return;
			}
			vueObj.checkCode = document.getElementById("checkCode").value;
			if(!vueObj.checkCode){
				toast("验证码不能为空");
				return;
			}
			//注册协议
			if(!document.getElementById("protocolCkb").checked){
				toast("请勾选校帅用户服务协议");
				return;
			}
			document.activeElement.blur();
			vueObj.loginFlag = "code";
			showWaiting();
			webCall2("/app/login/doLoginByVerificationCode", {
				mobilePhone: vueObj.userPhone,
				verificationCode: vueObj.checkCode,
				clientId: getClientId(),
				osType: plus.os.name,
				osVersion: plus.os.version,
				mobileType: plus.device.model,
				osUuid: plus.device.uuid,
				oaid: getCache(DEVICE_OAID_KEY),
				appAllVersion: plus.runtime.version,
				appWgtVersion: getCache(WGT_VERSION_FLAG)
			}, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(event, picCode){
			if(vueObj.timeCount != 0) return; //正在60s计时
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码")
				return;
			}
			showWaiting();
			if(picCode){
				webCall2("/app/message/sendLoginVerificationCode", {
					mobilePhone: vueObj.userPhone,
					sendCount: vueObj.sendCount,
					securityToken: vueObj.securityObj.securityToken,
					appSecurityToken: vueObj.securityObj.appSecurityToken,
					imageCaptchaValue: picCode
				}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
				return;
			}
			webCall2("/common/security/token", {
				mobilePhone: vueObj.userPhone,
				sendCount: vueObj.sendCount,
				sceneCode: "app_user_login"
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, {urlPath: "/app/message/sendLoginVerificationCode"});
		},
		/**
		 * 获取图形验证码
		 */
		onGetPicCode: function(){
			webCall2("/common/security/imageCaptcha", {
				securityToken: vueObj.securityObj.securityToken
			}, GET_PIC_CODE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case DO_LOGIN:
				if(!data.data.id){ //第三方登录未绑定手机
					openWindow("bindPhone", "../login/bind_phone.html", false, {
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						wxUser: vueObj.wxUser
					});
					return;
				}
				//清空消息
				clearPushMessage();
				//更新登录信息
				if(data.data.account && data.data.account.length > 0){
					updateLoginInfo(data.data.account, data.data);
				} else {
					updateLoginInfo(vueObj.userPhone, data.data);
				}
				//日志上报
				aliyunLoginDataPost(vueObj.loginFlag);
				//跳转首页
				openHomeMainHtml(true);
				break;
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				vueObj.userFlag = (data.data && data.data.userExists) ? '用户登录' : '用户注册';
				document.getElementById("picCodeId").style.display = "none";
				document.activeElement.blur();
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case GET_PIC_CODE: //获取图形验证码
				vueCodeObj.imgData = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data){
			closeWaiting();
			//需要图形验证码
			if(requestCode == GET_CODE && resultCode == 'code' && data && data.data){
				vueObj.securityObj = data.data;
				document.activeElement.blur();
				vueCodeObj.code = null;
				document.getElementById("picCodeId").style.display = "block";
				vueObj.onGetPicCode();
				return;
			}else if(requestCode == GET_CODE && data && data.bizCode == "10040"){
				toast(resultMsgDesc);
				vueCodeObj.code = null;
				vueObj.onGetPicCode();
				return;
			}
			iOSGetUserNetState(resultCode, function(result){
				if(result){return;} 
				onError(resultCode, resultMsgDesc);
				if(requestCode == GET_CODE){
					vueObj.sendCount++;
				}
			});
		},
		onButtonClick: function(e){
			document.activeElement.blur();
			//判断协议弹框
			if(!vueObj.onProtocolPopManager()){
				return;
			}
			switch (e.currentTarget.dataset.type){
			case 'code':
				vueObj.onGetCode(e);
				break;
			case 'protocol':
				openWindow("privateProtocol", "../common/web_page.html", false, {
					webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderProtocol",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case 'private':
				openWindow("privateProtocol", "../common/web_page.html", false, {
					webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderPrivateInfo",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case 'doLogin':
				vueObj.onLogin();
				break;
			case 'wxLogin':
				onWechatLogin();
				break;
			case 'pwd':
				var _userPhone = document.getElementById("userPhone").value;
				if(!regexMobile(_userPhone) ){
					_userPhone = getCache(ACCOUNT_KEY);
				}
				openWindow('login', 'login.html', false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY,
					userPhone: _userPhone
				}, null, false);
				break;
			case 'question':
				openWindow("questionMain", "../center/question_main.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
				break;
			default:
				break;
			}
		},
		/*
		 * 是否弹出服务协议和隐私协议弹框
		 */
		onProtocolPopManager: function(){
			if(!plus.runtime.isAgreePrivacy() && !getCache(LOGIN_PRIVATEP_ROTOCOL)){
				vueObj.isOpenProtocolPop(true);
				document.getElementById("protocolCkb").checked = false;
				return false;
			} 
			mui.fire(plus.webview.getLaunchWebview(), "onAgreePrivateProtocol", {});
			return true;
		},
		/*
		 * 协议弹框开关
		 */
		isOpenProtocolPop: function(isShow){
			if(isShow){
				document.activeElement.blur();
				document.getElementById("protocolPopSuperParent").style.display = "block";				
				document.getElementById("protocolPopSuper").classList.add("mui-active");
			} else {
				document.getElementById("protocolPopSuperParent").style.display = "none";				
				document.getElementById("protocolPopSuper").classList.remove("mui-active");
			}
		},
		/**
		 * 选择系统环境
		 */
		onSelectEnv: function() {
			var buttons = [{id:'TEST', title:'测试环境(TEST)'}, {id:'SELF', title:'自定义环境(SELF)'}, {id:'STABLE', title:'稳定环境(STABLE)'}, {id:'PRE', title:'预发环境(PRE)'},
				{id:'GRAY', title:'灰度环境(GRAY)'}, {id:'PRO', title:'生产环境(PRO)'}];
			plus.nativeUI.actionSheet({
				title: "请选择",
				cancel: "取消",
				buttons: buttons
			}, function(e){
				if(e.index > 0){
					var nowEnv = buttons[e.index - 1].id;
					if(nowEnv === 'SELF'){
						plus.nativeUI.prompt("请输入自定义接口地址", function(e){
							if(e.index === 0 && !e.value){
								toast("请输入自定义接口地址");
								return;
							}
							if(e.index === 0){
								vueObj.nowEnv = nowEnv;
								setCache(USER_SELECT_API_EVN, vueObj.nowEnv);
								setCache(USER_SELECT_API_URL, "http://" + e.value);
								resetAllPagesHost();
							}
						}, "自定义环境", "例如：192.168.8.8:8090", ["确定", "取消"]);
						return;
					}
					vueObj.nowEnv = nowEnv;
					setCache(USER_SELECT_API_EVN, vueObj.nowEnv);
					resetAllPagesHost();
				}
			});
		}
	}
});
//返回键处理
mui.back = function() {
	//退出应用到后台
	var main = plus.android.runtimeMainActivity();
	main.moveTaskToBack(false);
};

//Android监听软键盘
var originalHeight = document.documentElement.clientHeight ||document.body.clientHeight;
window.onresize = function(){
    //键盘弹起与隐藏都会引起窗口的高度发生变化
	var resizeHeight=document.documentElement.clientHeight || document.body.clientHeight;
	if(resizeHeight-0 < originalHeight-0){
	     //当软键盘弹起，在此处操作
		vueObj.showThird = false;
	}else{
	 	//当软键盘收起，在此处操作
	 	vueObj.showThird = true;
	}
}

//vue初始化
var portocolObj = new Vue({
	el: '#protocolPopSuperParent',
	data: {},
	beforeMount: function(){},
	methods: {
		onButtonClick:function(e){
			switch (e.currentTarget.dataset.type){
				case 'close':
					vueObj.isOpenProtocolPop(false);
					break;
				case 'agree':
					//设置本页面UserAgent
					setLocalUserAgent();
					document.getElementById("protocolCkb").checked = true;
					setCache(LOGIN_PRIVATEP_ROTOCOL, true);
					plus.runtime.agreePrivacy();
					vueObj.isOpenProtocolPop(false);
					vueObj.initThirdLogin();
					//权限申请
					plus.push.getClientInfoAsync();
					if(plus.os.name == 'Android'){
						//plus.android.requestPermissions(["android.permission.WRITE_EXTERNAL_STORAGE", "android.permission.READ_EXTERNAL_STORAGE", "android.permission.READ_PHONE_STATE"]);
					}
					mui.fire(plus.webview.getLaunchWebview(), "onAgreePrivateProtocol", {});
					break;
				case "protocol":	//服务协议
					document.activeElement.blur();
					openWindow("privateProtocol", "../common/web_page.html", false, {
						webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderProtocol",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					});
					break;
				case "private": //隐私协议	
					document.activeElement.blur();
					openWindow("privateProtocol", "../common/web_page.html", false, {
						webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderPrivateInfo",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					});
					break;	
				default:
					break;
			}
		}
	}
});
//vue初始化
var vueCodeObj = new Vue({
	el: '#picCodeId',
	data: {imgData:null, code: null},
	methods: {
		onButtonClick:function(e){
			switch (e.currentTarget.dataset.type){
			case 'close': //关闭弹窗
				document.getElementById("picCodeId").style.display = "none";
				document.activeElement.blur();
				break;
			case 'refresh': //刷新验证码
				vueObj.onGetPicCode();
				break;
			case 'submit': //提交验证
				if(!vueCodeObj.code){
					toast("请输入验证码");
					return;
				}
				if(commonTrim(vueCodeObj.code).length < 4){
					toast("请输入合法的验证码");
					return;
				}
				vueObj.onGetCode(null, vueCodeObj.code);
				break;
			default:
				break;
			}
		}
	}
});