//请求码
var GET_CODE = 1001, GET_PUBLIC_KEY = 1002, DO_MODIFY = 1003;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		userPhone: '',
		checkCode: '',
		userPwd: '',
		userPwdEncrypt: '', // 加密后的 userPwd
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		sendCount: 1, //短信验证码发送次数
	},
	beforeMount: function(){
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//初始显示手机号
			vueObj.userPhone = getCache(USER_PHONE_KEY);
		});
	},
	beforeDestroy: function(){
		if(vueObj.timer) clearInterval(vueObj.timer);
	},
	methods: {
		/**
		 * 点击确定按钮
		 */
		onSure: function(){
			vueObj.checkCode = document.getElementById("checkCode").value;
			if(!vueObj.checkCode){
				toast("验证码不能为空");
				return;
			}
			vueObj.userPwd = document.getElementById("userPwd").value;
			//请输入8-20位密码
			if(!vueObj.userPwd || vueObj.userPwd.length < 8 || vueObj.userPwd.length > 20 ){
				toast("请输入8-20位新密码");
				return;
			}
			//判断是否为纯数字或纯字母
			if(!stringIsRightPwd(vueObj.userPwd)){
				toast("您设置的密码过于简单，请设置2种以上字符");
				return;
			}
			vueObj.userPwdEncrypt = hex_md5(vueObj.userPwd);
			document.activeElement.blur();
			//获取公钥
			showWaiting();
			webCall2("/app/login/getPublicKey", { mobilePhone: getCache(ACCOUNT_KEY) }, GET_PUBLIC_KEY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 执行修改
		 */
		doModify: function(publicKey) {
			//密码加密
			var encrypt = new JSEncrypt();
			encrypt.setPublicKey(publicKey.publicKey);
			var encrypedPwd = encrypt.encrypt(vueObj.userPwdEncrypt);
		    
			var params = {
				mobilePhone: getCache(ACCOUNT_KEY), 
				verificationCode: vueObj.checkCode,
				newPassword: encrypedPwd //vueObj.userPwdEncrypt //encrypedPwd
			};
			showWaiting();
			webCall2("/app/login/updateLoginPassword", params, DO_MODIFY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			showWaiting();
			webCall2("/app/message/sendUpdatePwdVerificationCode", {
				mobilePhone: getCache(ACCOUNT_KEY),
				sendCount: vueObj.sendCount
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case GET_PUBLIC_KEY: //获取加密公钥
				vueObj.doModify(data.data);
				break;
			case DO_MODIFY: //修改密码成功
				toast("密码修改成功");
				//返回前更改状态栏色调
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				//关闭当前页
				mui.back();			
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});