//请求码
var GET_CODE = 1001, DO_REGISTER = 1002, GET_PUBLIC_KEY = 1003;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		schoolCode: '',
		userPhone: '',
		checkCode: '',
		userPwd: '',
		userPwdEncrypt: '', // 加密后的 userPwd
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		sendCount: 1, //短信验证码发送次数
		invitationCode:null,//邀请码
		showProtocol: true,
	},
	beforeMount: function(){
		mui.plusReady(function(){
			setStatusBarDefault();
			//设置键盘弹出模式
			keyboardAdjustResize();
			//插件初始化
			iOSInitNativeJs();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.schoolCode = plus.webview.currentWebview().schoolCode;
		});
	},
	beforeDestroy: function(){
		if(vueObj.timer) clearInterval(vueObj.timer);
	},
	methods: {
		//获取验证码
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码");
				return;
			}
			showWaiting();
			webCall2("/compus/user/sendRegisterVerificationCode", {
				mobilePhone: vueObj.userPhone,
				sendCount: vueObj.sendCount
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 注册-密钥
		 */
		onRegister: function(){
			/*if(!vueObj.schoolCode){
				toast("请返回重新选择学校");
				return;
			}*/
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone){
				toast("手机号码不能为空");
				return;
			}
			if(!regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码");
				return;
			}
			vueObj.checkCode = document.getElementById("checkCode").value;
			if(!vueObj.checkCode){
				toast("验证码不能为空");
				return;
			}
			vueObj.userPwd = document.getElementById("userPwd").value;
			vueObj.userPwd = commonTrim(vueObj.userPwd);
			//请输入8-20位密码
			if(!vueObj.userPwd || vueObj.userPwd.length < 8 || vueObj.userPwd.length > 20){
				toast("请输入8-20位密码");
				return;
			}
			//判断是否为纯数字或纯字母
			if(!stringIsRightPwd(vueObj.userPwd)){
				toast("您设置的密码过于简单，请设置2种以上字符");
				return;
			}
			//注册协议
			if(!document.getElementById("protocolCkb").checked){
				toast("请勾选校帅用户服务协议");
				return;
			}
			document.activeElement.blur();
			vueObj.userPwdEncrypt = hex_md5(vueObj.userPwd);
			//获取公钥
			showWaiting();
			webCall2("/login/getPublicKey", { mobilePhone: vueObj.userPhone }, GET_PUBLIC_KEY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
		},
		/**
		 * 执行注册
		 */
		doRegister: function(publicKey){
			//判断邀请码是否为空
			if(!stringIsNull(document.getElementById("channelCode").value)){
				vueObj.invitationCode = document.getElementById("channelCode").value;
			} else {
				vueObj.invitationCode = "";
				document.getElementById("channelCode").value = "";
			}
			//密码加密
			var encrypt = new JSEncrypt();
			encrypt.setPublicKey(publicKey.publicKey);
			var encrypedPwd = encrypt.encrypt(vueObj.userPwdEncrypt);
			
		    showWaiting();  
		    var extParams = {
				urlPath: "/compus/user/register"
			};
			webCall2("/common/token/get", {
				//schoolCode: vueObj.schoolCode,
				mobilePhone: vueObj.userPhone,
				verificationCode: vueObj.checkCode,
				password: encrypedPwd, //vueObj.userPwdEncrypt //encrypedPwd
				clientId: getClientId(),
				osType: plus.os.name,
				osVersion: plus.os.version,
				mobileType: plus.device.model,
				invitationCode: vueObj.invitationCode,//邀请码
				osUuid: plus.device.uuid,
				oaid: getCache(DEVICE_OAID_KEY),
				appAllVersion: plus.runtime.version,
				appWgtVersion: getCache(WGT_VERSION_FLAG)
			}, DO_REGISTER, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, extParams);
		},
		//登录
		onLogin: function(){
			mui.back();
		},
		//注册服务协议
		onRegisterProtocol: function(){
			openWindow("privateProtocol", "../common/web_page.html", false, {
				webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderProtocol",
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		},
		//隐私政策
		onPrivateProtocol: function(){
			openWindow("privateProtocol", "../common/web_page.html", false, {
				webUrl: h5Host + "/activity/h5/common?activityCode=iOSPrivateInfo",
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		},
		//启动定时器并更新 smsCodeBtn 状态
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case GET_PUBLIC_KEY: //获取加密公钥
				setTimeout(function(){
					vueObj.doRegister(data.data);
				}, 200);
				break;
			case DO_REGISTER: //注册
				closeWebview("loginByCode");
				closeWebview("login");			
				//清空消息
				clearPushMessage();
				toast('注册成功');
				// 更新登录信息
				updateLoginInfo(vueObj.userPhone, data.data);
				//日志上报
				aliyunLoginDataPost("reg");
				if(getCache(SCHOOL_CODE_KEY)){ //已选学校，跳转到首页
					openWindow('main', '../main.html', false, {isCloseOpener:true,statusBarType:STATUS_BAR_DEFAULT_KEY}, null, true);
				}else{ //未选择学校，跳转到学校选择页
					openWindow('selectScholl', '../login/select_school.html', false, {
						invitationCode:vueObj.invitationCode,//渠道邀请码
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						from: 'login',
						isCloseOpener:true,
					});
				}			
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			closeWaiting();
			iOSGetUserNetState(resultCode, function(result){
				if(result){return;} 
				onError(resultCode, resultMsgDesc);
			});
		}
	}
});

//Android监听软键盘
var originalHeight = document.documentElement.clientHeight ||document.body.clientHeight;
window.onresize = function(){
    //键盘弹起与隐藏都会引起窗口的高度发生变化
	var resizeHeight=document.documentElement.clientHeight || document.body.clientHeight;
	if(resizeHeight-0 < originalHeight-0){
	     //当软键盘弹起，在此处操作
		vueObj.showProtocol = false;
	}else{
	 	//当软键盘收起，在此处操作
	 	vueObj.showProtocol = true;
	}
}

//常见问题
document.getElementById("questionBtn").addEventListener("tap", function(){
	openWindow("questionMain", "../center/question_main.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
});