var self = null;
var scan = null, bCancel = false;
//请求码
var QUERY_MEAL_LIST = 1001, QUERY_TAKE_MEAL = 1002, QUERY_CHECK_ORDER = 1003, QUERY_DELIVERED = 1004;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		orderDatas:[],//订单列表
		status: -1,//查询的订单状态 30待派单 40待取餐 50待分拣 60待核验 70待送达,
		takenMeal:0,//已取餐份数
		takeIndex:-1,//当前点击取餐的下标
		shopId:"",//店铺id
		lightMgr: null, //android光线传感器
		lightInterval: null,
		showLight: false, //是否显示开启闪光灯
		openFlash: false //是否开启闪光灯,默认不开启
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				vueObj.stopScan();
				vueObj.stopLight();
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					vueObj.stopScan();
					vueObj.stopLight();
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarBlack();
					vueObj.startScan();
					vueObj.startLight();
					setUpViewStatusBar(STATUS_BAR_DEFAULT_KEY);
				}
			}, false);
			//监听关闭事件
			window.addEventListener("onScanCloseListener", function(){
//				closeWebview(self.id);
			});
			//程序从后台进入前台的监听事件
			window.addEventListener("resume", function(){
				vueObj.startScan();
				vueObj.startLight();
			}, false);
			//程序从前台进入后台的监听事件
			window.addEventListener("pause", function(){
				vueObj.stopScan();
				vueObj.stopLight();
			}, false);
			//详情页取餐成功或分拣核验成功
			window.addEventListener("onOrderDataChange", function(event){
				if(vueObj.status==40){
					vueObj.loadTakeList();
				} else if((vueObj.status==60 ||  vueObj.status==80) && event.detail.value){
					vueObj.orderDatas.unshift(JSON.parse(event.detail.value));
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			// 获取窗口对象
			self = plus.webview.currentWebview();
			//参数
			vueObj.shopId = self.shopId;
			vueObj.status = self.status>= 0 ? self.status : -1;
			document.getElementById("title").innerText = vueObj.status==40?"扫码取餐":(vueObj.status==60?"扫码核验":(vueObj.status==80 ? "扫码送达":"扫一扫"));
			if(vueObj.status==60 || vueObj.status==80){
				document.getElementById("manualBtn").style.display = "block"; 
			}
			var user = getUserInfo();
			//相机权限判断
			if(!checkUserPermission("CAMERA", null, function(){
				vueObj.initScan();
			}, function(){
				mui.back();
			})){ return; }
			// 扫码初始化
			vueObj.initScan();
			vueObj.loadTakeList();
		});
	},
	methods: {
		/*
		 * 查询代取餐列表
		 */
		loadTakeList:function(){
			if(!vueObj.shopId || vueObj.status != 40) return;
			webCall2("/app/delivery/oms/order/scanTakeList", {
				offset:0,
				limit: 100,
				shopId: vueObj.shopId,
				deliveryDetailStatus: vueObj.status,
			}, QUERY_MEAL_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 订单处理
		 * status 3待派单 4待取餐 5待分拣 6待核验 7待送达 ,
		 */
		onOrderManager: function(orderNo){
			if(!vueObj.status || vueObj.status < 0 || !orderNo) return;
			switch (vueObj.status){
				case 40: //待取餐
					showWaiting();
					webCall2("/app/delivery/oms/order/takeMeal", {orderNo: orderNo}, QUERY_TAKE_MEAL, vueObj.onSuccess, vueObj.onErrorBefore);
					break;
				case 60:	//待核验
					showWaiting();
					webCall2("/app/delivery/oms/order/doCheckAndSorting", {orderNo: orderNo}, QUERY_CHECK_ORDER, vueObj.onSuccess, vueObj.onErrorBefore);
					break;
				case 80://待送达
					showWaiting();
					webCall2("/app/delivery/oms/order/beDeliveredIn", {orderNo: orderNo}, QUERY_DELIVERED, vueObj.onSuccess, vueObj.onErrorBefore);
					break;	
				default:
					setTimeout(function(){
						vueObj.startScan();
					}, 1000);
					break;
			}
		},
		/**
		 * 扫码初始化
		 */
		initScan: function() {
			setTimeout(function(){
				var scanMain = document.getElementById("scanMain");
				scanMain.removeAttribute("disabled");
				scan = new plus.barcode.Barcode('scanMain', [plus.barcode.QR, plus.barcode.CODE128, plus.barcode.EAN8, plus.barcode.EAN13], {
					frameColor: '#FF5959',
					scanbarColor: '#FF5959'
				});
				scan.onmarked = vueObj.onmarked;
				// 开始扫描
				vueObj.startScan();
			}, 200);
		},
		/**
		 * 开始扫描
		 */
		startScan: function() {
			if(!scan) return;
			scan.cancel();
			scan.start({sound:'default'});
		},
		/**
		 * 停止扫描
		 */
		stopScan: function() {
			if(!scan) return;
			scan.cancel();
		},
		/**
		 * 二维码扫描成功
		 */
		onmarked: function(type, result, file) {
			result = result.replace(/\n/g, '');
			result = result.replace(/^\"|\"$/g,'');
			result = result.replace(/^\'|\'$/g, '');
			outputLog("scaned('" + type + "','" + result + "','" + file + "');");
			if(!result){
				plus.nativeUI.alert("扫描失败，请重试", function(){
					vueObj.startScan();
				}, "", "确定");
				return;
			}
			if(result.indexOf("oms")==0 && vueObj.status && vueObj.status > 0){ //订单号
				vueObj.onOrderManager(result.substring(3));
				return;
			}
			plus.nativeUI.alert("码内容无法识别", function(){
				vueObj.startScan();
			}, "", "确定");
		},
		/**
		 * 从相册中选择二维码图片
		 */
		scanPicture: function() {
			plus.gallery.pick(function(path) {
				if(plus.os.name == "iOS"){
					plus.barcode.scan(path, vueObj.onmarked, function(error) {
						plus.nativeUI.alert('无法识别此图片');
					});
					return;
				}
				vueObj.compressImg(path, function(compressPath){
					plus.barcode.scan(compressPath, vueObj.onmarked, function(error) {
						plus.nativeUI.alert('无法识别此图片');
					});
				});
			}, function(err) {
				outputLog('Failed: ' + err.message);
			});
		},
		/**
		 * 切换开关
		 */
		scanSwitch: function() {
			if(bCancel) {
				vueObj.startScan();
				btCancel && (btCancel.innerText = '暂　停');
			} else {
				vueObj.stopScan();
				btCancel && (btCancel.innerText = '开　始');
			}
			bCancel = !bCancel;
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_MEAL_LIST: //获取取餐列表
				vueObj.orderDatas = data.rows;
				vueObj.takenMeal = 0;
				for(var i in vueObj.orderDatas){
					var item = vueObj.orderDatas[i];
					if(item.deliveryDetailStatus == 50){//已取餐
						vueObj.takenMeal++;
					}
				}
				break;
			case QUERY_TAKE_MEAL: //确认取餐
				toast("取餐成功");
				if(vueObj.takeIndex >= 0){
					var item = vueObj.orderDatas[vueObj.takeIndex];
					item.deliveryDetailStatus = 50;
					Vue.set(vueObj.orderDatas, vueObj.takeIndex, item);
					vueObj.takeIndex = -1;
				}
				vueObj.loadTakeList();
				setTimeout(function(){
					vueObj.startScan();
				}, 1000);
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});
				break;	
			case QUERY_CHECK_ORDER: //确认核验
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});
				toast("核验成功");
				setTimeout(function(){
					vueObj.startScan();
				}, 1000);;
				vueObj.orderDatas.unshift(data.data);
				break;	
			case QUERY_DELIVERED: //确认送达
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});
				toast("送达成功");
				setTimeout(function(){
					vueObj.startScan();
				}, 1000);
				vueObj.orderDatas.unshift(data.data);
				break;		
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			if(requestCode == QUERY_TAKE_MEAL){
				vueObj.takeIndex = -1;
			}
			closeWaiting();
			if(requestCode != QUERY_MEAL_LIST){
				plus.nativeUI.alert(resultMsgDesc?resultMsgDesc:'请求访问失败，请重试', function(){
					vueObj.startScan(); //重新开始扫描
				}, "", "确定");
				return;
			}
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "takeMeal": //确认取餐
				vueObj.takeIndex = e.currentTarget.dataset.index;
				vueObj.onOrderManager(vueObj.orderDatas[e.currentTarget.dataset.index].orderNo);
				break;	
			case "item": //订单点击
				if(!e.currentTarget.dataset.orderNo) return;
				openWindow("orderDetail", "../common/order_detail.html", false, {
					orderNo:e.currentTarget.dataset.orderNo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;	
			default:
				break;
			}
		},
		/**
		 * 开始检测灯光
		 */
		startLight: function() {
			if(vueObj.lightInterval) clearInterval(vueObj.lightInterval);
			if(vueObj.lightMgr == null) return;
			vueObj.lightInterval = setInterval(function(){
				var androidLux = vueObj.lightMgr.getLux();
				vueObj.showLight = androidLux < 10;
			}, 2000);
		},
		/**
		 * 停止检测灯光
		 */
		stopLight: function() {
			if(vueObj.lightInterval) clearInterval(vueObj.lightInterval);
			vueObj.lightInterval = null;
			if(vueObj.lightMgr != null) vueObj.lightMgr.stop();
		},
		/**
		 * 灯光切换
		 */
		changeLight: function() {
			vueObj.openFlash = !vueObj.openFlash;
			scan.setFlash(vueObj.openFlash);
		},
		/**
		 * 图片压缩
		 */
		compressImg: function(path, callBack){
			showWaiting();
			//不覆盖原图
			var newImgSrc = "_downloads/" + (+new Date()) + path.substr(path.lastIndexOf('.'));
			var conf = {
				src: path,
				dst: newImgSrc,
				quality: 70,
				width: 400
			};
			//iOS HEIC 转换成 png
			if(path.indexOf("HEIC") >= 0) {
				conf.dst = newImgSrc.replace("HEIC", "png");
				conf.format = "png";
				conf.overwrite = true;
			}
			plus.zip.compressImage(conf, function(data) {
				closeWaiting();
				outputLog("图片压缩结果: " + JSON.stringify(data))
				if(callBack) callBack(data.target);
			}, function(err) {
				closeWaiting();
				plus.nativeUI.alert('无法识别此图片');
			});
		}
	}
});
//闪光灯按钮监听
document.getElementById("lightBtn").addEventListener("tap", function(){
	vueObj.changeLight();
	if(vueObj.openFlash){
		document.getElementById("lightImg").src = "images/scan_light_open.png";
	} else {
		document.getElementById("lightImg").src = "images/scan_light_close.png";
	}
});
document.getElementById("manualBtn").addEventListener("tap", function(){
	openWindow("scanManual", "scan_manual.html", false, {
		status: vueObj.status,
		statusBarType: STATUS_BAR_DEFAULT_KEY
	});
});
