//请求码
var QUERY_CHECK_ORDER = 1001, QUERY_DELIVERED = 1002;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		status: -1,//查询的订单状态 30待派单 40待取餐 50待分拣 60待核验 70待送达,
		orderId: "",//订单id
		shopId: "",//店铺id
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setUpViewStatusBar(STATUS_BAR_DEFAULT_KEY);
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			// 获取窗口对象
			self = plus.webview.currentWebview();
			//参数
			vueObj.status = self.status>= 0 ? self.status : -1;
			document.getElementById("title").innerText = vueObj.status==60?"扫码核验":"扫码送达";
		});
	},
	methods: {
		/*
		 * 订单处理
		 * status 3待派单 4待取餐 5待分拣 6待核验 7待送达 ,
		 */
		onOrderManager: function(orderNo){
			if(!vueObj.status || vueObj.status < 0 || !orderNo) return;
			switch (vueObj.status){
				case 60:	//待核验
					showWaiting();
					webCall2("/app/delivery/oms/order/doCheckAndSorting", {orderNo: orderNo}, QUERY_CHECK_ORDER, vueObj.onSuccess, vueObj.onErrorBefore);
					break;
				case 80://待送达
					showWaiting();
					webCall2("/app/delivery/oms/order/beDeliveredIn", {orderNo: orderNo}, QUERY_DELIVERED, vueObj.onSuccess, vueObj.onErrorBefore);
					break;	
				default:
					break;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {	
			case QUERY_CHECK_ORDER: //确认核验
				toast("核验成功");
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});
				mui.fire(plus.webview.getWebviewById("scan"), "onOrderDataChange", {
					value: data.data ? JSON.stringify(data.data) : null
				});
				break;	
			case QUERY_DELIVERED: //确认送达
				toast("送达成功");
				mui.fire(plus.webview.getWebviewById("main"), "onOrderDataChange", {});
				mui.fire(plus.webview.getWebviewById("scan"), "onOrderDataChange", {
					value: data.data ? JSON.stringify(data.data) : null
				});
				break;		
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "submit": //提交
				var orderId = document.getElementById("orderInput").value;
				if(!orderId){
					toast("请填写订单编号");
					return;
				}
				vueObj.onOrderManager(orderId);
				break;
			default:
				break;
			}
		},
	}
});
