//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		currentVersion: '',//当前版本
		showNewVersion: '' //服务器版本
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//界面初始化
			vueObj.currentVersion = plus.runtime.version;
			//检测版本
			window.getAppVersion(function(versionData){
				if(versionData && versionData.version){
					var hasNewVersion = window.isHaveNewVersion(vueObj.currentVersion, versionData.version);
					if(hasNewVersion){
						vueObj.showNewVersion = "新版本(V" + versionData.version + ")";
					}
				}
			});
		});
	},
	methods: {
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case "introduce": //APP介绍
				openWindow("aboutIntroduce", "about_introduce.html", false);
				break;
			case "comment": //去评分
				vueObj.doComment();
				break;
			case "version": //版本更新
				vueObj.checkVersion();
				break;
			default:
				break;
			}
		},
		/**
		 * 去应用市场评分
		 */
		doComment: function() {
			if(plus.os.name == 'iOS') { //iOS的评分跳转
				plus.runtime.openURL("itms-apps://itunes.apple.com/cn/app/id1533201151?mt=8&action=write-review",
					function(e) {
						toast(e.message);
					}
				);
			} else { //Android的评分跳转
				var Intent = plus.android.importClass("android.content.Intent");
				var Uri = plus.android.importClass("android.net.Uri");
				var main = plus.android.runtimeMainActivity();
				var uri = Uri.parse("market://details?id=cn.com.yunma.school.app");
				var it = new Intent(Intent.ACTION_VIEW, uri);
				it.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				main.startActivity(it);
			}
		},
		/**
		 * 检测版本更新
		 */
		checkVersion: function() {
			window.getAppVersion(function(versionData){
				var isNewest = true;
				if(versionData && versionData.version){
					var hasNewVersion = window.isHaveNewVersion(vueObj.currentVersion, versionData.version);
					if(hasNewVersion){
						isNewest = false;
						plus.runtime.openURL(versionData.url);
					}
				}
				if(isNewest){
					toast('当前已是最新版本');
				}
			});
		}
	}
});
