//请求码
var GET_USER_ADDRESS = 1001, DO_SUBMIT = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		realName: "",//收货人姓名
		userPhone:"",//手机号
		areaCode:"",//地址编码
		areaName:"",//省-市-区
		address:"",//详细地址
		addressItem:null,
		addressId:null, //用户收货地址id
		defaultStatus:0//是否是默认地址 0默认1不默认
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			//设置键盘弹出模式
			keyboardAdjustResize();
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//监听地址选择返回
			window.addEventListener("onAddressSelect", function(event){
				vueObj.areaCode = event.detail.areaCode;
				vueObj.areaName = event.detail.provinceName + event.detail.cityName + event.detail.areaName;
			});
			vueObj.realName = getUserInfo().realUserName ? getUserInfo().realUserName : getUserInfo().userName;
			vueObj.userPhone = getCache(ACCOUNT_KEY);
			vueObj.addressItem = plus.webview.currentWebview().addressItem;
			vueObj.defaultStatus = plus.webview.currentWebview().defaultStatus ? 0 : 1; 
			if(vueObj.addressItem){
				vueObj.addressId = vueObj.addressItem.id;
				vueObj.realName = vueObj.addressItem.userName;
				vueObj.userPhone = vueObj.addressItem.mobile;
				vueObj.areaCode = vueObj.addressItem.areaCode;
				vueObj.areaName = vueObj.addressItem.areaName;
				vueObj.address = vueObj.addressItem.address;
				vueObj.defaultStatus = vueObj.addressItem.defaultStatus;
			}
		});
	},
	methods: {
		/**
		 * 选择城市
		 */
		onSelectCity: function(e) {
			document.activeElement.blur();
			vueObj.realName = document.getElementById("realName").value;
			vueObj.userPhone = document.getElementById("userPhone").value;
			vueObj.address = document.getElementById("address").value;
			openWindow("selectProvince", "../common/select_list.html", false, {
				webviewId:plus.webview.currentWebview().id,
				type: "province"
			});
		},
		/*
		 * 提交
		 */
		doSubmit: function(e) {
			document.activeElement.blur();
			vueObj.realName = document.getElementById("realName").value.trim();
			vueObj.userPhone = document.getElementById("userPhone").value.trim();
			vueObj.address = document.getElementById("address").value.trim();
			if(!vueObj.realName || vueObj.realName.length <= 0){
				toast("请输入姓名");
				return;
			}
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码");
				return;
			}
			if(!vueObj.areaCode || vueObj.areaCode.length <= 0){
				toast("请选择区域")
				return;
			}
			if(!vueObj.address || vueObj.address.length <= 0){
				toast("请输入详细地址")
				return;
			}
			var extParams = {
				urlPath: "/compus/user/shippingaddress/save"
			};
			var param = {
				userName:vueObj.realName,
				mobile: vueObj.userPhone,//联系方式
				areaName:vueObj.areaName, //省-市-区
				address: vueObj.address,//详细地址
				areaCode:vueObj.areaCode,
				defaultStatus: 0,
			}
			if(vueObj.defaultStatus == 1){
				//是否默认:0默认1不默认
				param.defaultStatus = document.getElementById("defaultSwitch").classList.contains('mui-active') ? 0 : 1;
			} 
			if(vueObj.addressId) {
				param.addressId = vueObj.addressId;
			}
			webCall2("/common/token/get", param, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, extParams);
		}, 
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case DO_SUBMIT: //提交收货地址
				//触发监听事件
				mui.fire(plus.webview.getWebviewById("receiptAddressList"),"onAddressChange", {});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/*
		 * 客服电话
		 */
		onService: function(e){
			document.activeElement.blur();
			plus.device.dial("400-100-9591", true);
		},
		/*
		 * 检测输入框是否输入表情 替换
		 */
		inputChange: function(e){
		   var reg = /[^\u0020-\u007E\u00A0-\u00BE\u2E80-\uA4CF\uF900-\uFAFF\uFE30-\uFE4F\uFF00-\uFFEF\u0080-\u009F\u2000-\u201f\u2026\u2022\u20ac\r\n]/g;
		   if(e.currentTarget.value.match(reg)) {
		      e.currentTarget.value = e.currentTarget.value.replace(reg, ''); 
		   }
   	 	},
	}
});