var DO_NEXT = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		userPhone: null, //用户手机号
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		checkCode: null, //验证码
		sendCount: 1, //短信验证码发送次数
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.userPhone = getCache(USER_PHONE_KEY);
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			vueObj.checkCode = document.getElementById("checkCode").value;
			if(!vueObj.checkCode){
				toast("请输入验证码");
				return;
			}
			showWaiting();
			document.activeElement.blur();
			webCall2("/app/login/updateMobilePhoneCheckVerificationCode", {
				verificationCode: vueObj.checkCode
			}, DO_NEXT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			showWaiting();
			document.activeElement.blur();
			webCall2("/app/message/sendChangeMobilePhoneVerificationCodeOne", {
				sendCount: vueObj.sendCount
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case DO_NEXT: //跳转到下一步
				openWindow("modifyPhoneSecond", "modify_phone_second.html", false, {
					checkCode: vueObj.checkCode,
					statusBarType: plus.webview.currentWebview().statusBarType
				}, null, true);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});