var DO_MODIFY = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		userPhone: null, //新手机号
		oldCheckCode: null, //老手机对应的验证码
		sendCount: 1, //短信验证码发送次数
	},
	beforeMount: function() {
		mui.plusReady(function(){
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.oldCheckCode = plus.webview.currentWebview().checkCode;
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			var checkCode = document.getElementById("checkCode").value;
			if(!checkCode){
				toast("请输入验证码");
				return;
			}
			showWaiting();
			document.activeElement.blur();
			webCall2("/app/login/updateMobilePhone", {
				newMobilePhone: vueObj.userPhone,
				oldVerificationCode: vueObj.oldCheckCode,
				newVerificationCode: checkCode
			}, DO_MODIFY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码");
				return;
			}
			showWaiting();
			document.activeElement.blur();
			webCall2("/app/message/sendChangeMobilePhoneVerificationCodeTwo", {
				newMobilePhone: vueObj.userPhone,
				oldVerificationCode: vueObj.oldCheckCode,
				sendCount: vueObj.sendCount
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case DO_MODIFY: //修改手机号成功
				toast("手机号修改成功");
				//更新本地手机号
				setCache(ACCOUNT_KEY, vueObj.userPhone);
				setCache(USER_PHONE_KEY, data.data);
				//通知手机变化
				mui.fire(plus.webview.getWebviewById("settingAccount"), "userPhoneChange", {});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "userPhoneChange", {});
				//设置状态栏颜色
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				//关闭页面
				closeWebview("modifyPhoneFirst");
				closeWebview("modifyPhoneSecond");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});