//请求码
var DO_LOGOUT = 1001, GET_USER_INFO = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		cacheSize: '', //缓存大小
		currentVersion: '', //当前版本
		hasNewVersion: false, //是否有新版本
		newVersionUrl: null, //新版本下载地址
		isNotifyEnable: false,
		notifyTxt: '',
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			window.addEventListener("onPwdSettingSuccess", function(event){
				showWaiting();
				//调用退出登录接口
				webCall2("/app/login/logout", {}, DO_LOGOUT, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			window.addEventListener("onResumeListener", function(event){
				vueObj.checkNotifyStatus();
			});
			//检测版本
			vueObj.currentVersion = plus.runtime.version;
			window.getAppVersion(function(versionData){
				if(versionData && versionData.version){
					vueObj.hasNewVersion = window.isHaveNewVersion(vueObj.currentVersion, versionData.version);
					if(vueObj.hasNewVersion){
						vueObj.currentVersion = versionData.version;
						vueObj.newVersionUrl = versionData.url;
					}
				}
			});
			//检测通知是否开启
			vueObj.checkNotifyStatus();
		});
	},
	methods: {
		/**
		 * 检测通知是否开启
		 */
		checkNotifyStatus: function(){
			vueObj.isNotifyEnable = isNotificationEnabled();
			if(vueObj.isNotifyEnable){
				vueObj.notifyTxt = "已开启";
			}else{
				vueObj.notifyTxt = "去开启";
			}
		},
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case "account": //账号与安全
				openWindow("settingAccount", "setting_account.html", false, null);
				break;
			case "protocol": //用户协议
				openWindow("privateProtocol", "../common/web_page.html", false, {
					webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderProtocol",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "private": //隐私政策
				openWindow("privateProtocol", "../common/web_page.html", false, {
					webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=riderPrivateInfo",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "about": //关于
				if(vueObj.hasNewVersion){
					plus.runtime.openURL(vueObj.newVersionUrl);
					return;
				}
				openWindow("about", "about.html", false, null); 
				break;
			case "clear": //清除缓存
				vueObj.clearLocalCache();
				break;
			case "loginout": //退出登录
				vueObj.doLogout();
				break;
			case "notify": //开启推送通知
				if(!vueObj.isNotifyEnable){
					setNotification();
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 登出接口
		 */
		doLogout: function(){
			confirmDialog('', '是否要退出当前账号？', '确认', '取消', function sureCallback(){
				showWaiting();
				//调用退出登录接口
				webCall2("/app/login/logout", {}, DO_LOGOUT, vueObj.onSuccess, vueObj.onErrorBefore);
			}, function cancelCallback(){
				
			});
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case DO_LOGOUT: //登出成功
				//跳转到登录页
				openWindow("loginByCode", "../login/login_by_code.html", true, {isLoginOut:3}, null, true);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			closeWaiting();
			if(data && data.statusCode == 213){ //未设置登录密码
				openWindow("settingPwd", "../setting/setting_pwd.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
				return; 
			}
			if(requestCode == DO_LOGOUT){
				//跳转到登录页
				openWindow("loginByCode", "../login/login_by_code.html", true, {isLoginOut:3}, null, true);
				return;
			}		
			onError(resultCode, resultMsgDesc);
		}, 
		/**
		 * 本地缓存清除
		 */
		clearLocalCache: function() {
			mui.confirm('是否要清理缓存？', '', ['取消', '确认'], function (e) {
				if(e.index != 1) return;
				showWaiting();
				clearLocalAllCache();
				clearCache(function(){
					closeWaiting();
					toast('缓存已清理');
					//点击清除就直接清0
					vueObj.cacheSize = '0B';
				});
			});
		}
	}
});
