//请求码
var GET_PUBLIC_KEY = 1001, DO_MODIFY = 1002;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		userPhone: null, //用户手机号
		userPwd: '',
		userPwdEncrypt: '', // 加密后的 userPwd
	},
	beforeMount: function(){
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			vueObj.userPhone = getCache(USER_PHONE_KEY);
		});
	},
	methods: {
		/**
		 * 点击确定按钮
		 */
		onSure: function(){
			vueObj.userPwd = document.getElementById("userPwd").value;
			vueObj.userPwd = commonTrim(vueObj.userPwd);
			//请输入8-20位密码
			if(!vueObj.userPwd || vueObj.userPwd.length < 8 || vueObj.userPwd.length > 20 ){
				toast("请输入8-20位密码");
				return;
			}
			//判断是否为纯数字或纯字母
			if(!stringIsRightPwd(vueObj.userPwd)){
				toast("您设置的密码过于简单，请设置2种以上字符");
				return;
			}
			vueObj.userPwdEncrypt = hex_md5(vueObj.userPwd);
			document.activeElement.blur();
			//获取公钥
			showWaiting();
			webCall2("/app/login/getPublicKey", null, GET_PUBLIC_KEY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 执行修改
		 */
		doModify: function(publicKey) {
			//密码加密
			var encrypt = new JSEncrypt();
			encrypt.setPublicKey(publicKey.publicKey);
			var encrypedPwd = encrypt.encrypt(vueObj.userPwdEncrypt);
			
			var params = {
				newPassword: encrypedPwd //vueObj.userPwdEncrypt //encrypedPwd
			};
			showWaiting();
			webCall2("/app/login/updateLoginPassword2", params, DO_MODIFY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case GET_PUBLIC_KEY: //获取加密公钥
				vueObj.doModify(data.data);
				break;
			case DO_MODIFY: //设置密码成功
				toast("密码设置成功");
				//通知设置页，执行退出操作
				mui.fire(plus.webview.currentWebview().opener(), "onPwdSettingSuccess", {});
				//返回前更改状态栏色调
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				//关闭当前页
				mui.back();			
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});