//请求码
var DO_APPLY = 1001, SUBMIT_PROTOCOL = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		realName: '',// 真实姓名
		bankNo: null, //银行卡号
		realBankNo: null,//银行卡号 去除空格后的
		bankId:'',//银行类别id
		bankName:'',//银行名称
		userPhone: null, //手机号码
		isProtocol: false,
		walletInfo: {},
		showProtocol: false,
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//银行卡切换
			window.addEventListener("onBankTypeChange", function(event){
				vueObj.bankId = event.detail.bankId;
				vueObj.bankName = event.detail.bankAbbName;
			});
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//钱包数据
			var walletInfoStr= getCache(WALLET_STATUS_INFO);
			if(walletInfoStr){
				vueObj.walletInfo = JSON.parse(walletInfoStr);
				vueObj.isProtocol = vueObj.walletInfo.signFlag === 0;
				vueObj.showProtocol = !vueObj.isProtocol;
			}
			//接收参数
			vueObj.realName = getCache(WALLET_STATUS_INFO) ? JSON.parse(getCache(WALLET_STATUS_INFO)).legalerName : "";
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case SUBMIT_PROTOCOL: //协议上送成功
				vueObj.walletInfo.signFlag = 0;
				mui.fire(plus.webview.getWebviewById("walletMain"), "onBankAddSuccess", {});
				break;
			case DO_APPLY: //绑卡申请 
				//checkType 鉴权方式，1-短信验证，2-小额鉴权 
				openWindow("bankAddSecond", "bank_add_second.html", false, {
					applyId:data.data.id,//绑卡申请记录的id
					userPhone: vueObj.userPhone,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				//第一次绑卡进去 状态会变成 认证中
				var walletInfo = JSON.parse(getCache(WALLET_STATUS_INFO));
				if(walletInfo.authenticateStatus === 0){
					mui.fire(plus.webview.getWebviewById("walletMain"), "onBankAddSuccess", {});
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);	
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			document.activeElement.blur();
			switch (e.currentTarget.dataset.type){
			case "camera": //相机点击
				vueObj.bankNo = document.getElementById("bankNo").value;
				vueObj.userPhone = document.getElementById("userPhone").value;
				//调用公共图片选择上传
				popCompressSelectPic({
					scene: "bankCard",
					isBankCard: true,
					maxWidth: 750,
					maxHeight: 477,
					isClip: true,
					callBack: function(isError, list){
						if(list == null || list.length < 1) return;
						//去除空格
						if(list[0].imgUrl && list[0].imgUrl.length > 0){
							vueObj.bankNo = list[0].imgUrl.replace(/\s|\xA0/g,"");
						}
						if(/\S{5}/.test(vueObj.bankNo)){
							vueObj.bankNo = vueObj.bankNo.replace(/\s/g, '').replace(/(.{4})/g, '$1 ');
						}
					}
				});
				break;
			case "support": //查看支持的银行列表
				vueObj.bankNo = document.getElementById("bankNo").value;
				vueObj.userPhone = document.getElementById("userPhone").value;
				openWindow("bankSupportList", "bank_support_list.html", false, {
					source: "bankAdd",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "protocol": //协议
				openWindow("protocol", "../common/web_page.html", false, {
					webUrl: e.currentTarget.dataset.url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "doNext": //下一步
				vueObj.bankNo = document.getElementById("bankNo").value;
				vueObj.realBankNo = vueObj.bankNo.replace(/\s|\xA0/g,"");
				vueObj.userPhone = document.getElementById("userPhone").value;
				if(!vueObj.realBankNo || !regexBankCardNo(vueObj.realBankNo)){
					toast("请输入正确的银行卡号");
					return;
				}
				if(!vueObj.bankId){
					toast("请选择开户银行");
					return;
				}
				if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
					toast("请输入正确的手机号码");
					return;
				}
				if(!vueObj.isProtocol){
					toast("请阅读并勾选协议");
					return;
				}
				showWaiting();
				webCall2("/routestl/route/stl/account/bindingApply", {
					accountId:getCache(WALLET_ACCOUNT_ID),
					bankCardNo: vueObj.realBankNo,//卡号
					bankMobileNo: vueObj.userPhone,//手机号
					bankId: vueObj.bankId,//银行类别id
				}, DO_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
				break;	
			default:
				break;
			}
		},
		/**
		 * 银行卡卡号输入监听
		 */
		onCardInput: function(e) {
			var value = e.currentTarget.value;
			if(/\S{5}/.test(value)){
				value = value.replace(/\s/g, '').replace(/(.{4})/g, '$1 ');
			}
			e.currentTarget.value = value;
		},
		/**
		 * 监听协议变化
		 */
		onProtocolChange: function(e) {
			vueObj.isProtocol = e.currentTarget.checked;
			//上送协议
			if(vueObj.isProtocol && vueObj.walletInfo.signFlag !== 0){
				webCall2("/routestl/route/stl/account/addSignAgreement", {
					accountId: getCache(WALLET_ACCOUNT_ID),
					signChannel: 1
				}, SUBMIT_PROTOCOL, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		}
	}
});