var DO_BIND = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		userPhone: '', //手机号码
		applyId:null, //申请记录id
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		smsScoded:"",//验证码
	},
	beforeMount: function() {
		mui.plusReady(function(){
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.applyId = plus.webview.currentWebview().applyId;
			vueObj.userPhone = plus.webview.currentWebview().userPhone;
			vueObj.userPhone = vueObj.userPhone ? vueObj.userPhone.replace(/^(\d{3})\d{4}(\d+)/,"$1****$2") : '';
			//银行卡列表进来 用户手动触发发送验证码
			if(!vueObj.userPhone) return;
			//倒计时 上个页面接口 已经发送验证码了
			vueObj.setTimeCount();
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.smsScoded || vueObj.smsScoded.length <= 0){
				toast("请输入验证码");
				return;
			}
			showWaiting();
			document.activeElement.blur();
			webCall2("/routestl/route/stl/account/applyVerify", {
				accountId:getCache(WALLET_ACCOUNT_ID),
				applyValue: vueObj.smsScoded,
				applyId: vueObj.applyId,
			}, DO_BIND, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在120s计时
			showWaiting();
			webCall2("/routestl/route/stl/account/scodesend", { 
				accountId:getCache(WALLET_ACCOUNT_ID),
				applyId:vueObj.applyId
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 120;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{ 
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_CODE: //获取验证码
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case DO_BIND: //绑卡验证
				openWindow("walletResult", "wallet_result.html", false, {
					source:'bankAdd',
					statusBarType: plus.webview.currentWebview().statusBarType,
					isCloseOpener:true,
				});
				mui.fire(plus.webview.getWebviewById("walletMain"), "onBankAddSuccess", {});
				mui.fire(plus.webview.getWebviewById("walletBankList"), "onBankAddSuccess", {});
				mui.fire(plus.webview.getWebviewById("walletWithdraw"), "onBankAddSuccess", {});
				closeWebview("bankAddFirst");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);	
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
			vueObj.smsScoded = value;
		},
	}
});