//请求码
var QUERY_SUPPORT_BANK = 1001;
var searchTime = null;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		originalBankRows:[],//原数据列表
		bankRows:[],//搜索展示列表数据
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			vueObj.handleScrollTop();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.querySupportBank();
		}); 
	},
	methods: {
		/*
		 * 查询支持的银行卡列表
		 */
		querySupportBank: function(){
			showWaiting();
			webCall2("/routestl/route/stl/bank/list", {accountId:getCache(WALLET_ACCOUNT_ID)}, QUERY_SUPPORT_BANK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case QUERY_SUPPORT_BANK: 
				vueObj.bankRows = data.rows;
				vueObj.originalBankRows = data.rows;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "item": //选择银行卡
				if(plus.webview.currentWebview().source != "bankAdd") return;
				mui.fire(plus.webview.getWebviewById("bankAddFirst"), "onBankTypeChange", {
					bankAbbName: e.currentTarget.dataset.name,
					bankId: e.currentTarget.dataset.bankId,
				});
				mui.back()
				break;
			default:
				break;
			}
		},
		/*
		 * 滑动位置计算
		 */
		handleScrollTop: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {immersed = parseFloat(ms[2]);}
			if(!immersed) {return;}
			document.getElementById("scrollWrapper").style.top = 44 + immersed + 54 + 'px';
		},
		/*
		 * 搜索框未空时 重置数据
		 */
		onSearchInput: function(e){
			if(searchTime)  {clearTimeout(searchTime);searchTime = null;}
			searchTime = setTimeout(function(){
				var searchContent = document.getElementById("searchInput").value;
				if(!searchContent || searchContent.length <= 0){
					vueObj.bankRows = vueObj.originalBankRows;
				}
			}, 500);
		},
		
	}
});
mui('.mui-input-row').on('tap', '.mui-icon-clear', function() {
	vueObj.bankRows = vueObj.originalBankRows; 
}, false);
//弹窗禁止滑动
document.addEventListener("touchmove", function(e){
	document.activeElement.blur();
});
/*
 * 搜索
 */
function onSearch() {
	document.getElementById("searchInput").blur();
	var searchContent = document.getElementById("searchInput").value;
	if(!searchContent || searchContent.length <= 0) {
		toast("请输入内容");
		return;
	}
	mui('.mui-scroll-wrapper').scroll().scrollTo(0, 0, 0);
	var tempBankRows = [];
	vueObj.originalBankRows.forEach(function(item) {
		if(item.bankAbbName.indexOf(searchContent) >= 0) {
			tempBankRows.push(item);
		}
	});
	vueObj.bankRows = tempBankRows;
}