var QUERY_LIST = 1001, SET_DEFAULT_BANK = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		bankData:[],//银行卡数据列表
		deleteIndex:null, //解绑的下标
		maxBindCount:0,//最大绑卡数
		source:'',//来源
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听银行卡添加成功
			window.addEventListener("onBankAddSuccess", function(event){
				vueObj.loadBankList(); 
			});
			//监听银行卡解绑成功
			window.addEventListener("onBankDeleteSuccess", function(event){
				vueObj.bankData.splice(vueObj.deleteIndex, 1);
			});
			//滚动初始化 
			mui('.mui-scroll-wrapper').scroll();
			vueObj.bankData = plus.webview.currentWebview().bankData ? plus.webview.currentWebview().bankData : [];
			vueObj.source = plus.webview.currentWebview().source;
			if(getCache(WALLET_STATUS_INFO)){
				vueObj.maxBindCount = JSON.parse(getCache(WALLET_STATUS_INFO)).maxBindCount;
			}
			if(vueObj.bankData && vueObj.bankData.length > 0) return;
			vueObj.loadBankList();
		});
	},
	methods: {
		/*
		 * 银行卡列表查询
		 */
		loadBankList: function(){
			showWaiting();
			webCall2("/routestl/route/stl/account/queryBindingList", {accountId:getCache(WALLET_ACCOUNT_ID)}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: //银行卡列表
				vueObj.bankData = data.rows; 
				break;	
			case SET_DEFAULT_BANK: //设置默认银行卡
				vueObj.loadBankList();
				toast("设置成功");
				break;	
			default:
				break;
			}
		}, 
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case "item": //银行卡点击
				var index = e.currentTarget.dataset.index;
				var item = vueObj.bankData[index];
				//提现银行卡选择
				if(vueObj.source == "walletWithdraw"){
					//触发监听的自定义事件
					var opener = plus.webview.currentWebview().opener();
					if(opener){
						mui.fire(opener, "onBankSelectBack", {
							selectBank: item
						}); 
					}
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
					//关闭页面
					mui.back();
					return; 
				}
				if(item.status ==1){//绑定中
					openWindow("bankAddSecond", "bank_add_second.html", false, {
						applyId:item.id,//绑卡申请记录的id
						statusBarType: plus.webview.currentWebview().statusBarType
					});
					return;
				}
				vueObj.deleteIndex = index;
				openWindow("walletBankDetail", "wallet_bank_detail.html", false, {
					bankAbbName: item.bankAbbName, 
					bankNo: item.cardNo, 
					bankId: item.id, 
					isDefault:item.defaultFlag==0 ? true : false,
					isLastBank:vueObj.bankData.length <= 1 ? true : false,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}); 
				break;
			case "set": //设置为默认银行卡
				var item = vueObj.bankData[e.currentTarget.dataset.index];
				if(item.defaultFlag==0) return;
				showWaiting();
				webCall2("/routestl/route/stl/account/settingDefaultCard", {accountId:getCache(WALLET_ACCOUNT_ID),bindId:item.id}, SET_DEFAULT_BANK, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			case "add": //添加银行卡
				openWindow("bankAddFirst", "bank_add_first.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "support": //查看支持的银行列表
				openWindow("bankSupportList", "bank_support_list.html", false, {
					eacctType: vueObj.eacctType,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			default:
				break;
			}
		},
	}
});