/** 网络请求码 */
var QUERY_WALLET_STATUS = 1001;
var myScroll;
var vueObj = new Vue({
	el: '#main',
	data: {
		openStatus:0,//店铺开通状态 0-未开户，1-开户中，2-已开户
		authenticateStatus:-1,//钱包认证状态 0-未认证，1-认证中，2-已认证
		balance:0,//钱包余额
		walletInfo:{},//钱包状态
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//监听账户信息变化
			window.addEventListener("onBankAddSuccess", function(){
				vueObj.pulldownRefresh();
			});
			//监听账户余额变化
			window.addEventListener("onWalletReaminChange", function(){
				vueObj.pulldownRefresh();
			});
			if(getCache(WALLET_STATUS_INFO)){
				vueObj.walletInfo = JSON.parse(getCache(WALLET_STATUS_INFO));
				vueObj.openStatus = vueObj.walletInfo.openStatus;
				vueObj.authenticateStatus = vueObj.walletInfo.authenticateStatus;
				vueObj.balance = vueObj.walletInfo.withdrawAmount&&vueObj.walletInfo.withdrawAmount>0 ? centToYuan(vueObj.walletInfo.withdrawAmount):0;
			}
			//查询账户信息
			vueObj.pulldownRefresh();
		}); 
	},
	methods: {
		/** 
		 * 下拉刷新 具体业务实现
		 */
		pulldownRefresh: function() {
			webCall2("/routestl/route/stl/account/queryAccount", {
				accountId:getCache(WALLET_ACCOUNT_ID)
			}, QUERY_WALLET_STATUS, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			vueObj.closePullStatus();
			closeWaiting();
			switch(requestCode) {
			case QUERY_WALLET_STATUS://钱包查询
				setCache(WALLET_STATUS_INFO, JSON.stringify(data.data));
				if(data.data.id){
					setCache(WALLET_ACCOUNT_ID, data.data.id);
				}
				vueObj.walletInfo = data.data;
				vueObj.openStatus = vueObj.walletInfo.openStatus;
				vueObj.authenticateStatus = vueObj.walletInfo.authenticateStatus;
				vueObj.balance = vueObj.walletInfo.withdrawAmount && vueObj.walletInfo.withdrawAmount>0 ? centToYuan(vueObj.walletInfo.withdrawAmount):0;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			vueObj.closePullStatus();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			//刷新列表
			Vue.nextTick(function(){
				setTimeout(function(){
					myScroll.refresh();
				}, 200); 
			}); 
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			var type = e.currentTarget.dataset.type;
			//钱包认证中
			if(vueObj.authenticateStatus == 1 && type!="remainDetail"){
				type = "bank";
			}
			//钱包未认证 跳转绑卡页面
			if(vueObj.authenticateStatus == 0 && type!="remainDetail"){
				openWindow("bankAddFirst", "bank_add_first.html", false, {
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				return;
			}
			switch (type){
			case "withdraw": //提现
				openWindow("walletWithdraw", "wallet_withdraw.html", false, {
					balance: vueObj.balance,
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				break;
			case "remainDetail": //余额明细
				openWindow("walletRemainList", "wallet_remain_list.html", false, {
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				break;
			case "bank": //银行卡列表
				openWindow("walletBankList", "wallet_bank_list.html", false, {
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				break;			
			default:
				break;
			}
		},
	}
});
/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.pulldownRefresh();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	}); 
})(mui);