var myScroll, isLoadingMore, isNoMore, start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],//明细数据
		timeMode:1, // 1月份  2日期区间
		dateMonth: null, //查询月份时间，例如:2018-0
		applyTimeStart: null, //查询开始时间，例如:2018-01-01
		applyTimeEnd: null, //查询结束时间，例如:2018-01-01
		amountStart:'',// 金额区间
		amountEnd:'',// 金额区间
		categoryShow:false,//
		billType:0,//查询类型 0全部 1收入 2支出
		tempBillType:0,//临时查询类型 0全部 1收入 2支出
		isSelectCondition:false,//是否选择了筛选条件
	}, 
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听时间变化
			window.addEventListener("onDateUpdate", function(event){
				vueObj.timeMode = event.detail.mode;
				if(event.detail.mode == 2){
					vueObj.applyTimeStart = event.detail.startTime;
					vueObj.applyTimeEnd = event.detail.endTime;
				} else {
					vueObj.dateMonth = event.detail.monthTime;
				}
				showWaiting();
				myScroll.scrollTo(0, -67, 0);
				start = 0;
				vueObj.loadData();
			});
			mui('.mui-scroll-wrapper').scroll();
			vueObj.handleMenuTop();
			//加载数据
			vueObj.loadData();
		}); 
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			var params = {
				"offset": start,
				"limit": 10,
				accountId:getCache(WALLET_ACCOUNT_ID)
			}
			if(vueObj.billType > 0){
				params.billType = vueObj.billType;
			}
			//时间区间
			if(vueObj.timeMode == 2 && vueObj.applyTimeStart){
				params.searchDateType =  vueObj.timeMode;
				params.createTimeStart = vueObj.applyTimeStart;
				params.createTimeEnd = vueObj.applyTimeEnd ? vueObj.applyTimeEnd : vueObj.applyTimeStart;
			} else if(vueObj.timeMode == 1 && vueObj.dateMonth){
				params.searchDateType = vueObj.timeMode;
				params.dateMonth = vueObj.dateMonth;
			}
			//金额区间
			params.tranMoneyStart = vueObj.amountStart.length > 0 ? yuanToCent(vueObj.amountStart) : (vueObj.amountEnd.length > 0 ? 0 : '');
			params.tranMoneyEnd = vueObj.amountEnd.length > 0 ?  yuanToCent(vueObj.amountEnd) : (vueObj.amountStart.length > 0 ? 1000000000000 : '');
			webCall2("/routestl/route/stl/account/queryBillList",params, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){ 
			case QUERY_LIST:
				vueObj.datas = (start == 0 ? data.data.billDetails : vueObj.datas.concat(data.data.billDetails));
				start = vueObj.datas.length;
				setNoDataBackground(vueObj.datas.length === 0);
				document.getElementById("item0mobileSpan").style.display = vueObj.datas.length < 4 ? "none" : "";
				closePullStatus(data.data.billDetails);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/*
		 * 点击事件
		 */
		onButtonClick: function(e){
			if(e.currentTarget.dataset.type){
				document.activeElement.blur();
			}
			switch (e.currentTarget.dataset.type){
				case 'category'://筛选点击
					if(!vueObj.categoryShow){
						//赋值
						vueObj.tempBillType = vueObj.billType;
					}
					vueObj.onShowCategoryPop(!vueObj.categoryShow);
					break;
				case 'time':
					openWindow("selectDate", "../common/select_date.html", false, {
						mode: vueObj.timeMode,
						monthTime: vueObj.dateMonth,
						startTime: vueObj.applyTimeStart,
						endTime: vueObj.applyTimeEnd,
						headerColor:'#FFFFFF',
						statusBarType: STATUS_BAR_DEFAULT_KEY
					});
					vueObj.onShowCategoryPop(false);
					break;	
				case 'close': //关闭弹框
					vueObj.onShowCategoryPop(false);
					break;	
				case 'reset': //重置按钮
					vueObj.tempBillType = 0;
					document.getElementById('amountStartInput').value = '';
					document.getElementById('amountEndInput').value = '';
					break;
				case 'confirm'://确定按钮
					vueObj.amountStart = document.getElementById('amountStartInput').value.length > 0 ? document.getElementById('amountStartInput').value : '';
					vueObj.amountEnd = document.getElementById('amountEndInput').value.length > 0 ? document.getElementById('amountEndInput').value : '';
					if(vueObj.amountStart.length > 0 && vueObj.amountEnd.length > 0 && parseFloat(vueObj.amountStart) > parseFloat(vueObj.amountEnd)){
						vueObj.amountStart = document.getElementById('amountEndInput').value;
						vueObj.amountEnd = document.getElementById('amountStartInput').value;
					}
					vueObj.billType = vueObj.tempBillType;
					if(vueObj.billType > 0 || vueObj.amountStart.length > 0 || vueObj.amountEnd.length > 0){
						vueObj.isSelectCondition = true;
					} else {
						vueObj.isSelectCondition = false;
					}
					showWaiting();
					myScroll.scrollTo(0, -67, 0);
					start = 0;
					vueObj.loadData();
					vueObj.onShowCategoryPop(false);
					break;	
				case 'billType': //类型点击
					//当前按钮是已点击状态 
					if(e.currentTarget.classList.contains('active')) return;
					vueObj.tempBillType = e.currentTarget.dataset.billType;
					break;
				case 'item': //列表点击
					openWindow("walletBillDetail", "wallet_bill_detail.html", false, {
						billId: e.currentTarget.dataset.billId,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					});
					break;	
				default:
					break;
			}	
		},
		/*
		 * 是否显示类型pop
		 */
		onShowCategoryPop:function(isShow){
			vueObj.categoryShow = isShow;
			if(isShow){
				document.getElementById("activationPopSuperParent").style.display = "block";
				document.getElementById("activationPopSuper").classList.add("mui-active");
			} else {
				document.getElementById("activationPopSuperParent").style.display = "none";
				document.getElementById("activationPopSuper").classList.remove("mui-active");
			}
		},
		/*
		 * 清空某个div下的选择按钮
		 */
		onClearSelectBtn:function(id){
			var ele = document.getElementById(id);
			if(!ele) return;
			var btnArray = ele.getElementsByClassName('active');
			for(var i = btnArray.length; i > 0; i--) {
				var item = btnArray[i - 1];
				item.classList.remove('active');
			}
		},
		/*
		 * 菜单弹框位置计算
		 */
		handleMenuTop: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {immersed = parseFloat(ms[2]);}
			if(!immersed) {return;}
			document.getElementById("scrollPop").style.paddingTop = immersed + 100 + 'px';
		},
		/**
		 * 输入金额监听
		 */
		onMoneyInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull($('#scrollerList'), pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		document.getElementById("item0mobileSpan").innerHTML = data.length < 10 ? "没有更多数据了" : "正在加载...";
		isNoMore = data.length < 10;
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	}); 
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
	}
	document.getElementById("main").style.backgroundImage = isNoData ? "url(../../img/no_content_bg.png)" : "none";
	document.getElementById("item0mobileSpan").style.display = isNoData ? "none" : "";
}