//请求码
var DO_WITHDRAW = 1001, QUERY_DEFAULT_BANK = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		balance: '',//钱包可用余额
		bankRows:[], //银行卡列表
		bankItme:{},//
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听添加银行卡
			window.addEventListener("onBankAddSuccess", function(event){
				//查询默认银行卡
				webCall2("/routestl/route/stl/account/queryBindingList", {accountId:getCache(WALLET_ACCOUNT_ID)}, QUERY_DEFAULT_BANK, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//监听银行卡选择  
			window.addEventListener("onBankSelectBack", function(event){
				vueObj.bankItme = event.detail.selectBank; 
			});
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.balance = plus.webview.currentWebview().balance;
			//查询银行卡列表
			showWaiting(); 
			webCall2("/routestl/route/stl/account/queryBindingList", {accountId:getCache(WALLET_ACCOUNT_ID)}, QUERY_DEFAULT_BANK, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 提现
		 */
		doNext: function(e) { 
			if(!vueObj.balance || vueObj.balance == 0){
				toast("暂无可用余额");
				return;
			}
			var withdrawMoney = document.getElementById("withdrawMoney").value;
			if(!withdrawMoney){
				toast("请输入提现金额");
				return;
			}
			if (withdrawMoney <= 0) {
				toast("提现金额不得小于0")
				return; 
			}
			if(parseFloat(vueObj.balance) < parseFloat(withdrawMoney)){
				toast("超过可提现金额，请修改");
				return;
			}
			document.activeElement.blur();
			showWaiting();
			webCall2("/routestl/route/stl/account/withdraw", {
				optUserId: getCache(USER_ID_KEY),
				optUserName: getCache(REAL_NAME_KEY),
				optMobileNo: getCache(ACCOUNT_KEY),
				accountId:getCache(WALLET_ACCOUNT_ID),
				bindingId: vueObj.bankItme.id,
				amount: yuanToCent(withdrawMoney)
			}, DO_WITHDRAW, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DEFAULT_BANK: //查询银行卡列表
				if(!data.rows || data.rows.length <= 0) return;
				//只有第一次查询银行卡列表 才进行赋值
				if(!vueObj.bankRows || vueObj.bankRows.length <= 0){
					vueObj.bankItme = data.rows[0];
					for(var i in data.rows) {
						if(data.rows[i].defaultFlag == 0){
							vueObj.bankItme = data.rows[i];
							break;
						}
					}
				}
				vueObj.bankRows = data.rows;
				break;
			case DO_WITHDRAW: //提现申请
				//status 0-未提交，1-申请中，2-受理成功，3-提现成功，4-提现失败
				if( data.data.status == 4){
					toast(data.data.msg ? data.data.msg: "提现失败, 请重试");
					return;
				}
				//跳转到成功页
				openWindow("walletResult", "wallet_result.html", false, {
					source: "withdraw",
					withdrawStatus: data.data.status,
					statusBarType:plus.webview.currentWebview().statusBarType,
					isCloseOpener:true,
				});
				mui.fire(plus.webview.getWebviewById("walletMain"), "onWalletReaminChange", {});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			document.activeElement.blur();
			switch (e.currentTarget.dataset.type){
			case "bank": //选择提现银行卡
				openWindow("walletBankList", "wallet_bank_list.html", false, {
					"bankData":vueObj.bankRows,
					"source": 'walletWithdraw',
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case "all": //点击全部提取
				if(!vueObj.balance || vueObj.balance == 0){
					toast("暂无可用余额");
					return;
				}
				//先显示出来, 点提现 再进行下一步
				document.getElementById("withdrawMoney").value = vueObj.balance;
				break;	
			case "withdraw"://提现点击
				vueObj.doNext();
				break;
			default:
				break;
			}
		},
		/**
		 * 输入金额监听
		 */
		onMoneyInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9.]/g, '');	
			e.currentTarget.value = value;
			//控制输入两位小数
			value = value + '';
			var values = value.split('.');
			//控制整数位位数
			if(values[0].length > 10) {
				values[0] = values[0].substring(0, 10);
			}
			if(values.length > 1) {
				if(values[1].length > 2) {
					value = values[0] + '.' + values[1].substring(0, 2);
				} else {
					value = values[0] + '.' + values[1];
				}
			} else {
				value = values[0];
			}
			if(values.length > 1 && (values[0].length <= 0 || values[0] == "")) {
				value = "0.";
			}
			e.currentTarget.value = value;
		},
	}
});